# v 1.2.2  2022-02-25  [stable]

This is a maintenance release with major bug fixes.

There were several shortcomings with bandwidth management: capping was not
performed correctly and could overuse uploading bandwidth. Also when the DHT
is turned off or on, we need to recompute proper bandwidth stealing.

Corruption of the DHT disk databases could also lead to a crash.

There was a critical old bug in the Dynamic Querying layer that affected
Ultrapeers mostly: we could corrupt memory and/or crash when the current node
was removed and we were processing a Dynamic Query for that node.  This is
more likely to happen when running as an Ultrapeer but it could also affect
nodes running as leaves, although the probability of that bug happening is
much less in that case.

Finally, it is best to not iterate on a global list that could get changed
due to a node removal.  This was the case when sending pongs to neighbouring
nodes, so we now take a private copy.

Improvements:
- Extended "props" shell command with -e (exact) and -i (ignore missing).
- The "props" command now takes a set of properties, handled as one batch.

Bug Fixes:
- Properly recompute bandwidth stealing on DHT changes.
- Avoid crashing in D-Bus lib when filename is improperly UTF-8 encoded.
- DHT: protect against corrupted database.
- bw_available(): fix invalid logic for I/O source capping.
- pong_all_neighbours_but_one(): iterate on local list.
- dq_node_removed(): must free dq object asynchronously.

Under the Hood:
- Update IRC network information: moved from freenode to libera.chat
- Chunk size limiting for uploads accounts for bandwidth.
- Reduce memory footprint for statx_t if no data kept.
- CQ: defer freeing of dispatched event.
- watchdog: be more verbose within critical messages.
- node_parse(): signal to callers when we have BYE-ed the node.
- cq_event_called(): use better diagnostic on assert failure.
- dbus_util_send_message(): protect against invalid text.
- prepare_entry(): ensure entry invariant remains true.
- wd_expire(): do nothing if watchdog was asleep.

# v 1.2.1  2021-07-12  [stable]

This is a maintenance release with minor bug fixes.

Note that our project IRC #gtk-gnutella channel is now on irc.libera.chat.

When launching gtk-gnutella and there is a stale lockfile present, listing
some PID, and it happens that there is already another process running
under this PID, we abort, complaining that another gtk-gnutella is running.
However, if the lockfile is really stale, and the PID listed in there has
nothing to do with gtk-gnutella at the moment, the user will need to remove
the stale lockfile.  Hence we show them the command to run, listing the
full lockfile path so that it is easy to overcome this little inconvenience!

When using hashtables for memory management, it was possible to trigger a
resizing and, during the course of operations, have further memory used,
requiring tracking of new items in the same hashtable we were in the
process of resizing.  That led to double VMM freeing of the region used
to store the data.

Add properties to track bytes exchanged by schedulers.  These properties
track the amount of bytes exchanged by session and are reset to 0 whenever
a new user session starts.  It allows users to see the actual amount of
data consumed by running gtk-gnutella sessions, programmatically via the
shell interface.

Add -t switch to shell "status" command: this displays the total amount
of bandwidth consumed during the session for the different schedulers.

Improvements:
- Show command to clean stale lockfile.
- Add properties to track bytes exchanged by schedulers.
- Add -t switch to shell "status" command.
- Make use of libera.chat instead of freenode.
- Expiration time now increased from 1 to 2 years.
- New --no-expire switch to disable GUI popup when expired.

Bug Fixes:
- pattern_prefix_period(): don't corrupt end-of-block.
- Fix subtle recursive resizing bug.
- Do not emit empty leading description in saved properties.
- For time sync over UDP, write replying time later!
- hash_table_resize(): clear last cached lookup!
- ev_link(): insert events in the proper bucket!

Under the Hood:
- Updated GeoIP databases.
- Ad bit_generic_count_set().
- Add plural_child().
- Add progstart_was_called().
- Add H_STRFREEV_NULL().
- Add syn=c to *.ht and *.ct files for vim.
- Add hash_table_copy_foreach().
- Add tm_precise_elapsed_ns() convenience routine.
- Add thread_stack_size() to get configured stack size.
- Add pattern_string() to get the string being looked for.
- Add str_2c_from() to grab C string from a given offset.
- Add eval_subst_atom().
- Add stacktrace_caller_fast() and stack-test program.
- Add thread_{un}suspend().
- Add tmalloc_contains() for assertions.
- Add public VMM validate/invalidate routines.
- Add macros to ease printing for tmval and tmspec.
- Add node_check() to node traversal loops.
- Avoid branches in SIGN() as well.
- Avoid regeneration of Geo DB if no data changes.
- Bump python dependency for jhbuild on OSX.
- Better clock skew computation.
- Handle time-sync exchanges via UDP better.
- Make use of travis cache feature for OSX builds.
- Only include <sys/sysctl.h> if we actually need it.
- Allow compilation with usemymalloc=n on 32-bit CPUs.
- Let mem_test() run only once.
- When no backtrace(), ensure we compile with a frame pointer.
- Compile with -DTRACK_MALLOC -DREMAP_ZALLOC again.
- Made -DTRACK_ZALLOC usable again.
- Do not check stack at longjmp() if on altstack.
- Do not trap hash_list_{new,free}() under REMAP_ZALLOC.
- Ensure properties use xmalloc() for their values.
- Wait until main() starts to allocate the signal chunk.
- Made ascii_toupper() and ascii_tolower() avoid branching.
- Trace saving time whithin property files.
- Trace page (PA) and offset within page on SEGV.
- Trace page protection on SEGV faults, if possible.
- Trace how and where symbols were loaded in crash log.
- Symbol quality definition moved to symbols!
- Windows: handle freopen("a") specially to allow read sharing.
- Windows: no need to dump stack again if no gdb.
- mutex: supply more context on lock errors.
- ostream: now also accepts str_t as output medium.
- rwlock: added debug option to track wlock location.
- random-test: added -a to benchmark all routines.
- random-test: add -v to be verbose when -a is used.
- VMM: added extra debugging tools / assertions.
- VMM: trace new compile-time options.
- clock: simplify code by using aging table.
- xmalloc: avoid late page pool creation.
- xmalloc: extended assertions to detect freelist corruption.
- zalloc: avoid warnings when compiling with REMAP_ZALLOC.
- zalloc: with ZONE_SAFE, ensure block tagging never changes!
- malloc.c: enhanced and fixed some errors with multi-threading.
- malloc.c: huge refactoring and cleanup.
- aging_destroy(): remove periodic GC before cleanup.
- bfd_util_init(): avoid warning on bfd_init() call.
- clock_adjust(): removed MAX_SDEV.
- clock_adjust(): stop pruning if we keep everything.
- clock_update(): lowered required amount of data.
- compat_setjmp(): protect against gone contexts.
- crash_handler_process(): only call crash_auto_restart() if needed.
- ev_free(): assert event is not linked in queue!
- ev_unlink(): added list consistency assertions.
- eval_subst(): remove the size limitation on the susbtituted string.
- evq_close(): be silent if event queue not created.
- fi_pick_rarest_chunk(): fixed assertion failure.
- fi_pick_rarest_chunk(): log assertion values.
- get_prop(): also trace failing property when ps is NULL.
- ggept_filesize_encode(): can return 0 if given 0.
- hash_compute_increment(): make it odd without branch.
- main(): do not set a crash dir if not running for long.
- name_to_single_host_addr(): use pslist_random().
- ntp_send_probes(): comment updates, cleanup.
- once_recursive(): avoid calling stacktrace_function_name().
- progstart_duplicate(): added assertions.
- prop_lock(): use macro for locking (hiding lock type).
- rwlock_deadlocked(): trace write owner if known.
- spinlock_loop(): document why no memory barrier.
- statusbar_gui_push_v(): be safe if called early.
- str_avail(): new implementation and semantics.
- str_ichar() and str_istr() can now append.
- strvec_cpy(): was failing when called with cnt=0.
- thread_id_name_to_buf(): be nicer with negative IDs.
- thread_lock_waiting_done(): cleanup when no problems.
- tok_version_valid(): no longer run clock_update().
- xcopy(): not defined as inlined routine when TRACK_MALLOC.

# v 1.2.0  2020-07-09  [stable]

This is an evolution release, hence the minor version bump.

Several cases of bad input (from network) causing assertion failures were
fixed.  In particular, bad DHT response after a security token lookup or
invalid G2 input streams were fatal.

There was also a critical bug, originating from a harmful code typo, which
led gtk-gnutella to serve unvailable file chunks from partial files, as if
they were available, resulting in unintended download corruption on the
remote end!

Thanks to Laurent Gil's efforts, it is now possible to run gtk-gnutella from a
Docker container.  See https://github.com/angegar/gtk-gnutella-docker.
Running within docker raised some issues about sbrk() and thread_self(),
which were fixed.

The computation of the build date was fixed, to avoid corner cases where
gtk-gnutella would complain it was "old" when freshely compiled from
up-to-date sources in a git tree whose "master" branch was only infrequently
updated.

The file selector was fixed, to avoid displaying grayed-out folders, a setup
wich did not allow one to actually select directories in the preferences.

Many improvements were done to allow smoother uploading for servents with
more bandwidth than the recipients.  Instead of drastically limiting upload
bandwidth (which was negatively impacting everyone), we are now monitoring
and adjusting our uploading speed to avoid congestion on the remote end.
When stalling happens, we also react quickly to reduce the available bandwidth
of the connection, not that of all connections to whom we are uploading.

We also no longer rely on MaxMind GeoIP for providing the IP -> country
mappings.  Their distribution mode now requires a specific licence which seems
totally incompatible with the gtk-gnutella's distribution mode.  Instead, we
are now using IP2Location, and the GEO_LICENCE file now lists the conditions
under which these data are re-distributed (gtk-gnutella transforms the data
into a form that it can digest, so we are distributing a modified, derived
work, not the original).

If you are still using a version of gtk-gnutella earlier than the 1.1.x
series, you are strongly encouraged to upgrade.  Starting from this release,
we are now considering these versions too old to connect to.

Improvements:
- Let --compile-info show which malloc() is used.
- It is now possible to run gtk-gnutella from a Docker container.
- Added details in the README file about required packages to compile.
- Use gradual bandwidth penalty when uploads are stalling.
- Added upload bandwidth capping.
- Forcefully reduce request chunk if b/w is limited.
- Emit a Retry-After header on 416 replies.
- On HTTP 416, emit a Last-Modified header.
- Switched to IP2Location for mapping IPs to countries, dropping MaxMind GeoIP.
- Upload tab now shows our own partial completion ratio, not just "(partial)".
- Detect abuse from HTTP clients not reading payloads.
- Enforce Retry-After softly.
- Ban them when they abuse of the browse-host feature.
- Smarter detection of duplicate incoming Gnutella connections.

Bug Fixes:
- [GTK2] Fixed file selector to avoid greyed-out folders.
- [GTK2] Guarantee updating of properties when refresh button is clicked.
- Added emergency path during startup should sbrk() fail.
- Fixed instructions following build.sh run.
- Fixed possible thread_self() instability at startup.
- Fixed backward portability issue with the BFD library.
- Fixed computation of build date.
- Fix 2 harmful typos, affecting serving of partial files.
- Regenrate Configure to fix gccversion usage bug.
- Restored compilation of a standalone local shell.
- Remove executable permissions on C source file!
- Rename our ARC4 interface on systems with native arc4random().
- Updated all files to fix obsolete FSF postal address.
- Avoid banning hosts issuing legitimate upload requests.
- Implement GNU extension malloc_usable_size() when using our malloc().
- UHC: when hardwired list is exhausted, reload it.
- Make Content-Range and Content-Length prioritary headers.
- ban_allow(): was never returning BAN_FORCE.
- download_reply(): reload available ranges after 416 if needed.
- download_stop_switch(): forgot to remove passive queue indication.
- gtk_gnutella_exit(): must close UPnP layer before HTTP.
- http_send_status(): reworked to avoid undue header truncation.
- node_g2_read(): fixed faulty assertion.
- pb_token_found(): be more robust against unexpected input.
- search_gui_close_search(): avoid crash when emptying search list twice.
- update_available_ranges(): revisited range processing logic.
- upload_416_extra(): was generating non-compliant headers.
- vmm_dump_pmap_log(): fixed deadlock.
- download_moved_with_bad_sha1(): always reset fileinfo.
- file_info_reset(): also discard previous TTH info.

Under the Hood:
- Added temporary "xk" country code for Kosovo.
- Added vmm_type_pointer() to determine region type.
- Add lingering period for unreferenced file_descriptor objects.
- Add shell command "show files -d" to list currently used file_descriptor.
- Raise minimum b/w scheduling slot to 256 bytes per second.
- Fixed HashGenericCat() in Jmakefile, leading to wrong .c dependency.
- Fast assertions are a must for GTKG nowadays, always compile with them.
- Do not post multiple randomness generation messages.
- Split bit_generic routines into .ht and .ct.
- Reserve file_object_close() for user code.
- Made it possible to compile with TRACK_MALLOC again.
- Improved "thread elements" shell command to trace callback function names.
- Avoid VMM magazine allocation when running with TRACK_MALLOC.
- Enhanced TRACK_MALLOC to be able to trap xalloc() as well.
- Enhanced TRACK_MALLOC debugging power with MALLOC_CATCH_MALLOC.
- Extended bool_to_string() to display value if not 0 or 1.
- TEQ: optimize I/O events by posting them directly to I/O queue.
- VMM pmap logging shows allocated size per fragment type.
- Removed gone / probably gone logic for discovered threads.
- Ensure thread_atexit() callbacks run in discovered threads.
- Ensure walloc0() redirects to underlying zeroing routines, for statistics.
- Simplified shell I/O condition management and logging.
- Separate Gnutella and HTTP (upload) banning categories.
- STATIC_ASSERT: use a more compact version for less verbose errors.
- Made thread exit value read-only in thread_atexit() callbacks.
- Emit thread mask in crash logs upon detected deadlock.
- ADNS: the cache is now thread-safe and cached replies shuffled.
- ADNS: added expiring periodic callback for cached DNS entries.
- Added new "adns_debug" property for ADNS debugging.
- Avoid g_memmove() which has been deprecated.
- Added ripening_contains() and ripening_update() routines, not used yet.
- Optimize ripening table when no value is kept.
- Use aging table to track download mesh sending times.
- Use 429 instead of 550 for "Too Many Requests".
- Remind less often about banning status.
- Let emulated alloca() cleanup when thread exits.
- Ensure alloca_stack_direction_compute() is never inlined.
- Smarter detection of duplicate incoming Gnet connections.
- xmalloc: must "embed" xstrdup() and xstrndup().
- xmalloc: simplified allocation entry points.
- xmalloc: ensure stricter memory alignment when xmalloc() replaces malloc().
- ban_delay(): fixed to return remaining ban time.
- ban_force(): read incoming data before shutdown().
- ban_vendor(): GTKG earlier than version 1.1 deemed too old.
- bitcmp(): use memcmp() for byte comparison.
- bool_to_string(): added carp trace to help spot the culprit.
- cq_cancel(): fix logic to return TRUE if event was NULL.
- crash_deadlocked(): no longer dump stacks.
- crash_handler(): enter thread crash mode before signal cleanup.
- crash_time_internal(): use thread_safe_small_id() in raw mode.
- download_queue_delay_switch(): explicitly turn off queuing if switching.
- download_queue_v(): explicitely reset passive queuing info.
- download_reply(): Content-Length not necessary if Content-Range.
- download_send_push_request(): trace server GUID.
- erbtree_foreach(): added cheap safety assertion.
- evq_trampoline(): cleanup event if cannot signal thread.
- extract_retry_after(): ensure amount in seconds is the only value.
- fi_pick_rarest_chunk(): be smarter about selected chunk.
- fi_pick_rarest_chunk(): ensure first free chunk is available.
- hcache_fill_caught_array(): fix array fill logic.
- http_send_status(): ensure generated header has trailing CRLF.
- local_shell_mainloop(): must flag "writable" on POLLHUP.
- mingw_exception_log(): use static variables and be more careful.
- natpmp_handle_discovery_reply(): trace inconsistent replies.
- natpmp_handle_mapping_reply(): trace inconsistent replies.
- parq_upload_send_queue(): tie PARQ upload queue and upload.
- pcache_pong_received(): also validate changing ports.
- rand31: avoid race condition during intial seeding.
- random_pool_append(): ensure no endless recursion, ever!
- send_pproxy_error_v(): remove dead code.
- shell_handle_event(): always write() when having pending data.
- shell_handle_event(): on exception, setup EOF/shutdown.
- shell_write_data(): make sure to flush as much as possible.
- sig_compute_pc_index(): be paranoid about optimization.
- signal_name(): contort to avoid gcc-10 warning.
- signal_trap_with(): avoid kernel signal desynchronisation.
- signal_uncaught(): dump stack trace if harmful signal.
- sorted_array_lookup(): sort array if they forgot to do it!
- spinlock_deadlocked(): capture lock status early.
- stacktrace_atom_lookup_and_store(): trace race conditions.
- stacktrace_load_symbols(): do nothing if too early.
- thread_create_full(): keep async exit callback separated.
- thread_deadlock_check(): disable locks when deadlock is certain.
- thread_deadlock_check(): only dump stacks of involved threads.
- thread_stack_check_overflow(): also log used stack size.
- upload_remove_v(): create better logging message.
- vmm_malloc_inited(): now only called internally.
- xmalloc_show_settings_log(): trace chosen memory alignment.
- zgc_zalloc(): transformed some assertions into verbose ones.

# v 1.1.15  2019-07-14  [stable]

This release is a maintenance one fixing several minor bugs and two annoying
ones:

- The semi-reliable UDP layer could crash due to an assertion that started
  to trigger with the introduction of an explicit flush before the message
  times out for transmission.

- Due to an overseen condition, we were not able to serve seeded files when
  Partial File Sharing is enabled.  A seeded file is a completed file that
  still lies in the downloaded directory but is not part of the library
  directories.

The OOB banning code for hosts that never claim their OOB hits was also
revisited to prevent problems with hosts that query a popular file and then
get submerged by hits and thus refrain to claim the additional hits.  We are
now much more tolerant to avoid accidentally banning innocent hosts.

On Windows, the disassembling of machine instructions was enhanced to further
improve the ability to correctly issue symbolic stack traces when encountering
assertion failures or during crashes.

Finally, the Geo IP databases were refreshed.

Improvements:
- OOB: increased timeout for OOB hit delivery.
- OOB: switch to unreliable notification if semi-reliable UDP fails.
- OOB: raise the bar for banning after unclaimed OOB hits.
- Dynamic Hits: let us forward hits that bear a small amount of results.
- Count amount of banning we have to do for OOB querying hosts.

Bug Fixes:
- Rename statx struct to statistics to avoid name collision.
- browse_host_read_html(): fixed English typo.
- dl_util_query(): forgot to restore old signal handler.
- file_info_restrict_range(): was not serving seeded files!
- main(): do not let the supervisor process restart on crash!

Under the Hood:
- Added thread_stack_diff() to compare stack pointers.
- Added PLURAL() macros.
- Added clz64() to count leading zeroes on a 64-bit quantity.
- Added OP_CTZ() and OP_CLZ() to work on op_t quantities.
- Added pattern_memrchr() and pattern_strrchr() implementations.
- Jumbo patch to use vstrrchr() instead of strrchr().
- BIT_GENERIC_BIT() does not need the base argument.
- Factorized prefix-matching from sorted array.
- pattern.c: fix compiling with old gcc (version 4.4)
- pattern.c: forgot to include "endian.h".
- str: avoid "char" as parameter or return type, use "int".
- Windows: if not a "registered product", leave logs in current dir.
- Windows: enhanced stack unwinding.
- Windows: added option to debug backtraces "on crash" only.
- Windows: when backtracing, also parse another MOV instruction.
- Windows backtrace: also parse "add xx,%esp".
- compat_poll(): can now use poll() on Windows.
- evq_close(): warn when EVQ is not terminated after 2 seconds.
- file_info_moved(): no warning on file size if file still partial.
- main(): set a different product nickname for supervisor.
- mingw_analyze_prologue(): handle cases where no SP adjustment done.
- mingw_exception(): also log symbolic thread name if available.
- mingw_exception(): disable signals on stack overflow.
- mingw_exception(): interpret exception information differently.
- mingw_exception_log(): if PC looks invalid, try to intuit caller.
- mingw_file_rotate(): preserve extension during renaming.
- mingw_ftruncate(): it is OK if current offset is beyond truncation.
- mingw_get_return_address(): enhanced scanning for prologue.
- mingw_get_return_address(): validate next PC by checking CALL before.
- mingw_get_return_address(): validate stack pointer before access.
- mingw_thread_sig_deliver(): special-case signals for current thread.
- pattern_compile(): must use WALLOC0() for allocating!
- pattern_strstr_tiny(): fixed starting condition for aligned processing.
- rwlock_upgrade_from(): don't wait for readers in pass-through mode.
- rwlock_wait(): dump lock waiting queue when tracing sleeps.
- rwlock_wait(): trace summary when logging contention / sleeping.
- str_private(): declare non-leaking parts for TRACK_ZALLOC.
- teq_monitor(): trace pending events as well.
- thread-test: for interrupt tests, timeout if no interrupt received.
- thread_backtrace_capture(): avoid recursion and disable signals.
- thread_id_stack_used(): fixed for decreasing stacks.
- ut_frag_pmsg_free(): be more robust, avoid internal assertion.
- vmm_crashing_alloc(): better abort explicitly if no memory.
- wmove(): make sure it's a no-op with TRACK_ZALLOC.

# v 1.1.14  2018-10-04  [stable]

This release mostly improves the core routines and fixes a few important bugs.

Due to a bug in the usage of the RX buffers, we were not correctly parsing
data returned in "chunked" transfer-encoding by HTTP/1.1 servers.  This
affected the UPnP logic.

The UPnP port unmapping done when the program shuts down was also not being
able to complete successfully because we were preventing the HTTP connection
from going on during the shutdown.  Not critical because there is a lifetime
attached to all mappings, but always best to properly clean-up when leaving.

The algorithm used to pick random chunks to download was also revisited to
ensure a uniform selection within the whole file ranges that remain to be
fetched.

At startup time, the DHT code no longer expires keys when reloading data.
This could create crashes during the operation, with no other remedy than
to erase all the DHT database files manually to be able to recover!

The background task layer was also causing crashes (at exit time though)
because it was not recording whether it was running "user" code as opposed
to "kernel" code.

The SDBM code was also improved to allow concurrency and, in particular,
a "loose" iteration scheme which does not need to grab the database lock
during the whole iteration process.  It is also possible to perform a
concurrent database rebuilding.

The thread runtime now has an improved deadlock detection engine, based
on a topological sort, that can definitely tell whether we are deadlocked.
When the deadlock is detected, we can also have more information about
the threads participating in that deadlock condition, to assist debugging.

On Windows, a bug in our mingw_dlerror() emulation caused it to always
fail once an error had been recorded, leading to un-decorated subsequent
stack traces, which really do not help on that platform!

There was also a concurrency bug in the processing of network queries.
Every time the library was rescanned, it could trigger a crash due to
a memory zone being declared private and was in fact shared between
threads.  The crash occurred only when a query was received on the
Gnutella network whilst the library was rescanned.

The semi-reliable UDP layer TX side was revisited to maximize chances that
reliable messages get through completely.

The pattern matching code was revisited thoroughly.  A new algorithm (2-Way
String Matching) now complements the Quick Search algorithm and an initial
benchmarking is done to compare our own matching routines with native libc
versions of strstr(), strlen(), strchr() and memchr().  The fastest routine
is then selected, to ensure optimal performances.  There is also a unit-test
program ensuring proper semantics for the pattern search flags.

New Features:
- Added UDP scheduler message statistics by priority.

Improvements:
- [GTK2] Catch column resize events to persist widths quickly.
- Added "shutdown -x" to stop the program and continue session next time.
- Added --resume-session option to request explicit continuation.
- Improved pattern matching with new algorithm and runtime benchmarking.
- Persist current_peermode to restart in same mode after crash.
- Record compilation date and time for the crashlog.
- When running with no GUI, relax mem requirements to become ultra.
- Use minimum download chunk size to align requested download offsets.
- Added statistics for OOB hit notifications we process.
- Extensive improvements of the SDBM code to allow concurrency.
- Semi-reliable UDP TX layer now sends messages more aggressively.
- Reduce memory footprint of compiled patterns for short patterns.

Bug Fixes:
- No longer supply -lgthread-2.0 and -lresolv at link time.
- DHT: do not expire keys when reloading data at startup.
- Restored alphabetical listing of command options in the man page.
- The --use-poll argument was not mentioned in the manual page.
- UPnP: fixed XML logging.
- UPnP: was not correctly unmapping ports on servent shutdown.
- crash_time_internal(): protect against recursions in raw mode.
- file_info_retrieve(): must restore proper mtime for seeded files!
- filter_apply(): fixed suffix matching to allow whole match.
- http_data_ind(): could not process chunked data!
- iov_contiguous_size(): fixed destructive implementation.
- pslist_last_count(): fixed off-by-one error.
- recursive_scan_step_build_partial_table(): removed assertion.
- statx_opx(): use fabs() on double.
- word_vec_init(): zone cannot be private.
- zgc_subzone_defragment(): fixed improper assertion.

Under the Hood:
- Added hidden --no-build-version option.
- Added cstr_{b,f,l}cpy() routines to supplant g_strlcpy()
- Added strpcpy() which returns pointer to last copied trailing NUL.
- Added vmm_move() to move allocated VM regions to better places.
- Added G_FALL_THROUGH and fixed fall-through in switch cases.
- Added assertions in embedded lists for insertions / removals.
- Added new _mark_removed() and _link_mark_removed() for lists.
- Added is_ascii_ident() to check "\w" (word) in ASCII.
- Added ULONG_SWAP().
- Added op_roundup() and op_ptr_roundup() to round to upper aligned boundary.
- Added stats datapoint iterators and ability to remove outliers.
- Added G_FAST and G_NO_OPTIMIZE compilation directives.
- Added support for case-insensitive pattern matching.
- Added zone_info() to request zone allocation stats.
- Added p[s]list_shift_data() to remove head when NULL is valid data.
- Attempt relocation of hash tables arenas once in a while.
- Always capture and display the routine name in assertions.
- Disable parallel make execution in src/if.
- Fixed indentation for "if" and "else" leading to gcc 7.x warnings.
- Fixed logging fast assertion macros to allow just one string.
- Declare property choices[] array static and const!
- Optimize h_strnjoinv() with new strpcpy().
- Optimize memory for the gnet property init_list[].
- Optimized ctz64() to make it more obvious.
- Protect events and subscribers with magic tags.
- Removed http_buffer_t, completely obsoleted by pmsg_t.
- Show zalloc settings at startup and in "memory show options".
- Simplify code for read-lock upgrading and releasing.
- Strings now hold persistent "truncated" flags, for formatting.
- The watcher layer now auto-initializes.
- Use the Mersenne Twister as an additional random source.
- Use s_carp() instead of s_warning() for reporting "deep" important warnings.
- Use new vstrstr(), vstrlen(), vmemchr() and vstrchr() for optimized runtime.
- Windows: added ftruncate() emulation.
- Windows: fixed stat() and fstat(), with proper st_dev and st_ino fields.
- enamed hash_table_size() as hash_table_count() for consistency.
- When log messages are truncated, signal it visually with trailing "+++".
- VMM: use smarter core allocation under long-term strategy.
- anti_window_shift_hack(): hide normal output if not debugging.
- compat_longjmp(): record usage location and trace duplicate use.
- crash_invoke_inspector(): do not hardwire parent stdout / stderr.
- crash_restart(): always log the given message.
- crash_setcctime(): avoid using "time" as parameter name.
- crash_vmea_usage(): trace calling routine.
- entropy_seed(): also initialize random "previous entropy".
- fi_pick_chunk(): fixed selection of first chunk.
- fi_pick_chunk(): revisited random chunk selection algorithm.
- file_object_find(): loudly warn on file mismatch.
- get_iconv_charset_alias(): do not copy trailing ' ' in charset name.
- halloc_dump_stats_log(): was not logging realloc_via_xprealloc.
- hrealloc(): use vmm_move() and attempt to optimize VM space.
- log_handler(): emit stacktrace for glib, GTK or Pango warnings.
- mingw_dladdr(): use win32 DLP layer to check for new libraries.
- mingw_dlerror(): fixed to follow POSIX semantics.
- mingw_fix_stat(): trap ERROR_NOT_READY errors correctly.
- node_timer(): periodically try to move QRT arenas in VM space.
- parse.h: remove NON_NULL_PARAM() on function with assertions.
- rwlock_upgrade_from(): must only count read-locks from current thread.
- s_logv(): default log message max length raised to 3500 bytes.
- search_oob_pending_results(): randomly discard hits if too many.
- search_request_preprocess(): warn if TCP query contains a "QK".
- sequence_backward_iterator(): fixed case of one-way lists.
- stacktrace_pretty_filepath(): move to latest /src/.
- str_chr(): optimized to use vstrchr() if we can NUL-terminate.
- str_destroy(): ensure we do not call on a thread-private string.
- str_s2c(), str_2c(), str_dup(): handle already NUL-terminated strings.
- str_s2c(): ensure we do not call on a thread-private string.
- thread_suspend_others(): skip threads not marked as "valid".
- timestamp: be paranoid and protect against invalid time_t inputs.
- vmea_capacity(): changed semantics to report initial capacity.
- vmm_mmap_anonymous(): identify foreign regions more quickly.
- word_vec_make(): simplified code a bit.
- wrealloc(): if size does not change, attempt a wmove().
- xallocate(): be more aggressive when forcing VMM allocation.
- xmalloc: allocate via standalone VMM regions if possible.
- xmalloc: revisited plain VMM block allocation and freeing.
- xmalloc: use checksums to validate chunk headers.
- xreallocate(): ensure VMM space improves when reallocating.
- zcreate(): flag created zones as "user" ones.
- zgc(): only run for long-lived processes.

# v 1.1.13  2017-10-22  [stable]

This release primarily addresses issues that were left-over in 1.1.12.
Do not use that previous release, migrate from 1.1.11 to 1.1.13 directly!

The main issue was that of Partial File Sharing.  Numerous bugs, dating from
7 years or more, were lurking because my local configuration had switched PFS
off for testing, and it had never been turned back on!  In particular,
completed files were not properly shared, it was not possible to upload their
THEX since it was not recomputed, and the files were not properly indexed in
the Query Routing Table due to bugs in the background task layer.

In case of a crash, we now dump the value of all the Gnutella properties to
be able to spot configurations that deviate from the norm.  Too many bugs
were reported and ignored because they could not be reproduced, often due
to not having the same setup when attempting to debug!

Another nasty bug was fixed: it was not possible to change the IP support
configuration without causing an immediate crash.  The reason is due to a
change that was integrated in 1.1.12 to allow IPv6 UDP traffic from G2 nodes.
The problem was that this created an extra client stack on top of the
low-level UDP traffic scheduler and it was not properly cleaned-up when
switching IP configurations, leading to an assertion failure!

New Features:

Improvements:
- Append all Gnutella properties to the crashlog file.
- At startup, do not needlessly request TTH if we have it cached already.
- Optimized requests for library scan / QRP rebuild, avoiding multiple events.
- Allow TTH computation for seeded files.
- Obsolete and stale entries are now removed from the SHA1 cache.
- [GTK] Added GUI events on more fileinfo changes.
- [GTK] Show information about recomputed TTH for seeded files.
- Prune unshared entries from SHA1 cache at startup.
- Persist information about seeded files in the ASCII fileinfo database.
- Remove unneeded libraries from the default GTK2 ldflags.

Bug Fixes:
- Was not able to properly seed completed files; fixed shared_file_path().
- Was not always updating QRP on the UP side after a library change.
- Could have background tasks stuck after cancelling a multi-ref'ed one.
- Dynamic querying timeout was not properly computed (made too small).
- Changing from "IPv6 & IPv4" to "IPv4 only" mode caused a crash.
- Restored ability for "shutdown -r" to work.

Under the Hood:
- Added prop_to_typed_string().
- Added s_where() to log a stacktrace on stderr only.
- Added tt_slice_size() to compute slice length per leaf in the TTH.
- New crash_dumper_add() to register crash dumper callbacks.
- No panicing when thread cannot block but was actually suspended.
- Was unduly offsetting stacktrace by one extra level.
- bg_sched_sleep(): don't reduce runcount on exiting task!
- bg_sched_timer(): added run count consistency check.
- bg_sched_timer(): fixed logging of task's run time.
- bg_task_cancel(): log task address as well, not just the task name.
- bg_task_wakeup(): must clear user sleeping flag.
- crash_restart_notify(): use smarter crash_exit().
- crash_try_reexec(): suspend other threads as a precaution.
- deflate_flushed(): suppressed soft assertion.
- dq_results_expired(): fixed improper timeout computation.
- fi_free(): cut any pending reference by uploads!
- fi_tigertree_check(): more verbose in case of errors.
- file_info_moved(): must update fi->modified as well.
- file_info_remove_source(): removed unused discard parameter.
- file_info_retrieve(): also validate that DONE is consistent.
- file_info_shared_sha1(): do not share bad files.
- get_file_to_upload_from_urn(): factorized code.
- huge_update_hashes(): enforce one sync of SHA1 cache every minute.
- huge_verify_callback(): use shared_file_indexed().
- node_udp_disable(): was not disabling the G2 UDP IPv6 node.
- parse_and_append_cache_entry(): discard obsolete / stale entries.
- qrt_compressed(): fixed outdated comments.
- qrt_diff_1(): was never considering change.
- request_sha1(): don't request TTH if we have it cached.
- shared_file_fileinfo_unref(): clear fileinfo pointer.
- shared_file_from_fileinfo(): copy TTH atom as well, if any.
- shared_file_is_shareable(): be stricter for partial files.
- shared_file_path(): must process sf->fi correctly!
- upload_file_present(): loudly warn when completed file changed on disk.
- upload_file_present(): loudly warn when file not shareable.
- verify_update(): loudly warn when "progress" callback stops processing.

# v 1.1.12  2017-09-20  [stable]

This release fixes a very critical bug that was only manifesting when Partial
File Sharing was turned on, and which caused possible memory corruption (leading
to a sure crash later) when enqueuing new files for downloading.

New Features:
- Throttle browsing requests to one per hour from a given IP.
- Limit uploads to stalling hosts to 1, regardless of user settings.
- [GTK2] Show proper average data speed on completed uploads.

Improvements:
- Added "WSHR" vendor code for WireShare.
- Added "ENVY" vendor code for Envy.
- Do not attempt costly operations after a crash / auto-restart.
- Updated FAQ  -Uploads and Sharing-
- Use 64-bit variables for bandwidth computations.
- Make sure early stalling is not always reported for the same IP.
- Use even HTTP outgoing bandwidth as the last measure when stalling.

Bug Fixes:
- Allow IPv6 UDP traffic from G2 nodes.
- Be sure to use destructive list iteration with tmalloc_free_magazine().
- Critical upload HTTP statuses are now fully sent.
- Must give plain (untranslated) strings to send_upload_error().
- bg_task_finished(): now calls safer bg_task_dead().
- file_object_open_from(): also catch EROFS when opening file.
- node_bye_v(): do not call node_remove_v() for G2 nodes.
- vendor_code_get_name(): fixed validation of unknown code tokens.
- verify_next_file(): fixed wrong argument order in log message.

Under the Hood:
- bfd_util: reworked mutex grabbing in an attempt to avoid deadlocks.
- binary_hash(): disperse bits in initial hash value.
- check_for_events(): optimize path if timeout is 0 or we collect events.
- cq_event_called(): only zero variable holding event when asked!
- cq_zero(): now always nullify the event, as the name suggests.
- crash_setmain(): avoid spurious warnings with recent gcc.
- english_strerror() and symbolic_errno() made thread-safe.
- inputevt_timer(): factorized common code into new inputevt_handle().
- socket_udp_flush_queue(): do not process anything if we cannot devote time.
- stack_sym_trylock(): avoid deadly recursions through stack lock dumping!
- thread_sig_handle(): use atomic exchange operation to clear pending set.
- u32_ptr_hash(): discard lower bits of the multiplication as well.
- upload_timer(): clear the stall flag when it is over.
- Added aging_record() to simplify code for plain keys.
- Added cq_event() to acknowledge reception of events we do not track.
- Added "inputevt_trace" property for tracing dispatched I/O callbacks.
- Added english_strerror() to guarantee English messages.
- Added thread_signal_has_pending() and thread_signal_process().
- Added "lock_sleep_trace" and "lock_contention_trace" properties.
- AJE: changed pool #0 filling policy and reseeding checks.
- Ensure misc_init() is called before using lookup tables.
- Simplify is_ascii_*() by performing table lookup.
- Thread runtime now allows a signal handler to run within another one.
- Updated UHC list, fixed obsolete port numbers.
- Use new cq_event() in thread callout events to avoid possible leaks.
- Watchdog: revisited logic to do more under lock protection.

# v 1.1.11  2016-11-11  [stable]

This release fixes a portability issue on FreeBSD and introduces a main core
feature and minor new GUI features.

The main feature is the addition of "equivalence classes" defining word
aliases, used when sharing files and querying for them.

Currently, the only supported equivalence class deals with naming of series.
Indeed, there are various conventions that can be used to represent these,
and it makes searching inefficient: either one will lookup for all the
possible variations, or one will miss some of the files.

For instance, episode #8 of an hypothetical season #4 can be represented by
any of these strings:

	{ "s04e08", "4x08", "408", "04x08", "0408" }

Thanks to the equivalence class, a file bearing one of these strings can
be searched for (and located successfully) by using any of the other strings.
Of course, since this is a local processing, the more servents out there are
deployed with this aliasing support, the more efficient the feature becomes!

There are also new GUI features: the "Clear completed" button from the Download
pane is now doing someething useful, and the current page of different notebooks
is remembered across sessions.  The only one which is not restored on normal
resuming is the main notebook tab.  It will be restored if GTKG is restarted
after a crash, but otherwise the application will always start up within the
Network tab.

In the Uploads tab, upload requests coming from a G2 servent will now be
flagged with a "[G2]" tab right after the IP address. This helps seeing how
the Gnutella and G2 network unification is evolving.

New Features:
- Flag uploads coming from G2 servents with a "[G2]" tag after IP address.
- Added alias support in sharing/querying.
- Made the "Clear completed" button in Downloads/Tools do something useful.
- Moved "Clear completed" button to the bottom right of the download pane.
- Remember fileinfo notebook tab number across sessions.
- Remember main notebook tab number across sessions, only restored after crash.
- Remember Gnet stats notebook tab number across sessions.
- Remember download info / tools notebook tab number across sessions.

Improvements:
- Added --cleanup to explicitly request for final memory cleanup sequence.
- Updated Italian translation.
- Updated GeoIP databases.

Bug Fixes:
- Leaf nodes could end-up being connected to more ultrapeers than configured.
- Fixed monitoring of alien threads, important when GTK file selector is used.

Under the Hood:
- Debian compatibility level changed from 4 to 5.
- Make sure we can deal with older pkg-config, which needs leading arguments.
- Use "embedded" symbols for xmalloc(), xfree() and friends.
- Added "query_trace" property to trace all queries which were searched.
- Moved halloc-based string functions like h_strdup() to dedicated hstrfn.c.
- Expanded search mask to 64 bits to be able to hold all digits and letters.
- Count aliased queries and hits from aliases.
- Pre-compute shared file media type at record creation time.
- Pass query limits to st_search() to avoid needless pattern matching.
- Added h_strsplit() and h_strsplit_set().
- Added strvec_append_with() to expand vector by appending another vector.
- crash_assert_logv(): don't call crash_mode() if assert failure was recorded.
- entropy_clock_time(): mix the entropy nonce through hashing for more diffusion.
- node_can_accept_connection(): only send headers back when handshaking.
- qrp_add_file(): optimized to avoid computing word length if not required.
- thread_stack_check_overflow(): ignore virtual addresses outside stack range.
- vmm_init_once(): ensure any shared library for stacktrace unwinding is loaded.

# v 1.1.10  2016-09-01  [stable]

This is mostly a bug-fixing release and should be the last update on the
1.1.x release tree, before important core changes in the upcoming 1.2.

Improvements:
- FAQ cleanups.
- Added the ".ape" file extension to the default list of shared files.
- Remember hosts to which a TCP connection failed recently to avoid hammering.
- Updated French and Turkish translations.
- Updated GeoIP databases.

Bug Fixes:
- Don't embed build date if SOURCE_DATE_EPOCH is set for reproducibile builds.
- Missed ":" in variable substitution request, in scripts/nm-list
- nm-list: fixed date computation on BSD systems.

Under the Hood:
- Need TLS 2.12 to generate an X.509 self-signed certificate.
- Added G_PRINTF() hint to tls_logfmt() and tls_cert_log() to avoid warnings.
- Fixed CPP file inclusion protection symbol for lib/mime_type.h.
- Added the "ape" MIME type linked to the ".ape" file extension.
- Ensure we do not suspend threads during an interrupt.
- Track where context was taken in our setjmp wrappers to ease debugging.
- Keep track of "once" initializations in case we end-up recursing.
- Trace which new lock is overflowing the lock stack.
- once: make sure we can insert routine in our tracking table.
- once: arbitrarily limit nesting level in one thread to 32.
- dht_update_size_estimate(): return if our KUID was not initialized yet.
- keys_reclaim(): we can have values attached to key if we can remove it.
- symbols_load_from(): must release write lock when falling back to pre-computed.
- thread_element_block_until(): was not checking for concurrent unblocking.
- thread_element_block_until(): revisited signal handling.
- thread_suspend_others(): don't wait for busy threads already marked suspended.
- walloc: prevent race condition on walloc_stopped being set.

# v 1.1.9   2016-03-06  [stable]

This is mostly a bug-fixing release.

It fixes an important bug in the UPnP discovery path that led to a crash when
it found more than one UPnP device on the network.

It also introduces a new Glossary that can be displayed to explain some terms
that may be hard to understand for newcomers, so that they may in turn benefit
from the tooltips and the information in the FAQ.

On Windows, one important change is that we now force all memory allocations
from the external DLLs to use our own malloc() implementation.  This proves
that one of the DLLs is exhibiting a memory leak.  Plugging that leak will
unfortunately require that a garbage collector be implemented.  Measurements
indicate that 4K leak every second on average, which eventually leads to an
out-of-memory crash after a few days (2 to 3), preventing high uptimes on
Windows.  The leak is not originating from gtk-gnutella's code.

Improvements:
- [GTK2] Added menu to display the new glossary window.

Bug Fixes:
- Define PTHREAD_STACK_MIN to 0 in case it is not supplied by <pthread.h>.
- can_become_ultra(): don't account for upload fds if no upload will take place.
- compat_sleep_ms(): fixed the fallback implementation using compat_poll().
- dht_route_parse(): ensure we never use uninitialized variables.
- entropy_collect_host(): no longer attempt to get the host IP addresses.
- file_locate_from_path(): if pathname is qualified, duplicate argument!
- ftw_foreach(): prevent memory leak on error path.
- thread_lock_deadlock(): avoid de-referencing NULL if possible.
- upnp_discovered(): avoid segfault when we have to pick the first device.

Under the Hood:
- Disable warnings about the mem vtable being deprecated in recent glib.
- Suspend threads created after a global suspension is in effect.
- Warn when we cannot find a thread to record / release a lock.
- Added a new crash-level for deadlocks.
- Added optional debugging code to track reading threads on a read-write lock.
- Added spinlock_in_crash_mode_raw() for raw spinlocks to avoid deadly recursion.
- Additional debugging code to track read spots per thread on a read-write lock.
- Added backtrace capture when threads are contending for a lock.
- On deadlocks, suspend the other threads and log origin quickly before handling.
- New strategy in lock "deadlock" routines: ignore when in pass-through mode.
- Do not perturb the lock waiting state of the crashing thread on a deadlock.
- Revisited thread_lock_deadlock().
- Check for stack overflowing each time a lock is grabbed and recorded.
- Added thread diversion support.
- Added thread_halt() to forcefully halt concurrently crashing threads.
- Refactored memory checks to avoid systematic locking in mem_is_valid_ptr().
- Try to divert crash processing to main thread when triggered in a sub-thread.
- On deadlock condition, attempt to collect stacktraces of other threads.
- Add the current process PID and the last crash level to the crash log.
- Use raw logging routines in spinlock / mutex deadlock tracing.
- Added crash_getpid() for safe original PID computation, even across a fork().
- Add dump of all the thread stacks to the crash log if we can't fork().
- Moved equiv() and implies() definitions to "casts.h".
- Added xxx_to_string_grp() to optionally format xxx with thousand groupping.
- Adding win32 dynamic library patcher to trap malloc() in all required DLLs.
- Windows: with win32dlp, no need for monitoring committed memory.
- Renaming of legacy G_GNUC_XXX into G_XXX for concision.
- Renamed G_N_ELEMENTS as N_ITEMS.
- Moved gcc-specific macros to a dedicated file.
- Added pragmas to shut up spurious warnings with the clang 3.4.1 compiler.
- On the lock recording path, we can now use thread_get_element() safely.
- Made sure symbols are thread-safe and properly locked.
- If stacktrace dumps could intertwine, prefix the second with the thread ID.
- Allow for nested lock waiting sequences.
- Added SIGSYS to the list of harmful signals we want to catch.
- Added THREAD_F_WAIT to let thread_create() wait for the new thread to start.
- Windows: was not reconstructing correct stack frame pointer for WINAPI calls.
- Windows: improved backtracing through routines using a large amount of stack.
- Made signal_enter_critical() and signal_leave_critical() thread-safe.
- Made signal_in_handler() thread-safe.
- No longer block signals when waiting for a read-write lock.
- Prevent signals during logging, to avoid recursion if logging from handler.
- rwlock: when waiting for too long, deadlock only when no activity is seen.
- Added hash_table_is_locked().
- Added compat_gettid() and use it to record the system thread ID.
- Added support for thread_interrupt() and thread_os_kill().
- Windows: make sure s_read() can return EINTR and handle it properly.
- Windows: added support for sigprocmask(), sigsuspend() and friends.
- xmalloc: count and loudly trace allocation attempts made from signal handler.
- omalloc: loudly warn when invoked from signal handler.
- VMM: warn when memory allocation / freeing attempted from signal handler.
- VMM: use groupped formatting for region sizes or large numbers.
- Make sure we do not dispatch thread signals when running in an interrupt.
- Added s_minicarp_once() and a circular buffer to avoid memory allocation.
- Monitor when we issue blocking syscalls to flag signal handlers as safe/unsafe.
- Added plumbing to allow longjmp() or siglongjmp() in a signal handler.
- booleanize(): use version not causing any jump, for speed.
- clamp_strlen(): use same optimization as utf8_strlen() to compute length.
- mingw_analyze_prologue(): fixed MOVL immediate offset parsing.
- mingw_exception_log(): simplify processing on stack overflows.
- mingw_getdtablesize(): don't call _getmaxstdio(), hardwire 2048 instead.
- mingw_signal(): only call signal() for SIGSEGV.
- mingw_sigraise(): only log sent signal when asked to.
- mingw_waitpid(): fixed compilation warning given that WAIT_OBJECT_0 is 0.
- mingw_win2posix(): added mapping for ERROR_INVALID_USER_BUFFER.
- mingw_win2posix(): added mapping of ERROR_NO_SYSTEM_RESOURCES to ENOMEM.
- mingw_write(): for Windows 7 and maybe later, do not call write().
- mutex_is_owned(): optimized by avoiding thread_self() call if mutex not locked.
- prop_save_to_file(): use file's timestamp, not the current time.
- rwlock_not_owned(): ignore errors when the rwlock layer is in pass-through.
- s_logv(): made recursion detection thread-safe.
- s_logv(): use raw time computation when running in signal handler.
- s_minierror(): enhanced to enter crash mode immediately and show thread ID.
- s_rawlogv(): force "raw" mode when running in a signal handler.
- s_stacktrace(): downgrade from decorated to plain stack before skipping traces.
- signal_name(): added more items to signals[], so cache linear lookup result.
- spinlock_grab_try_from(): no crashing mode, don't say we locked if we couldn't.
- stacktrace_get_symbols(): make sure we're running this only once.
- stacktrace_unwind(): detect recursion in a thread-safe way.
- stacktrace_unwind(): use gcc-style unwinding if recursing or within malloc.
- str_vncatf(): added verbose assertion to ensure string is not overflowing.
- symbols_name_only(): simplified code.
- symbols_name_only(): simplify processing if we don't have to format an offset.
- thread_check_suspended(): account for thread_find() returning NULL.
- thread_cond_waiting_element(): don't create the cond stack until necessary.
- thread_exiting(): do not reset the QID range on Windows for an exiting thread.
- thread_id_name(): be robust if called during crashes.
- thread_launch_trampoline(): do not harvest entropy, this slows down creation.
- thread_lock_got_swap(): missed accounting of new lock in discovered thread.
- thread_lock_waiting_element(): warn when we detect recursive lock waiting.
- thread_preallocate_element(): also pre-allocate the lock stack.
- thread_sig_handle(): don't handle signals if thread is supposed to be blocked.
- thread_small_id(): bet on the QID lookup success.
- thread_sp(): simpler version defeating compiler optimizations.
- tm_localtime_raw(): use exact time, as this is used during logging.
- xmalloc_thread_alloc(): refuse to allocate if within a signal handler.

# v 1.1.8   2015-12-18  [stable]

This is an emergency bug-fixing release.

It addresses systematic crashes on some platforms, right at startup time,
and prevents random deadlocks on OS/X.

The systematic crash was due to an innocent change, which actually perturbed
the order of the initialization routines and, depending on the conditions,
caused an assertion failure during one of the thread startup.  Curiously, the
error manifests randomly and does not seem to depend on the OS but rather on
other subtle environment issues: one Linux distribution could be fine whilst
another was hit by the bug.

# v 1.1.7   2015-12-13  [stable]

This release adds support for new features:

	- TLS upgrade of existing connections.
	- Inbound HTTPS connections
	- Use of a supervisor process to relaunch gtk-gnutella on crashes

The TLS upgrade allows connections that have started without TLS to negotiate
TLS on the fly without having to reconnect. They are flagged as "e" to show
that encryption was dynamically added, as opposed to "E" which indicates an
initial TLS connection.

Certificates are now automatically generated and this allows HTTPS connections
from browsers.  For now this is of limited use, but it will come handy in the
near future when building a web-enabled GUI.

To be more resilient against crashes, gtk-gnutella now automatically launches
a supervisor process that will launch the real gtk-gnutella as a child process
and monitor its fate, restarting a new process when the old one failed.  This
is far more robust than having the process re-exec() itself at crash time since
there are some crashing conditions that do not even allow the process to go
that far in the crash handling...

On Windows, provided you have installed Cygwin's gdb, crash logs will now
contain a gdb backtrace of the failing process, making analysis of what went
wrong easier than with a simple stack trace.

Your previous GUID and KUID will be regenerated the next time you restart due
to a new algorithm used to detect that a configuration file is not accidentally
reused on another machine: the host name is now included, instead of just the
physical file information.  So when moving a disk to another machine, or simply
cloning an existing virtual machine, we are no longer going to reuse these
IDs which are supposed to be unique by properly detecting that the information
was copied over.

A bug in open_read() caused the Geo IP database to not be loaded on Windows.

Finally, all the options given to gtk-gnutella can now be abbreviated as long
as they are not ambiguous (i.e. enough is given to make them non-ambiguous).
For instance, given the current set of options, --p would be ambiguous but --s
will always mean --shell.  However, --pi is not ambiguous and refers to --ping.

Improvements:
- By default, gtk-gnutella now supervises its children to restart them.
- Now allows incoming HTTPS connections.
- Added support for Gnutella connection upgrade to TLS.
- Added support of RFC-2817 for upgrading to TLS within HTTP/1.1.
- Dump symbolic stack when crashing in supervised mode with our parent.
- VMM: added new flag to signal OOM condition and be aggressive with the cache.
- Options can now be abbreviated as long as they are not ambiguous.
- Added support for Virtual Memory Emergency Allocation (VMEA).
- Pulled latest translations from Transifex.

Bug Fixes:
- Make sure node_by_guid() cannot return a G2 node!
- VMM: fixed memory allocation logic during crashes.
- open_read(): fixed logic on Windows when no renaming is requested.
- Make sure we don't restart nor pause a failing process on --shell or --ping.

Under the Hood:
- Added spopen(), a simple popen() bypassing the shell.
- Added Windows-specific PROT_GUARD protection type for mprotect().
- Added log_show_pid() to direct the logging layer to show or hide the PID.
- Added library support for file locks.
- Added compat_process_exists() and compat_kill_zero().
- Added ability to dynamically limit walloc() usage, remapping to xmalloc().
- Added ability to disable halloc() at runtime, remapping it to xmalloc().
- Added specific PID file for locking out the supervisor process.
- Do not install periodic xgc() and zgc() unless running in a long-term process.
- Refactored main() initializations to limit memory usage in the supervisor.
- Windows: stop fatal recursion when the VMM layer extends the pmap.
- Windows: revisited exception logging to give more details and simplify code.
- Windows: reworked stack overflow detection logic.
- Windows: added launch() and spopen() support.
- Windows: added support for wait() and waitpid() on launched processes.
- Windows: launch gdb in a separate thread to get symbols when crashing.
- Windows: re-worked early init code to allow memory allocation.
- Windows: will now be building with gnutls-3.4.5.
- Windows: added getppid() support.
- Windows: added getuid(), geteuid(), getgid() and getegid() emulations.
- Windows: try to have SymInitialize() done as soon as possible.
- Windows: added support for getrusage(RUSAGE_CHILDREN).
- Make sure the logic used to construct fallback path is consistent.
- Refactored Windows socket initialization.
- Refactored setproctitle(), adding getprogname() and setprogname() as well.
- Revisited crash_mode() to include the notion of criticity level.
- Switched rand31() to the Park and Miller algorithm.
- SDBM: added fadvise() hint for page accesses, with a "random" access mode.
- Use short_time_ascii() instead of short_time() in log messages.
- TLS: use our own random number generators.
- TLS: use new types, with the _t trailing prefix.
- TLS: added support for a global audit log, available since gnutls 3.0.
- TLS: added vectorized push routine.
- TLS: added generation of private server key at startup if missing.
- TLS: don't need anonymous server credentials if we have a certificate.
- TLS: added generation of self-signed certificate at startup if missing
- TLS: removed ARCFOUR-40 from the list of overrides for GnuTLS 3.4.5.
- TLS: enhanced to support GnuTLS 3.x and allow HTTPS connections.
- TLS: the "custom I/O" push/pull routines are now the norm.
- TLS: normalized logging to always use G_STRFUNC for non-informative messages.
- mingw_fcntl(): return ENOSYS for unimplemented parts, not EINVAL!
- mingw_fcntl(): added F_RDLCK (read-lock) support for F_SETLK operations.
- mingw_sigraise(): trace signal, since it could be the prelude to a crash.
- cq_init(): loudly warn if the callout queue was created automatically before.
- cq_init(): always warn if callout queue exists, regardless of its thread.
- pncs_convert(): avoid using the stack, prefer a thread-private buffer.
- sdbm_set_volatile(): forgot to grab lock on entry.
- sdbm_thread_datum(): avoid too many re-allocation overhead, sacrificing memory.
- thread_launch(): warn once if pthread_attr_setstacksize() returns an error.
- gwc_parse_dispatch_lines(): avoid using "eof", it shadows a global on Windows.
- thread_launch_register(): force new PROT_GUARD protection on red-zone page.
- shell_exec_thread_list(): use configured stack size if available.
- spinlock_crash_mode(): dump PID as well in case process forked.
- crash_invoke_inspector(): also attempt to launch gdb on Windows.
- crash_invoke_inspector(): force emission of decorated stacks.
- crash_generate_crashlog(): dump thread locks before current stack.
- settings_random_save(): now merge randomness instead of just superseding it.
- crash_init(): now calls stacktrace_init() with immediate symbol loading.
- mingw_exception(): maintain exception recursive depth per thread.
- signal_perform_cleanup(): trace signals we get during cleanup.
- mingw_signal(): be thread-safe, in case of concurrent updates.
- tm_init(): now controls whether to start the time thread.
- vxml_parser_remove_buffer(): application logic was done only when debugging!
- crash_try_reexec(): do not exec() ourselves when we have a supervising parent.
- node_can_accept_connection(): even when "offline", accept nearby hosts.
- tls_handshake(): log IP:port and whether remote is client or server.
- SHA1_process_message_block(): make sure SHA1 is correct on big-endian systems.
- node_is_now_connected(): watch out for disconnected nodes after RX injection.
- download_get_server_name(): when name changes, reset some internal attributes.
- entropy_seed(): make sure we're correctly seeding our KISS RNG.
- gtk_gnutella_atexit(): do nothing if we're already crashing.
- unique_file_token(): include the hostname into the unique file ID.
- kuid_random_fill(): use random_key_bytes() to generate unique KUID.
- file_locate_from_path(): tweaked for Windows to add implicit "." in PATH.
- xallocate(): when crashing, use omalloc() for small blocks, instead of sbrk().
- hash_table_replace(): fixed logic when inserting into a fix-sized table.
- stack_print_decorated_to(): switch to lighter tracing if we hit an OOM.
- mingw_execve(): redesigned to avoid using external resources.

# v 1.1.6   2015-11-08  [stable]

This is a bug-fixing release.

This time it focues on Windows, which apparently exercised some bugs in
common code with other platforms -- so some fixes are going to benefit to
everyone even though the bugs did not manifest themselves as often.

Improvements:
- Increased default and max for "max_leaves" to account for modern systems.
- Pulled latest translations from transifex.
- Updated GeoIP databases.

Bug Fixes:
- Fixed memory leak on the error path of OOB / G2 query hit sending.
- Fixed memory leak on the file upload path.
- aging_insert(): was not properly handling freeing of keys, causing leaks.
- Fixed property description message for "max_leaves".
- Windows: no HEAP_NO_SERIALIZE flag on HeapAlloc() since we're multi-threaded.
- mingw_valloc(): fixed monitoring of unreserved VM space.
- Windows: optimized the inital VM space reservation.
- rpc_delay(): avoid int overflowing, which would make delay negative!
- node_udp_sr_data_ind(): do not crash if UDP was disabled or port was 0.
- Fixed crashes in the omalloc() layer.

Under the Hood:
- Make sure an initial GMT offset is computed before the time thread starts.
- Compact the aging structure on 64-bit platforms.
- Fixed possible race between evq_trampoline() and evq_event_discard().
- Added safety assertions: a removed item must belong to the list.
- Fixed typos in safety assertions.
- EVQ: closed race condition betweeen queues recreated in same thread ID.
- Use getrlimit(RLIMIT_AS) to get the available space, not RLIMIT_DATA.
- Windows: try harder to compute a relevant break value with sbrk(0).
- Windows: added cpp trap for dup().
- Windows: fixed fcntl(F_DUPFD) implementation which was not thread-safe.
- Windows: dump symbolic PC on stack overflows, after basic information.
- elist_remove(): assert that removed item must be part of some list.
- evq_event_discard(): be quiet when removing event for the event queue thread.
- evq_event_discard(): correctly handle cancelable events.
- evq_trampoline(): factorize removal of triggered item from queue list.
- evq_trampoline(): fixed logging message to use copied value.
- getgateway(): on Linux, cache previously computed value in case netlink fails.
- getgateway(): on Linux, the netlink socket can return EAGAIN on recv().
- main_command_line(): optimized and simplified!
- malloc_init_vtable(): be sure to set G_SLICE=always-malloc on Windows.
- mingw_exception(): skip printing of stacktrace if we got a stack overflow.
- mingw_getrlimit(): implement a better RLIMIT_DATA query.
- mingw_getrlimit(): return different max / current values to account for usage.
- mingw_signal(): always record signal handler in our internal list of handlers.
- mingw_valloc(): don't complain about non-hinted allocations when crashing!
- mingw_valloc(): use s_minicarp() to limit resource consumption.
- mingw_valloc(): when nearing out-of-memory, take data segment into account.
- mingw_vmm_init(): accelerate initialization, reducing amount of system calls.
- mingw_win2posix(): handle 0 to avoid warnings when called with no error.
- mingw_win2posix(): mapped ERROR_BAD_EXE_FORMAT to ENOEXEC.
- mingw_win2posix(): mapped ERROR_NETNAME_DELETED to EHOSTUNREACH.
- mingw_win2posix(): use s_minicarp() instead of s_warning() to see "culprit".
- omalloc_allocate(): was releasing spinlock too soon in read-only mode.
- omalloc_chunk_allocate_from(): fixed bug when header dissolution was required.
- publisher_handle(): simplified code by factorizing shared_file_unref() call.
- s_minicarp() and s_minicrit(): carefully avoid stdio when dumping stack.
- sdbm_close(): ensure we sync pending dirty data when database is not volatile.
- sdbm_name(): return path to the .pag file if no name was explicitly given.
- settings_init(): when computing max VM space, use max from RLIMIT_AS, not cur.
- socket_create_and_bind(): on Linux systems, force SO_REUSEADDR before bind().
- sort-test: reduce verbosity by default.
- thread_suspend_others(): silently suspends itself if concurrently asked to.
- udp_sched_write_error(): don't dump a stack trace on send errors we expect.

# v 1.1.5   2015-10-08  [stable]

This is a bug-fixing release.

Most of these bugs were discovered by investigating why gtk-gnutella was
frequently crashing on OS/X platforms.  Why other platforms were not having
the same problems remains a mystery, since all these bugs were not specific
to OS/X, apart from the vmm_munmap() bug -- since mmap() is only used on
OS/X due to its lack of the sendfile() system call.

One of the fixed bugs could lead to a crash when the network connection was
broken (e.g. a cable unplugged or a WiFi connection terminated).

Improvements:
- UHC: re-engineered the random choice of UHCs in the pre-established list.

Bug Fixes:
- qrt_patch_compress_done(): fixed race with qrp_comp_done().
- xmalloc: prevent deadlock when freeing deferred blocks on the allocation path.
- pmap_remove_from(): protect from exceptional corner case to avoid crash.
- ut_frag_pmsg_free(): don't requeue an unsent message synchronously.
- VMM: fixed race condition in vmm_munmap() that could lead to failures.
- omalloc: fixed chunk management when memory alignment is required.

Under the Hood:
- well_state_discard(): fixed missing indexing of array pointer.
- thread-test: avoid mixed output by using atomic I/Os to stderr for messages.
- thread-test: main testing entry points now clearly flagged in output.
- signal_trampoline(): be verbose and lenient when our pre-condition fails.
- evq_event_discard(): fixed message to log the name of the registering thread.
- hash_list_lookup(): was mistakenly returning a const value.
- thread_private_set_extended(): ensure a NULL free routine clears any old one.
- crash_mode(): removed redundant call to thread_suspend_others().
- rand31_random_seed(): avoid popcount(), prefer modulo with a prime number.
- hash_offset_init_once(): avoid entropy_minirand(), causes dealocks on Windows.
- uhc_send_ping(): if we cannot contact selected UHC, try with another one.
- omalloc_chunk_*protect(): ensure chunk is consistent with page boundaries.
- More assertions in omalloc() to ensure we're not corrupting memory.
- Use global mutex to protect symbols_xxx() calls, simplified stacktrace code.
- Reduced UHC retry time from 1 hour down to 3 minutes.
- Revised UHC list.
- More thread-safe refactoring for other stringification routines.

# v 1.1.4   2015-09-09  [stable]

This release is mostly a bug-fixing release.

One major bug (leading to crash) was found in the G2 frame parsing layer: a
carefully crafted G2 packet sent to GTKG could crash it, leading to a Denial
of Service.  For that reason, an upgrade to 1.1.4 is strongly recommended.

The only major new feature is the added cleanups of the TTH cache and the
crash log directory, to make sure we do not keep useless files on the disk
forever.

Because the Phex servent is no longer maintained, there is now a workaround
for that particular servent to ensure it can correctly download from GTKG.

Improvements:
- [GTK2] Added tri-state column sorting in "property editor" preference pane.
- [GTK2] Show icon + warning message when we have no TCP listening socket.
- Added an "install-strip" target to all Makefiles to install with stripping.
- Can no longer edit properties flagged as "internal" through shell or GUI.
- Added new "session_start_stamp" property to hold the true starting time.
- Added support for TTH cache cleanup.
- Added automatic cleanup of the crash log directory.
- New shell command "random stats" to display the statistics on random layer.
- Workaround for Phex: always send X-Gnutella-Content-URN in upload replies.
- Updated GeoIP database.

Bug Fixes:
- upnp_natpmp_discovered(): detect when UPnP layer was shutdown and abort.
- Fixed bad definition of XXTEA key, which led us to use only its first 4 bytes.
- node_g2_read(): need to only read 3 bytes usually to determine frame length.
- thread_sp(): tweaked to defeat gcc 5.x optimization leading to a NULL return.
- File moving: notify main thread as soon as file is completely copied.
- update_available_ranges(): lack of X-Available means file is full on server.

Under the Hood:
- Windows: added getppid() and statvfs() emulation, plus rmdir() support.
- Improved the unpredictability of our random numbers.
- Loudly warn if attempting a file-descriptor operation on a revoked descriptor.
- Added compat_sendfile() with fallback to emulated version when necessary.
- Added compat_statvfs() for portability and code simplification.
- File moving operations now use sendfile() if available.
- XFMT: made it loudly clear that comment nodes are ignored for now.
- VMM: when debugging, trace large allocation spots.
- VMM: raised maximum page cache lifetime from 3 to 15 minutes.
- page_cache_find_pages(): treat user memory as if under short-term strategy.
- filepath_basename(): optimize code when G_DIR_SEPARATOR is '/'.
- Optimized CMP() to avoid branching regardless of the arguments.
- Added ftw_foreach() to traverse a file system and process each entry.
- mingw_readdir(): do not change errno if it was left untouched by _wreaddir().
- Let mingw_{opendir,readdir,closedir} use normal types, not generic ones.
- mingw_stat(): added workaround for trailing "/" or "/." in paths.
- etree_traverse_internal(): minor optimization to avoid trailing +1 each time.
- Added etree_sort() and etree_sort_with_data() to sort children of all nodes.
- Changed signature of decoding base16 and base32 routines.
- Regenerated Configure to fix the fdopendir() compile test.
- Make sure pointer hashing distributes its trailing bits evenly.
- elist_merge_sort(): don't update tail, just do one single pass at the end.
- vmm_dump_pmap_log(): copy pmap data, then process dumping without locks.

# v 1.1.3   2015-04-08  [stable]

This is mainly a critical bug-fixing release, addressing a huge shortcoming
in 1.1.2: all Shareaza leaves are incorrectly flagged as being fakes and are
being removed quicktly from ultrapeers, creating network churn and instability.
Everyone running gtk-gnutella as Ultrapeer must upgrade to 1.1.3 quickly.

Releasing quickly after 1.1.3 is also a pretext for improving stability on
Windows platforms, especially after restarts: because Windows does not support
the "close on exec" flag on file descriptors, restarted processes were left
with several instances of a listening socket bound to the same port, causing
havoc as behaviour is totally undefined and was most probably leading to the
inability for the process to get any incoming connections.

On Windows, we now also monitor the memory usage more closely, in order to
avoid the C runtime from issuing a (blocking) popup signalling a fatal memory
allocation error should it run out of space.

More generally, the VMM layer is now capable of trapping fatal memory
allocation errors and handling them more efficiently.  In particular, when
everything has failed, the layer can request a brutal restart of the process.
Under less dire circumstances, a graceful restart will be requested.

This was also an occasion to revisit the long-term allocation strategy in
the VMM layer and optimize it in order to further limit fragmentation of
the VM space.  Even though avoiding fragmentation matters mostly for 32-bit
applications, this also limits the amount of individual memory region mappings
the kernel has to maintain and gtk-gnutella has to keep track of.

Finally, a last-minute bug fix where a user reported a deadlock in the QRP
processing code.  After investigation, it turned out that there was indeed
a recursive locking on a spinlock that had escaped all real-life testing out
there so far!

Improvements:
- [GTK2] Added popup menu icon in front of "force push mode" for sources.
- [GTK2] Added warning icon in status bar when kernel runs short of net buffers.
- Increased default node connection timeout and size of the quick connect pool.
- Updated the shell "status" command to display "!IP" on net buffer shortage.
- Updated FAQ along with French and Turkish translations.
- Updated GeoIP databases.

Bug Fixes:
- Fixed invalid test for "fake" Shareaza that led to network instabilities.
- Made QRP lock a mutex to allow for recursive locking through qrp_comp_done().

Under the Hood:
- On out-of-memory conditions, attempt to auto-restart if possible.
- Windows: monitor committed memory, crashing before the kernel would kill us.
- Added crash_restart() and controlling routines to request smooth restart.
- On network buffer shortage (ENOBUFS), stop TCP connections for a while.
- UPnP: protect upnp_mapping objects given to callbacks with reference counts.
- Adjusted lock tracking when locks are disabled, fixing lock swapping.
- Windows: remember socket descriptors so that we can close them on exec().
- Refactored code for listening sockets to warn when bound port is already used.
- When shutdowning in "crash mode", skip most of the memory cleanup.
- rwlock_destroy(): make sure to write-unlock the lock if it was owned.
- waiter_ack(): don't panic if waiter was not notified, but loudly complain.
- upnp_map_natpmp_publish_reply(): trace given port on NAT-PMP mapping errors.
- upnp_discover(): force selection of IPv4 interface for UPnP discovery.
- thread_unsuspend_others(): relaxed hard assertion into a soft one.
- alloc_pages(): try harder on OOM conditions to allocate from the page cache.
- socket_connect_finalize(): fixed wrong errno processing for connect().
- socket_connect_prepare(): no need for SO_REUSEADDR for connecting sockets.

# v 1.1.2   2015-03-21  [stable]

This is mainly a bug-fixing release, addressing rare crashes that have been
happening in production.  It also contains several improvements.

It fixes a user-reported bug whreby it was not possible to properly configure
the download paths using the GUI -- that led to application crashes due to
the incomplete support for discovered threads (which GTK is using underneath
to manage the dialog box).

Another bug was caused by the HTTP header parsing logic which did not allow
"." in header names.  That made it refuse to parse headers sent by some UPnP
devices, such as "BOOTID.UPNP.ORG" or "CONFIGID.UPNP.ORG", prevening UPnP
mappings from being installed.

Hapening rarely but still annoying, there was a bug on the error handling path
of write errors to the TX network stack, leading to assertion failures in
the mq_tcp_putq() routine.  That was because the qrt_compressed() routine
was not handling task cancellation properly.  The likelyhood of hitting that
bug when running as a leaf node was very low.

On the improvement side, the search list is now highlighting searches for
which we have associated downloads by displaying the text in green.  Further
tweaks were made to our GTK2 code to make sure the changes are reported "real
time" when the state changes, which was not always the case before (one needed
to go over a search by explicitly clicking on it to update the display in
the search list).

The SHA1 computation code was also further optimized to be as fast as possible,
reducing file hashing time by two!  Since SHA1 hashing happens regularily
in gtk-gnutella to collect entropy, optimizing the SHA1 computation affects
more than just file verification.

Improvements:
- [GTK2] Added translation URL in the "About" GUI dialog.
- [GTK2] Highlight searches with registered downloads by using green text.
- [GTK2] Added tri-state column sorting to the "upload history" panel.
- FAQ: added new entry explaining how to get the magnet of a shared file.
- Map the "collection" G2 query tag to the Windows / Linux "archive" file set.
- Map the "torrent" G2 query tag to the "torrent" file set.
- Added support for "rom", "wordprocessing" and "subtitle" G2 query media types.
- Further optimized SHA1 computation, now going about twice faster for files.

Bug Fixes:
- page_cache_insert_pages(): fixed incorrect write-lock upgrade logic.
- pmap_insert_region(): must recompute insertion index if we extend the pmap!
- tmalloc: fixed thread magazine accounting in the depots.
- Did not commit back to database after updating the DHT key request count.
- routing_chunk_move(): must check messages carefully when chunk was moved.
- route_message(): beware of check_duplicate() which can remove the node.
- thread_element_matches(): pay more attention to discovered threads.
- thread_find_tid(): skip thread elements not marked as being valid!
- node_shutdown_mode(): must correctly account for shutdowning G2 nodes!
- bogons_changed(): forgot to close opened file descriptor
- upload_stats_load_history(): added missing break in switch.
- qrt_compressed(): was not handling QRP compression task cancellation properly.

Under the Hood:
- Added hostile ranges.
- Updated GeoIP databases for IPv4 and IPv6.
- Throttle the amount of PUSH messages we can send for a given remote server.
- Legitimate Shareaza nodes cannot be flagging themselves as ultrapeers.
- Windows: stack unwinding made safer with more memory checks to avoid faults.
- UPNP: attempt rediscovery of port mapping devices every hour, if missing one.
- UPNP: attempt rediscovery of port mapping devices every hour, if missing one.
- Added new TSIG_OVFLOW signal sent when a thread overflows its stack.
- Fixed race condition between concurrent waiter_refcnt_dec() calls.
- Added logging of layer which reports a TX error in case of assert failure.
- Track the last seen time (activity) of discovered threads other than main.
- Prevent glade-2 from outputting support files now, since we patched them.
- Added tracing of funny X-Falt lines we are seeing when demsh_debug is set.
- Added tracing of funny X-Alt lines we are seeing when dmesh_debug is set.
- Added tracing of funny X-Nalt lines we are seeing when dmesh_debug is set.
- Added crash hook for the thread layer.
- Added TX layer write-fault mechansim to help detect user error handling bugs.
- Syntaxic adjustments to make the latest guile happy with definitions.
- The GUI will now display current bandwidth by default, instead of the average.
- mingw_exception(): write shorter messages in case of stack overflows.
- thread_element_reset(): forgot to reset te->stack_base to NULL.
- header_append(): allow "." in header names.
- thread_join_internal(): no thread_cancel_test_element() on foreign thread!
- thread_find_element(): avoid leaving routine without unlocking mutex!
- cond_wait_until(): now correctly handle underlying cond variable mutation.
- thread_block_timeout(): don't panic if main thread already unblocked.
- dir_entry_filename(): made the Windows version thread-safe.
- hfield_dump(): fixed formatting of continuation lines.
- dmesh_collect_locations(): only parse the last timestamp when many given.
- xmalloc_thread_free(): always handle blocks in the cross-thread free list.
- Hide strtok_free(), forcing clients to use new strtok_free_null().

# v 1.1.1   2014-09-02  [stable]

This is mostly a bug-fixing release.

Improvements:
- Share Opus files by default, added opus and webm to search filters.
- No longer automagically unshare directories that do exist currently.
- Revamped peek/poke functions because GCC generated unoptimized code for these.

Bug Fixes:
- Avoid crash when we cannot parse the remotely supplied push-proxy URL.
- Fixed crash when entering "local:" as search term.
- Fixed crash when gtk-gnutella was stopped from terminal and put to background.
- Fixed crash on "Reverse DNS lookup" queries from the GUI node pane.
- Fixed GtkSpinButton "adjustment with non-zero page size" deprecation message.
- Handle G_SEARCHPATH_SEPARATOR in shared base directory correctly.

Under the Hood:
- shared_file_get_index(): fixed lower boundary of assertion.
- fi_find_aggressive_candidate(): prevent division by 0 if no starving download.
- Fixed possible race condition between bg_task_wakeup() and bg_sched_sleep().
- Regenerated Configure to allow BFD library detection for newest versions.
- teq_post_rpc(): use linearily increasing timeouts to limit logging.
- str_vncatf(): made recursion checks before calling s_minicarp() thread-safe.
- ut_frag_pmsg_free(): avoid SIGSEGV when fragment was already acknowledged.
- deflate_add(): refuse further data when the TX deflate layer had an error.
- search_dequeue_all_nodes(): must also iterate on G2 nodes.
- cq_heartbeat(): only log delay adjustements when running with cq_debug > 0.
- g2_node_handle(): silence warnings when not debugging.
- Allow xfl_find_freelist_index() to work with gcc 4.9 and optimizations.
- keys_offload(): do not process if the key layer was shutdown.

# v 1.1.0   2014-07-02  [stable]

This is a major release introducing new features and making gtk-gnutella
a multi-threaded application with drastic performance boosts for background
tasks like file hashing or library rescanning.

Another major feature is the added support for the G2 search protcol: we are
connecting to G2 hubs as a leaf, answer to search / browse requests from G2
hosts.  We also use G2 to issue our own searches.  Finally, we freely exchange
files with G2 hosts (downloading and uploading).

The G2 protocol was further extended to make sure G2 query hits convey as
much information as Gnutella query hits, in particular for alt-loc propagation
and TLS support.  The G2 semi-reliable UDP layer is also leveraging the new
features designed for the corresponding Gnutella layer (cumulative and extended
acknowledgments), gracefully falling back to legacy features if the remote host
is not able to understand the new features.

A critical bug was fixed: reception of carefully crafted invalid DHT messages
would lead to an immediate crash, an open door for Denial of Service (DoS)
attacks.  That bug has been present since 0.97 (release of August 2011).

Last but not least, the code base has now been checked by Coverity.  There was
a very low defect rate of 0.26 (amount of true defects per thousand lines
of code) and all problems were fixed.

New Features:
- Multi-threading support (file hashing, library rescan, DNS, etc...)
- Added support for the G2 search protocol, connecting as leaf mode to G2.
- Turned gtk-gnutella into a random number server through the "random" command.
- Removed Bitzi support since the service has shutdown.
- Added the --no-dbus command-line option to prevent D-BUS notifications.
- [GTK] Added GUI enabling of the G2 protocol for searches.
- [GTK] Added spin-button to set the amount of G2 hub connections to maintain.
- [GTK] Report amount of G2 hubs to which we are connected.
- [GTK] Show amount of G2 host browsing served, in the upload stats pane.

Improvements:
- [GTK2] Added tri-state column sorting to "Downloads" and "Uploads" panes.
- Better entropy collection to initialize the pseudo random number generators.
- Externally visible randomness (e.g. GUIDs) is now cryptographically strong.
- We now pick random DHT nodes to send back from the whole routing table
- Some entropy collected is persisted, for better reseeding in next session.
- Added time change detection when switching from/to Daylight Saving Time.
- QRP query routing now uses LimeWire's logic, less strict than the GTKG one.
- The shell "status" command now reports the amount of G2 hub connections.
- Detect OOB proxy MUID conflicts for leaf queries.
- Added the "stats drop" shell command to show dropped message statistics.
- Improved random selection of files being matched in the library (local hits).
- When a PUSH request fails to connect back, ban target IP:port for 5 minutes.
- Configure: correctly detect the BFD library even if no -liberty.
- Crash handler now records and logs the ID and name of crashing thread.
- Updated gtk-gnutella.appdata.xml to the latest specifications.
- Updated the FAQ, along with translations to French and Turkish.

Bug Fixes:
- DHT bucket merging was incorrectly handling removal of nodes from table.
- Reception of improper DHT messages could lead to an immediate crash (DoS).
- ut_frag_pmsg_free(): rescheduling of expire event was in wrong block.
- base16_encode(): would cause buffer overflow when destination too small.
- Rotate OOB token keys less often, to avoid expiration whilst in transit.
- socket_udp_event(): ignore empty datagrams.
- Fixed host cache updates to avoid setting "out of bounds" property values.
- hcache_find_nearby(): was missing a "break" in the case for HOST_GUESS.
- Scheduled static checking by Coverity, found 81 problems requring a fix.
- Fixed TCP message size computing bug, which could corrupt the TCP stream.
- Configure: fixed endianess detection of IEEE-754 floats on Solaris.
- Was never configuring TCP quick ACKs due to a missing "break" statement.
- omalloc() could crash when configuring read-only objects.
- Ensure we never insert any "unusable host" in the push-proxy set.
- keys_update_value(): forgot to persist back updated expiration timestamp.
- Properly flag UDP route as deflatable when GGEP "Z" is seen in queries.
- Flag UDP route as supporting semi-reliable UDP when query flags are parsed.

Under the Hood:
- GUESS now avoids querying hosts to which we are connected via TCP
- GUESS: count the amount of hosts reached by query, since G2 queries a cluster.
- GUESS: increased cached lifetime of query keys to a little less than 1 day.
- GUESS: defer hosts we cannot requery to avoid constantly looping over them.
- GUESS: fixed host atom leak when message is synchronously dropped.
- GUESS: invalidate cached query keys on IP or listening port change.
- Added a thread management layer on top of the POSIX thread layer.
- Added support for safe inter-thread signals, handled by our thread layer.
- Expanded the set of atomic operations we can perform.
- Added read-write locks, now used by the VMM layer.
- Addded multi-threaded goodies: barriers, dams, event queues, cond variables.
- VMM: closed race condition during allocations.
- Added support for permanent thread-private data.
- Added primitive fork() handling in a multi-threaded environment.
- Made float formatting code thread-safe, removing need for funnelling.
- The ADNS now always runs in a separate thread.
- Provide both thread-private (hashtable) and thread-local (array) variables.
- Added new "thread list" shell command to monitor running threads.
- Added "task list" shell command to list currently defined background tasks.
- Added the "thread stats" shell command to dump thread statistics.
- Added "lib show callout" shell command to display callout queue information.
- Added "lib show files" to show opened files via file_object_xxx().
- Made sure PROTECT_ATOMS and ATOMS_HAVE_MAGIC are orthogonal settings.
- Moved the reference count of atoms to the tracking hash table.
- Callout queue runs the idle callbacks if not scheduled in the last 30 secs.
- Logging timestamps are now emitted with a millisecond accuracy.
- Improved g_assert_not_reached() to propagate the routine name as well.
- Re-architected file_objects to allow permission checking on opened files.
- Introducing tqsort(), a multi-threaded quicksort for sorting large arrays.
- Do not mark SIGPROF as harmful to allow profiling.
- Added a thread-magazine allocator, used by walloc() and vmm_alloc().
- Allow execution of some shell commands in a separate thread.
- Added our own plain one-way and two-way list implementation.
- Added optimized item freeing for embedded lists holding walloc()'ed objects.
- Added thread-local ARC4 random streams for increased throughput.
- Added global and per-thread WELL and CMWC random number generators.
- Added Fortuna-like algorithm (AJE -- Alea Jacta Est) for gathering entropy.
- Added support for fixed-size hash tables, entirely held in a static buffer.
- hash_table_replace(): optimized to avoid two hash_table_find() calls.
- Protect query hit generation against concurrent library rescans.
- No longer close all file descriptors in main, since threads use them.
- Semi-reliable UDP: only send last fragment of large message to unknown hosts.
- Semi-reliable UDP: make sure remote side is ACK-ing sent fragments only.
- Semi-reliable UDP: avoid endless loops if unsent ACK message is dropped.
- Semi-reliable UDP: added TX accounting for dropped and physically sent ACKs.
- Semi-reliable UDP: was not releasing data structure for dropped ACKs.
- QRP support for generation of 1-bit patches, and optimized 1-bit handling.
- make_room_internal(): removed bug catcher from 2006, which never triggered.
- Cleaned up Gnutella handshaking to emit an Accept if the remote sent one.
- search_results_process(): do not record last hop as hostile on relayed hits.
- Do not attempt to OOB-proxy queries in search_request()!
- host_timer(): fixed wrong cut-off by "quick connect pool".
- Added script to auto-generate enums along with symbolic and English text.
- options_parse(): fixed parsing of values immediately following the option.
- Shuffling of large arrays now performed using PRNGs with greater period.
- Renamed "struct mutex" as "struct lmutex" to avoid conflicts on Solaris.
- st_search(): randomly shuffle results only when we have more than we can send.
- Windows: added emulated clock_gettime() and clock_getres().
- Dispatch entropy to PRNGs only once every 30 seconds at most.
- Simplified rand31(), restoring its full period, and redesigned rand31_u32().
- sdbm_rebuild(): was not properly catching errors during copy.
- prop_get_def(): switched to HCOPY_ARRAY() to avoid any size problems
- kmsg_handle(): avoid dereferencing a potentially NULL pointer.
- route_max_forward_ttl(): take a reference instead of a by-value parameter.
- parq_upload_remove(): fixed assertion, which was always evaluating to TRUE.
- Report errors if we cannot set a file non-blocking or request close on exec().
- Base32 decoding could fail spotting bad input due to short base32_map[] array.
- search_matched(): was not counting the amount of skipped results in a search.
- getgateway(): properly fallback to netstat parsing when socket() fails.
- roots_fill_closest(): avoid memory leak on the error path.
- Fixed UDP TX schedulers to allow both IPv4 and IPv6 message sending.
- Make sure only developers will use autogen to regenerate the property files.
- dh_route(): only compress UDP query hits when GUESS queryier supports them.
- dh_route(): do not attempt UDP compression if message sent via reliable UDP.
- Count UDP compression attempts and failures, including in semi-reliable UDP.

# v 1.0.1   2013-12-31  [stable]

This is a minor release correcting a grave bug causing gtk-gnutella to think
all other gtk-gnutella out there are hostile.

Other minor improvements are present, as well as low-level bug fixes.  The
most visible change is that filenames with parentheses are now mangled to
have the parentheses turned into brackets, instead of being left as-is.  This
allows filename cut-n-paste into shell commands, without having to use the
shell auto-completion to escape the parentheses.

Improvements:
- Generate a NM/1.0 HTTP-like header at the top of the pre-computed nm list.
- [GTK] Avoid GUI flickering when widget sensitivity is changing quickly.
- Replace "()" with "[]" in filenames for easier cut-n-paste in shell commands.
- Windows: improved stack unwinding.

Bug Fixes:
- Fixed grave bug, making all GTKGs appear hostile.
- qrp_close(): must disable periodic monitoring during shutdown.
- filename_to_utf8_normalized(): fixed broken if/else logic in loop.

Under the Hood:
- Updated the GeoIP databases.
- Added a Keywords entry for lintian in the gtk-gnutella.desktop file.
- Fixed license link to point to GPL-2 on Debian systems.
- Added gtk-gnutella.appdata.xml for distributions that need such a file.
- Renamed icon.xpm as icon.48x48.xpm and icon.32x32.xpm as icon.xpm.
- TLS: disabled SVN signature verification code, since we no longer use SVN.
- Define our own G_STRFUNC, do not use the version from GLib.
- vmm_resize(): fixed wrong implementation when vmm_crashing is true.
- Semi-reliable UDP: drop traffic to host temporarily if we can't send messages.
- Use a 5-minute TLS ban to avoid reconnecting to host with TLS when it failed.
- download_mark_active(): do not reset fi->recv_last_rate on HTTP follow-ups
- bsched_heartbeat(): fixed wrong delay computatation, use tm_elapsed_ms().
- gtk_gnutella_exit(): always emit final "cleanly exited" info.
- zalloc_stack_accounting_ctrl(): used wrong lookup key, leading to crashes.
- mingw_valloc(): handle initial non-hinted allocations larger than page.
- signal_trap_with(): fixed improper return value computation for sigaction().

# v 1.0.0   2013-09-01  [stable]

This is a major release correcting a few bugs and adding small but interesting
features such as the ability to limit dropping of received UDP messages,
making the DHT keys and values persistent across sessions, SDBM file
auto-compaction at startup, and last but not least, rarest-chunk downloading
to optimize download efficiency when facing partial sources.

New Features:
- Let users define a maximum lease time for UPnP and NAT-PMP mappings.
- Made DHT keys and values persistent across sessions.
- When there are partial sources for a file, download the rarest chunks first.

Improvements:
- [GTK1] Optimize massive updating of the download source list.
- [GTK] Dynamically update the list of available chunks in the file (blue line).
- Files used to persist information across sessions are now auto-compacted.
- The UPnP layer can now monitor more types of Internet Gateway Devices.
- After unclean shutdown, rename existing core file in crash directory.
- Detect servers that choke when receiving pipelined HTTP requests.
- Added the Mersenne Twister Pseudo-Random Number Generator.
- Remember when user requests an auto-restart, to keep the same session going.
- Increased maximum download buffer size to 1 MiB and default to 128 KiB.

Bug Fixes:
- [GTK2] Set height of the pref/upload window (paths to files) to 100 pixels.
- [GTK1] Fixed wrong enum value usage (c_fi_sources instead of c_src_num).
- [GTK] Download source details were incorrect sometimes for queued downloads.
- [GTK] Reserve display of partial file indication (PFS) to partial sources.
- DHT traffic accounting was broken when semi-reliable UDP was introduced.
- Was wrongly keeping orphan DHT contacts and removing alive ones!
- Fixed wrong restarting DB key computation for DHT values (preventing crashes).
- Fixed improper "good" alt-loc flagging from uploaders, leading to wrong mesh.
- Fixed English typos in comments and user-visible messages.
- Avoid selecting the magic fw-fw file index for partial files in query hits.
- Fixed wrong propagation of duplicate messages with higher TTL.

Under the Hood:
- Fixed posix_memalign() so that we can now run with glib 2.36 and upwards.
- [GTK] Update available ranges when the core sends a "range changed" event.
- Added UDP datagram read-ahead to minimize local kernel drops (RX queue full).
- Added UDP read-ahead statistics.
- Ensure "DHT values" and "DHT raw data" SDBM files are consistently reloaded.
- Fixed omalloc() memory usage accounting.
- str_at(): fixed harmful typo causing it to seg-fault with negative offsets.
- Do not send X-Features / X-Token on follow-up HTTP requests.
- upnp_dscv_probed(): plugged memory leak.
- UPNP: extract the Service Control Protocol Definition (SCPD) URL.
- UPNP: monitor gateway with GetStatusInfo() if no GetTotalPacketsReceived().
- Some UPnP devices can advertize an API and yet return 401 (action invalid).
- bigkey_hash(): more robust in case we encounter a big key and support is off.
- udp_sched_write_error(): don't panic if we get an unexpected UDP write error.
- Jumbo patch: replaced most gm_[v]snprintf() with str_[v]bprintf() calls.
- Count truncated incoming UDP messages.
- http_got_header(): fixed harmful typo causing mishandling of chunked output.
- After 3 X-Nalt reports, move source from download mesh to the banned mesh.
- Leave banned entries in the bad mesh for at least 5 minutes.
- cq_free(): release mutex to prevent loud warning a shutdown time.
- When the the crash handler child fails, append decorated stack from parent.
- download_data_received(): extend fileinfo when file size is unknown.
- Moved HTTP range parsing / handling from core to library (re-architectured).
- Benchmark sorting routines at startup and select the most efficient.
- socket_udp_flush_timer(): do not process queued datagrams during shutdown.
- Make rand31() more random, especially on the low-order bits.
- Added computation of chi-squared cumulative distributions.
- Made entropy_random() 5 times faster on average.
- Prefer random_value() over random_u32() followed by bit masking.
- The random layer now uses the Mersenne Twister, excepted for random_bytes().
- hash_keyset_lookup(): was not always spotting first tomb correctly.
- Let small hash tables be denser than larger ones.
- Tweaked hash tables and derivatives for smaller memory footprint.
- guess_pmsg_free(): make sure pool does not contain host before adding it back.
- http_send_status(): was not properly detecting too large HTTP headers.
- Semi-reliable RX UDP: re-ack everything well before the whole message expires.
- Adjust maximum DHT value count per IP/network dynamically with DHT size.
- Be careful when truncating body on an HTTP kept-alive connection.
- ensure_unicity(): assume pidfile is locked when lock owner bears our PID.
- Added protection when writing important files on filesystems like "ext4".
- PARQ: accept to move an upload to the "dead" queue even if we wait for QUEUE.
- Made GTK2 the default GTK version since GTK1 is not 64-bit safe.

# v 0.98.4   2012-11-04  [stable]

This is an important release correcting severe bugs affecting the overall
wealth of the system: the PARQ upload queue was not properly restored, the
DHT was not always sending correct values back (resulting in failed lookups),
and SDBM (our hash-on-disk database) had two well-hidden bugs that could cause
crashes at startup or that compromised regular runtime operations.

This release also introduces an interesting improvement: we are now using a
reliable UDP layer to transfer out-of-band query hits, ensuring that these
important messages are properly sent and received and never lost.

The SPAM-detection on query hits received via UDP was too eager to discard
results from perfectly valid sources, causing improper loss of results from
your queries.

We were also wrongly sending out more queries than necessary: a long-standing
bug caused locally-issued OOB-proxied queries to be re-emitted a second time,
and we were re-forwarding duplicate queries (received with higher TTL than
before) to all the leaves.  Although not harmful, these two bugs were wasting
some of the outgoing bandwidth when running as a ultra node.

New Features:
- Plugged support for "OOB Proxy Veto".
- Added a Semi-Reliable UDP layer for Gnutella for safe OOB hit delivery.
- Report and display available file size when handling hits for partial files.

Internationalization:
- Added French and Turkish translations of the FAQ.
- Updated French and Turkish translations.
- Fixed typo in a German translation.
- Cleanup of the English FAQ, updating obsolete answers.

Improvements:
- [GTK] Show different icon and tooltip when port mapping done through NAT-PMP.
- [GTK] Flag results from servents with a banned GUID in the "Info" column.
- [GTK] Windows version now compiled with GTK 2.24.10.
- Non-sharing servents can now be promoted to ultra peers (in automatic mode).
- Be stricter about vendor messages origin: ignore them if from wrong protocol.
- Strip GGEP "NP" key from relayed queries.
- Use higher-priority UDP messages for important or time-sensitive data.
- Use semi-reliable UDP to transfer critical data (query hits).
- Make sure the queries we OOB-proxy have a GGEP "SO" key for secure OOB hits.
- Ignore unsecure OOB hit promises from hosts known to support secure OOB.
- Use some of our connected ultra nodes when filling UHC pongs.
- Updated GeoIP databases.
- When resuming from crashes, do not stop session-only searches.
- Persist selected search media types from session to session.
- Report last modification time + available size of partial files in hits.
- Added "webm" and "zoo" to the list of file extensions that can be shared.
- Display unexpected command-line argument before usage output.
- The shell "status" command now shows how port mapping was done, if any.
- Do not forward "What's New?" queries to leaf nodes with empty routing tables.

Bug Fixes:
- Avoid segmentation fault if GUESS 0.2 cache is empty.
- Avoid SDBM crash when clearing database which had big keys/values present.
- Use signed arithmetic to compute compression ratios.
- Consider x.x.x.0 as a possibly valid IPv4 address.
- Was not correctly parsing the saved PARQ queue, causing undue forgetting.
- Fixed key accounting in DBMW.
- SDBM was sometimes not iterating over unflushed dirty LRU pages.
- Fixed wrong DHT value response message format.
- Fixed crash when attempting to browse host on a queued source.
- Do not route duplicate queries with higher TTL to leaves.
- Prevent sending of duplicate (locally issued) OOB-proxied queries.
- Fixed startup crash bug on Ubuntu machines.
- Changed the Debian menu icon to use the one which is 32x32, as lintian wants.
- Fixed auto-restart function on 64-bit Windows.

Under the Hood:
- [GTK] Darken the color used to display partial results (yellow -> dark gold).
- Various PARQ cleanup to smooth QUEUE callback operations.
- Fallback to pre-computed symbol file when loaded symbols are garbage.
- Relax file_path_set() and open_read() to gracefully handle relative paths.
- get_folder_basepath(): protect against unsuitable environment variables.
- Recompute the amount of banned fds dynamically as config parameters change.
- Detect series of unclaimed OOB hits from a host to ignore further queries.
- Changed MUID marking strategy in queries to better accomodate OOB proxying.
- Added a UDP TX scheduler to optimize datagram sending by priority.
- Enhanced the incremental zlib operations, reusing objects across operations.
- Added new official ISO 3166 country codes.
- node_read(): was wrongly resizing the message buffer for each message!
- Refactored aging table to lower memory footprint (by 6 pointers per entry).
- On Windows, keep last 3 stdout/stderr logs, created when launched from GUI.
- Send important UDP messages with a "control" priority.
- Count TCP push-proxy requests aimed at firewalled-to-firewalled connections.
- Patch UDP PUSH messages aimed at initiating firewall-to-firewall transfers.
- Count received PUSHes requesting FW-FW transfers, plus those targeting us.
- dht_init(): do not reset the KUID if DHT disabled at startup.
- Detect whether we are restarting after a clean shutdown or after a crash.
- bg_task_terminate(): don't panic at shutdown when handling unaccounted tasks.
- Reserve only about 40% of the available virtual memory space on Windows.
- Always discover port-mapping devices, even if they won't be used.
- Ensure reasonable TTL and hops for PUSH messages from UDP we will route.
- The shell "nodes" command now displays the gnet port along with the address.
- Added metaconfig check for malloc() superseding.
- New switch --disable-malloc added to build.sh to prevent superseding malloc().
- When launching gdb during crash, ask for threads and thread stacks as well.
- External IP changes were not waiting for 3 hosts in 3 different CIDR ranges.
- Removed too restrive permissions in the man page (COPYRIGHT section).
- Shell meta-chars in executable path do not prevent loading symbols via BFD.
- Added more DHT statistics.

# v 0.98.3   2012-06-04  [stable]

New Features:
- [GTK] Added per-search GUESS statistics line, which can be hidden by users.
- [GTK] Display amount of downloads associated with search in the search label.
- Added property to control usage of unused Gnutella bandwidth by GUESS.
- Added "memory check xmalloc" shell command to monitor the xmalloc freelists.
- On Windows, generate a gdb-like stack trace in the crash log file.

Improvements:
- [GTK] Optimized rendering of main statistics page.
- [GTK] Show more accurate message for queued downloads on completed files.
- Shell now displays properties with appropriate surrounding type markers.
- Limit pongs sent to transient nodes in order to save some bandwidth.
- Avoid sending too many pongs on uncompressed connections.
- Added README.Windows to document compile instructions for Windows.
- Avoid "write() failed: EPIPE" messages from the shell for local client writes.
- Added GUESS link cache size to the general statistics pane.
- GUESS now uses a dynamically computed outgoing bandwidth limit.
- Allow failed TLS connections to be retried without TLS, transparently.
- Added "-a" switch to the shell "version" command to display glib/GTK/TLS info.
- Added -p switch to the "stats" shell command to pretty-print numbers.
- Memory optimization of commonly used data structures to reduce footprint.
- Always generate a crashlog file, even when dumping a core.
- PARQ: switch actively queued download to another when file has been completed.
- Attempt to immediately restart download after failed SHA1 + TTH verification.
- At startup, compute TTH if available and SHA1 checking failed.
- When switching PARQ 1.0 downloads, switch IDs if queue position is favorable.
- Updated translation strings, and fixed French translation.

Bug Fixes:
- bug #3286824 "Crash at startup / 0.96.9 / FreeBSD AMD64"
- Fixed %G formatting bug whereby a zero following a dot would be missed.
- Prevent auto-restart when they explicitly request a shutdown.
- Fixed grave bugs in the virtual memory layer, some being Windows-specific.
- PARQ was not properly computing amortized per-slot time.
- Avoid random shell connection failures on Windows.
- An un-parseable token in a shell command led to an assertion failure.
- Fixed the "alignment optimized" code branch of msort_with_tmp().
- Fixed bad copy-n-paste that could lead to malloc() freelist corruption.
- Fixed GUESS corner-case crash when handling an RPC timeout.
- [GTK] Avoid crash when user clears the upload statistics (bug #3501181).
- On Windows, be smarter when reserving the initial amount of virtual space.
- GUESS: always wakeup sleeping queries if we have bandwidth.

Under the Hood:
- Improved thread-safety of the VMM layer.
- Removed perl4-ism in Perl scripts.
- Updated IPv4 and IPv6 geo databases.
- Attempt to drive a deadlock crash as far as possible to collect debug info.
- When logging from another thread (not main), include the small thread ID.
- Switched halloc() to xpmalloc() instead of walloc().
- Added thread-private zones for blocks <= 512 bytes for faster allocations.
- Optimized access to thread-private information, via a lock-free fast path.
- Exit with a zero status when terminating through a regular signal or request.
- Some UTF-8 optimizations and low-level fixes.
- Also log the faulting PC when we get a harmful signal.
- Use the BFD library, if available, to extract symbols from the executable.
- Restored ability to have usable stack unwinding on Windows.
- Extended crash log information to include full OS name and CPU architecture.
- Sort SHA1s in the search.xml file.
- Clear whole routing table when switching between Ultra and Leaf modes.
- Protect xfree() from algorithmic complexity when handling bursts.
- Added xmalloc garbage collector to reclaim fragments from freelist.
- Allow the "TLS handshake failed" string to be translated.
- Consider IPv4 addresses x.x.x.0 as non-routable.
- Now uses own hash table and hash set implementations.
- Strengthened entropy collection and ARC4 initial seeding.
- Randomly propagate GUESS 0.2 hosts among GUESS 0.2 servents.
- Assume we're not firewalled right after initial UPnP or NAT-PMP configuration.
- Avoid compiler warnings on Windows.
- Make sure random_value() returns uniformly distributed random numbers.
- Added ability to filter dumped traffic by IP address.
- Changed %F to display whole mantissa before switching to scientific notation.
- Ensure memory allocated from the heap is aligned properly.
- Show amount of detected CPUs at startup.
- Added version numbers to the crash log file name.
- Avoid complexity attacks on the hash table.

# v 0.98.2   2011-12-30  [stable]

This is a minor patch to support systems running latest Ubuntu systems,
and maybe others which create multiple threads for GTK programs: our
xmalloc() implementation replaces the system's malloc() but it was not
safe to use in multi-threaded environments.

GUI improvements:
- [GTK] Added option to discard results from banned GUIDs (set by default).
- [GTK] Display results from servents with a banned GUID in "hot pink".

Other improvements:
- Updated turkish translation.
- Added IPv6 geo-localization database (from Maxmind).
- Added dynamic IPv6 hostile support.

# v 0.98.1   2011-12-16  [stable]

This is a minor patch to support systems running glib-2.30.2 and above.

# v 0.98   2011-12-11  [stable]

This is a major release, adding "IPv6-Ready" features.  It also fixes
long-lasting bugs in various areas and contains some other low-level
improvements.

During the building of this release, Dennis MacAlistair Ritchie passed away.
Gtk-gnutella would not exist in its current form without the earlier work
of Dennis, the co-inventor of C.  This release is dedicated to the memory
of that great computer scientist.  Farewell, Dennis!

New Features:
- Added "IPv6-Ready" support.
- Enhanced the shell "memory" command to display various allocator stats.
- Added the "pid" and "version" shell commands.
- Added the "command" shell command to print the server's command line.
- Added -r option to "shutdown" shell command to request a restart.
- Added the --no-restart and --restart-on-crash gtk-gnutella options.
- Added the shell "date" command displaying ISO time with ms accuracy.

Improvements:
- Ignore Bitzi ticket timeouts on missing entries for explicit user retries.
- Added routing table statistics.
- GUI: show file creation times for local searches in the info summary.
- Optimized page cache coalescing by avoiding two successive binary lookups.
- Added -f option to "shutdown" shell command to initiate a fast shutdown.
- Allow "echo command | gtk-gnutella --shell" a chance to work on Windows.
- Ban duplicate GUIDs to avoid them being the target of PUSH requests.
- Updated French translation for 0.98.
- Revisited TX stack flow-control logic when there is a compressing layer.
- Don't send Hops-Flow messages to nodes not supporting it.
- Use full compression for ultra <-> ultra connections.
- Internationalization now works on Windows.

Bug Fixes:
- Fixed harmful cleanup of routing table when cycling over naturally.
- Fixed bug in add_file() when adding multiple partial files to a query hit.
- Fixed DHT lookup when path protection kicks in and clears the closest node.
- Fixed handling of relative position lists, causing unfair PARQ scheduling.
- Prevent preferences from being shown from tray icon when already shutdowning,
  fixing bug #3376952.
- Hide tray icon at shutdown time.
- Enabled loading of hostiles file on Windows.
- Fixed crash on mis-parsed IPv6 address.
- Make sure node is still connected before routing its queries.
- Avoid crashes when asked to deflate 0 bytes.
- Fixed dynamic querying to avoid duplicate messages to probed nodes.
- GUESS must forget about query if the query key was not correct.
- Do not send translated messages in node handshaking replies.
- dualhash_insert_key(): fixed insertion to avoid possible assertion failures.
- Avoid wrong "activity timeout" indications for ultra <-> ultra connections.
- Make sure we do not include "non-shareable" files in query hits.
- Fixed the "node add" and "node drop" shell commands.

Under the Hood:
- Fixed remote token validation for git versions.
- Count and report in statistics the amount of cached GUESS 0.2 hosts.
- Fixed improper message queue status computation (warn zone / delay).
- XML parser was not handling illegal byte sequences in UTF-8 buffers.
- Fixed creation time (GGEP "CT") to send actual filesystem creation time, not
  the filesystem last modification time.
- Enforce configured IP protocols, preventing connection to other protocols.
- Added malloc() replacement.
- Clear "last dmesh sent" timestamp in uploads when client switches resources.
- Construct build date from git's HEAD commit, if available.
- Added options to the "shutdown" shell command to trigger the crash handler.
- Propagate Windows exception information into the crash log.
- On Windows, propagate the PC at which the exception occurs in the crash log.
- Force "idle" tasks to be scheduled once in a while.
- Increased frequency of the main callout queue heartbeats by 4.
- Arrange for a crash log to be generated even when fork() fails.
- Loudly warn when string formatting leads to truncation of the message.
- Added regression tests for str_vncatf().
- Added floating point formatting routine from Robert G. Burger, allowing
  str_vncatf() to format floating point numbers natively.
- Added Windows startup debugging support and fixed Cygwin startup.
- Remap all g_xxx() logging routines to our own message logging layer.
- Added "update-potfiles" target to refresh the POTFILES.in list.
- Frozen PARQ upload queue slots don't count as "wanted" by the queue.
- Added "qhit_bad_debug" property to control logging of bad query hits.
- Stack unwinding routines now stop at the first non-text address they reach.
- Added dynamic memory usage statistics collection.
- Propagate self-assessed symbol quality into the crash log, if not good.
- Make sure we open all files in binary mode on Windows.
- Packaged regex 0.12 to supply POSIX regcomp() on systems lacking it.
- Raise the default number of allowed fds to 2048 on OS X.
- Added SDBM testing and benchmarking program.
- Don't publish NOPE entries in the DHT for nodes with a bad GUID.
- Added "tx_deflate_debug" and "tx_debug_addrs" properties.
- TX deflating layer can postpone Nagle flushing up to 2 seconds.
- Updated Geo IP database.

# v 0.97.1   2011-09-11  [stable]

This is a bug-fixing release, addressing critical bugs that slipped through
in the 0.97 release but which happen only in particular conditions.

The project also switched from SVN to git.  This affects the version number
which no longer includes a single SVN revision but instead uses the combination
of a counter for the number of changes since the last release plus git's
abbreviated commit ID.

Bug Fixes:
- Fixed bootstrapping problems on IPv6 enabled hosts [bug #3376322].
- Forgot to clear global HTTP handle on GHC errors [bug #376322].
- Typo caused crash when processing alternate locations in firewalled mode
  with PFSP enabled.
- Forgot to clear pending THEX downloads on download stops.
- Make sure we remove the SHA1 of de-indexed files from the shared set.
- Handle "message too large" errors when sending on UDP.

Under the Hood:
- When running as ultra node, use GUESS introduction pings when requesting
  a query key so that the remote ultrapeer can passively discover us.
- Do not count GUID collisions with our own GUID when we see our own IP:port!
- Added some gcc 4.6 "hot" / "cold" routine tagging for better optimizations.
- netmask_to_cidr(): was not using the proper metaconfig symbol to activate
  the usage of __builtin_popcount.
- Updated build.sh to build an app bundle for OSX with target=osxbundle
- Added "dmg" to the default extension list for shared files.
- Added OS X integration support: menu bar is now on the OS menubar on top,
  the application does a clean exit on cmd-q and the application continues
  to run when only the window is closed.
- Use the downloads folder on Windows 7 and Vista for completed downloads.
- Updated the geographic IP mapping database.
- Integrated spell check of the French translation from stegozor@gmail.com.
- Turned "zalloc_always_gc" to FALSE by default.

# v 0.97     2011-07-18  [stable]

This is a major release, fixing critical long-standing bugs and introducing
handy new features.  It is also the first stable release for Windows.

New Features:
- Added HTTP request pipelining.
- Added GUESS (Gnutella UDP Extension for Scalable Searches).
- Added the ability to look for specific media types.
- Added the ability to query for partial files as well.
- Added "What's New?" queries.
- Added smart search stopping / resuming options.
- Added command-line option --minimized; useful when auto-starting gtk-gnutella.

Improvements:
- Improved unpredictability of random numbers.
  Continuously collect new randomness from message events (RX, TX, dropping).
- No longer uses download overlaps as soon as we know the TTH of the file.
- When the download queue is auto-frozen due to lack of space, monitor the
  filesystem to auto-unfreeze when enough space is available again.
- Can configure different amount of limits for various kind of search results.
- [GTK2] Added missing configuration option for case-insensitive sorting.
- [GTK] Flag search results bearing an alien IP as such, using both a tag
  (alien) and a color (deep pink).
- [GTK] Added option to discard results bearing an alien IP (TRUE by default).
- [GTK] Added option to restart session-only searches that still have pending
  downloads registered (FALSE by default).
- [GTK] Search details now include a line to display available metadata.
- [GTK] Fill in the Bitzi metadata column on the fly as results come in when
  we have cached ticket information available.
- [GTK] Show media type filter attached to query, when known, in the search
  detail window.

Bug Fixes:
- Fixed *grave* routing bug whereby TTL was wrongly trimmed down by one
  extra step. Furthermore, the trimming threshold was wrong, which in effect
  caused ultrapeers to drop queries with TTL <= 2.
- Fixed *grave* routing bug: was sending TTL>1 queries twice on the same
  connection when running as ultrapeer.
- Fixed *grave* routing bug: was not properly forwarding duplicate OOB-proxied
  queries with a higher TTL (MUID was not altered the second time).
- Make sure ~ expansion is done for path variables when changed at runtime.
  Fixes bug #3215847.
- Was not processing updates of "search_reissue_timeout" from the GUI!
- Filename sanitizer led to a crash when given a filename with leading spaces.
- TTH downloads would crash when not receiving any data back.
- An off-by-one bug prevented proper token validation, causing GTKG to not
  properly recognize the latest releases.
- Avoid crash when attempting to connect to a node that would be internally
  flagged as "useless".
- Fixed chunk selection algorithm to properly request from servers providing
  partial files.
- Various "crash at shutdown time" type of fixes (occuring rarely and randomly).
- Plugged hole leading to a file completing but not being checked for its SHA-1
  when we have a few sources competing against each-other and all these sources
  end up ignoring data to preserve their connection.
- Fixed crashes with GTK2 on some platforms at quit time by ignoring duplicate
  "quit" requests.
- Fixed race condition that could lead to an incomplete QRP configuration.
- Fixed important LRU cache management bug in the SDBM layer, which was causing
  data loss in persisted databases.
- Head pings had their GGEP "PUSH" key improperly parsed.
- [GTK] Was not saving the column size of the search list.
- Fixed cause of random crashes in the VMM layer on systems using mmap() to
  serve uploaded files.

Miscellaneous:
- Dutch translation updated.
- French translation updated.
- By default, auto-clear completed and failed chunk downloads.
- Changed user-visible connection state wording: "Connected" -> "Receiving" or
  "Awaiting data".
- Added documentation for DHT "NOPE" values.
- Allow one to disable partial file sharing in general, enabling it only for
  rare files (no full copy present).
- Moved SDBM files to dedicated directories, either "gnet-db" or "dht-db".
- Added visual indication that the download queue is frozen.
- Added GUI configuration for "tth_auto_discovery".
- [GTK] New colors for search results, to quickly spot partial hits, alien hits,
  hits with media-type mismatch and hits from firewalled sources with no
  push-proxy listed.
- [GTK] Added expert-level configuration for the DHT mode, for whether DHT
  keys/values should be kept in memory, and for the SPAM SHA1 look-up table.
- Option --disable-ipv6 was removed from build.sh:  we now always compile with
  IPv6 when Configure detects OS support.

Under the Hood:
- Tweaked aggressive chunk selection logic.
- Let the RX link layer use the configured socket RX buffer size to determine
  the maximum amount of data that we can attempt to read in one system call,
  when the input layer cannot let us know how much data is pending.
- Ensure we only keep valid address and port information when merging PUSH
  servent addresses for a given GUID.
- Make sure fast assertion routines are never inlined or it would perturb
  stack traces due to missing offsets.
- When building search request, be careful to not include unnecessary bloat at
  the end of the extension block or other GTKG nodes will drop the query.
- DHT statistics now show local k-ball info along with the theoretical one.
- Added probalistic model to randomly avoid cached DHT values too far from the
  key's theoretical k-ball during value lookups.
- Smarter handling of "duplicate DHT values" (coming from the same publisher).
  We now allow fetching of these duplicates and retain different versions of the
  same value if we find a discrepancy (due to caching or partial re-publishing).
- PUSH flooding detection no longer bans offending hosts, but only regulates
  the traffic by dropping flooding requests.
- Compact extensions of forwarded queries to remove needless bloat: the XML is
  compacted, legacy HUGE requests to return URNs in hits are dropped, GGEP
  payload that are large enough are possibly compressed.
- s390(x) has IEEE 754 floats.
- Handle GGEP "u" in queries (SHA1 and bitprint URNs).
- Avoid showing "negative" retry delays.
- Turned some debugging-only assertions off.
- Fixed bad test that led to a crash when receiving improper FIND_NODE messages.
- Removed dependency to libxml2: now uses built-in XML support.
- Converted bitzi cache to a persistent SDBM-based database.
- Faster Bitzi request scheduling.
- The Gnutella routing table now dynamically adjusts its size.
- Deprecated GGEP "GTKGV1" in query hits, replacing it with "GTKGV".
- Make sure we never send back duplicate SHA1 hits, even if they are sharing
  twice the same file from different directories.

# v 0.96.9   2011-03-20  [beta for Windows]

This release only concerns the Windows platform.

Gtk-Gnutella is now fully functional on Windows but needs extensive beta
testing before it can be officially released as 0.97.  A pre-compiled binary
was released on Sourceforge (SVN revision 18885).

# v 0.96.9   2011-03-14  [stable]

New Features:
- Added UPnP and NAT-PMP support.
- Added a "log" command to the shell to manage logfiles.
- Added --gdb-on-crash switch, auto-activated when no core dumps are possible.
- Configures a crash directory as ~/.gtk-gnutella/crashes
- [GTK] Added visual feedback for UPnP and NAT-PMP configuration status.

Improvements:
- Better handling of uploading servers that also publish in the DHT.
- Added Global Host Cache as a last-resort bootstrapping mechanism when UDP is
  not working.
- Search results from firewalled hosts are now displayed in "dark slate gray"
- Message statistics now include a line per DHT message type instead of
  aggregating all DHT messages in the same basket.
- Always use ARC4 random number generator.
- Continuous entropy collection to make the random number sequence more random.
- Raised default ultrapeer connections in leaf mode to 4, maximum now being 5.
- ASCII parentheses are no longer considered evil characters and are not
  stripped from filenames anymore.
- Trailing spaces and periods are stripped from filenames because Windows
  does not like them.
- When stdout and stderr are different files, critical messages (assertion
  failures, crashes) are duplicated to stdout.
- [GTK] Added visual feedback icon for the DHT status.
- [GTK] Show green/yellow/red uploading status icons indicating increasing
  warning levels after which we declare that uploads are stalling.
- [GTK] Show DHT alt-loc queries on a per-file basis.

Bug Fixes:
- Prevented random crash at shutdown time (improper cleanup ordering).
- Prevent crash when running on linux kernels patched with grsecurity.
- Fixed improper hop count display (always showing 2147483647) in horizon stats.
- Fixed bad GUI status for files: do not say "SHA1 failed" unless it's true.
- Fixed message statistics which were reading payload size from the header
  instead of relying on what was actually read.
- OOB proxying code was not considering MUID collisions, causing memory leaks.
- Was not always reconnecting to other Gnutella nodes when missing slots.
- Fixed old bug triggered by setting "listen_port" to 1 multiple times.
- Magnets created from search results did not include push proxies.
- [GTK2] Was not saving tree view column positions in the statistics pane.
- [GTK2] Fixed broken DND so that files can be drag 'n' dropped from
  local searches and the download view to other desktop apps now.
- [GTK] New users were never able to see the preset filters in the menu.

Under the Hood:
- Fresh bogus IP lists and geo IP database.
- Updated SPAM detection rules.
- Updated Gnutella bootstraping logic due to changing environments.
- Cached DHT security tokens are now regularily expired.
- Tuned DHT maintenance traffic down, using statistical methods to further
  avoid needless RPCs.
- Clear empty databases at startup, attempt to shrink them otherwise.
- Fixed uninitialized memory read detected by valgrind.
- Made SDBM more robust when facing errors.
- Errors encountered during SDBM operation are now reported at exit time.
- If I/O errors were detected during operations of a persisted DB, request key
  checking at next startup.
- Added CPU frequency scaling detection (Linux and Windows only) to be
  able to properly determine whether we are overloading the CPU.
- Removed ShareMonkey URL support: they went out of business.
- Use the DHT routing table as a source for new node addresses when the host
  caches are depleted, before attempting to contact the UHCs.
- Throttle UDP pings so that we do not bombard a single host with many requests.
- Limit Gnutella connection attempts to a given host to one per 2 minutes.
- DHT routing table size now adjusts dynamically, lowering maintenance traffic.
- Throttle received DHT lookups as a precaution against abuse from rogue nodes.
- At startup time, sort cached host entries to put the most recent ones first.
- Optimized QRP table merging loop.
- Improved behaviour when facing stalling uploads.
- Only send "DHT" in Gnutella pongs if the DHT runs in active mode.
- Implemented DHT attack-prevention rules to guard against Sybil attacks.
- Added arc4random() default implementation for systems without it.
- Robustified query hit parsing so that we can filter out invalid hits.
- [GTK2] Completely migrated GtkFileSelection to GtkFileChooser.

# v 0.96.8   2010-03-21  [stable]

This is essentially a bug-fixing release for 0.96.7, in which some code paths
that were not exercised during pre-release testing are responsible for
fatal errors (sudden crashes due to assertion failures).

Bug Fixes:
- Removed an obsolete assertion now that gtk-gnutella supports NOPE DHT values.
  This was causing a crash each time a NOPE value was received in response
  to push-proxies queries in the DHT.
- Fixed memory alignment problem for non-forgiving CPU architectures.
- The virtual memory manager would crash when the kernel starts allocating
  pages in zones we wrongly thought were already used.
- Fixed long-standing bug in the Query Routing Table protocol where a RESET
  message with the wrong table size could sometimes be sent, causing the remote
  node to close the connection.
- Make sure an ultrapeer is not publishing NOPE values in the DHT if support
  for the DHT was disabled by user, which would be triggering a fatal assertion
  failure.

Under the hood:
- Fixed Makefile to ensure proper compilation under Gentoo's build scripts.
- Push-proxy client support now makes sure there is a space after a leading
  GET or HEAD word in the HTTP request.
- The DIME parsing layer now given more information in case of an error.
- Let THEX downloads peruse any supplied Content-Length information from the
  server (applicable only when the output is not chunked).
- The VMM layer is now smarter at identifying foreign pages when allocating
  blocks larger than a single page.
- When sending BYE messages, do not shutdown the socket layer if using TLS.
- Compilation cleanup for SunOS, Sun Studio, and versions of GTK < 2.5.0.

# v 0.96.7   2010-03-07  [stable]

Bug Fixes:
- Fixed memory leaks.
- Do not unduly rewrite fileinfo trailers on restart, messing with the "mtime"
  filesystem information.
- We were never forwarding to other ultra nodes queries that did not
  have a TTL of exactly 1 (severe bug impacting the network).
- Queries not kept for a local file match were most often dropped and not
  forwarded (severe bug impacting the network).
- Corrected detection of largefile support in Configure.
- Fixed oversight in token validation, to be able to verify older versions.
- Fixed metaconfig unit for systems without kqueue().
- PARQ complained about lack of X-Queued header even if HTTP status was not 503.
- Fixed sending of QUEUE callbacks to avoid hammering remote host, or stopping
  alltogether at the first timeout detection.
- Was sometimes failing to reconnect to more nodes after disconnections.
- Inverted logic was causing repeated UHCs queries when under the minimum
  amount of peer connections, causing undue traffic.
- Tigertree verification would sometimes crash and delete the wrong slices
  after a TTH mismatch.
- Fixed crashes at shutdown time due to inappropriate dropping of new messages
  in the message queues.
- Fixed crashes at shutdown time due to improper checking in the dynamic
  query cleanup code.
- Fixed invalid boundary test when server shrinks the requested file chunk.
- Unfreeze all PARQ entries from the IP after serving a quick slot, or we
  could have several frozen entries for that IP with no possible escape.
- Receptions of "GIV" and "QUEUE" were not checking whether the remote address
  was an hostile one.
- Changed the Bitzi ticket-requesting URL, as the previous one was no longer
  responding correctly.
- Fixed push-proxy support: requests (LIME/21) now only use v1 and acks
  (LIME/22) only use v2 because this is what LimeWire expects.  GTKG was
  sending LIME/21v2 which confused LimeWire, in effect disabling the ability
  of GTKG to act as a push-proxy.
- GUI node flags were not updated upon reception of a Push Proxy
  Acknowledgement (indicating the node became one of our push-proxies).
- Fixed status bar which lost the GTKG URL as soon as a new version was
  announced.
- Fixed crash when a compressed connection was closed and had never been
  given any data to compress.
- Fixed behaviour on DHT value lookups when the key exists but is not holding
  the proper value types.
- Fixed HTTP partial range merging logic.
- Fixed logic for push-fallback on connection timeouts.
- Fixed improper GUI status display when connecting to a push-proxy.
- Could wrongly discard a perfectly good push-proxy.
- Prevent "found more recent metainfo" warnings at next startup by properly
  flushing the metainfo database at shutdown time.
- The "Force push mode" menu entry could have no effect if gtk-gnutella had
  determined the host did not require a push.
- Avoid innocuous duplicates in the persisted download file.

Improvements:
- Better resuming of downloads on session restarts.
- Increased success rate on downloads from firewalled hosts.
- Completed support for DHT publishing: DHT is now fully functional.
- DHT bandwidth usage is now disaplayed in the GUI.
- Added support for GGEP XQ (eXtended Query) as used by LimeWire for search
  terms longer than about 30 characters.
- Try to decipher incorrectly encoded query flags from buggy Shareaza.
- Parse incorrectly formatted X-Alt header from buggy Shareaza.
- Implemented PFSP 1.0a: now emits and handles new X-Available header.
- Added some MIME types and file extension mappings.
- Added comand-line switch --compile-info to print some information
  that is hardcoded at compile-time.
- Persist known TTH roots in magnets.
- Swapped leaf and ultrapeer slots for GGEP UP in compliance with LimeWire
  which does not follow the published specification (so we don't either now
  but we are compliant with the de-facto standard).
- Will now remove uncompressed ultra connections when full and getting a
  new compressed one.
- Whitelist can now support TLS hosts and will refresh DNS mappings regularily.
- Improved granularity of the background task used to scan the library in
  order to prevent noticeable processing freezes as much as possible.
- Redesigned the output of the shell "status" command to show more information
  and display status flags (shown as icons in the GUI).
- Added liberal parsing of urn:sha1: and urn:bitprint to cope with clueless
  sites using hexadecimal instead of base32 to encode the hashes.
- Added -v option to the shell command "props" to also display values along.
- Added real shell-like string parsing, and fixed escaping to work correctly.
- Added the ';' separator to be used to separate mutiple shell commands.
- Allow crashes and fast assertions "soft" failures to be timestamped.
- Don't answer to UDP pings from bad nodes, which include "alien" hosts.
- Loop through the TCP push-proxies more quickly until one can relay our push.
- Passively revitalize PUSH routes and wakeup starving downloads.
- Attempt to collect push-proxies passively from relayed query hits.
- A completed file waiting for being moved accross filesystems will now
  be flagged as such in the GUI "Downloads" pane.
- Detect and fix improper 503 HTTP status code replies when 416 was meant
  (broken HTTP replies from Foxy, Shareaza, and maybe others).

Under the hood:
- DHT (Distributed Hash Table) is now enabled by default.
- Reduced blackout period between two DNS server name lookups to 30 minutes.
- Updated PFSP specifications (partial file sharing) to version 1.0a.
- More statistics.
- Always use exact time when logging, not the cached time.
- Align to LimeWire's settings for DHT expiration and republishing periods.
- Do not emit any PFSP header when seeding a finished file.
- Even if bandwidth is tight, force emission of the X-Hostname header under
  certain circumstances because this information is precious.
- No longer constantly monitors for unsolicited UDP traffic, which will save
  precious CPU cycles.
- Improved malloc tracking by reporting symbolic names in stack frames.
- Optimized ultrapeer TX compression settings to reduce memory requirements,
  saving 288 KiB of RAM per Gnutella node connection (leaf or ultra).
- Increased default amount of ultrapeer connections to 42.
- Optimized memory footprint of the simple hashtable and allow it to be
  downsized as well.
- Consider a HEAD Ping message to be unsolicited UDP traffic.
- New shell command "memory dump" available when malloc stats compiled in.
- Some documentation held in SVN cannot be packaged on Debian, so it was
  moved to a separate directory that is left out from the packaging manifest.
- SDBM improvements for greater runtime performance and data consistency.
- Added DHT root node caching (k-closest nodes of a target KUID).
- Tuned DHT node lookups for more performance.
- Can now hold the SPAM look-up table in an SDBM database instead of memory.
- The directory holding "incomplete" files is now lock-protected to prevent
  two different gtk-gnutella instances from using the same one.
- Added long-due zone garbage collector, called when gtk-gnutella is "idle".
- Tuned block size to avoid wasting too many bytes in zones.
- Improved the virtual memory management layer to limit fragmentation,
  especially for servents running over long periods of time (weeks).
- Revised the vitrual memory management page-caching algorithm.
- Politely deny handshaking with peers presenting an X-Auth-Challenge header
  or an FP-Auth-Challenge one.
- Added support for firewalled alternate location collection and propagation
  through the X-Falt header (requires that the "fwalt/0.1" feature be
  advertised in X-Features).
- Added a non-persistent "alien" cache to keep track of IP:port of nodes
  that do not belong to the Gnutella network.
- Increased the buffer size of datagram sockets to 32KiB to allow reception of
  bigger messages: it is not uncommon to get OOB query hits larger than 4KiB.
- Count (and show) amount of launched SHA-1 and TTH file verifications.
- Translation updates.

Limitations:

- DHT code is currently sub-optimal for firewalled hosts.
- Manual bandwidth tuning is currently necessary to allow for efficient
  DHT usage.  Allow at least 8 Kib/s out, 15 KiB/s out being better.
  Also increase the lookup bandwidth to 32 KiB/s in and 6 KiB/s out, the
  defaults of 8 KiB/s in and 2 KiB/s out being very conservative.
- DHT is enabled by default with a fixed (manually tunable) configuration.
  There is no auto-tuning and no adaptation to traffic conditions yet.
  You need to explicitly disable the DHT if you don't want to benefit from it.

# v 0.96.6   2009-03-29  [stable]

Bug Fixes:

- #1932909 "columns in search window do not scale properly".
- Fixed improper HTTP chunking when outputing chunks larger than 64 KiB.
- #2628899 "tries to download from my old self after IP changes".
- Was not always resuming the interrupted SHA-1 computation of a finished file
  when servent was closed in the middle of processing.
- Fixed bad range checking test in the download part.
- Was not paying attention to the "give_server_hostname" property and instead
  sent "HNAME" GGEP extensions in query hits provided a non-empty name was
  defined as the "server_hostname".
- Fixed improper upload slot counting which introduced race conditions,
  sometimes leading to having more slots used than the configured maximum
  (in addition to the "quick" upload slots).
- Prevent occasional crashes at shutdown time, during subsystem cleanups.
- Fixed corner cases where we could lose a server hostname and downright bug
  where we discarded the hostname after a DNS lookup if the subsequent
  connection attempt did not succeed.

Improvements:
- Refuse to share certain directories: /, $HOME, $GTK_GNUTELLA_DIR, and
  the incomplete and corrupted directories.
- Downloads GUI: added checkboxes to invert the select/filter patterns.
- Downloads GUI: added "Modified" column and detail showing the timestamp of
  the last file modification.
- Optional beautification operations on filenames: strip leading "-", remove
  consecutive "_" and prevent "_" surrounding punctuation characters.
- Fixed significant performance issue in the Gtk+ 1.2 front-end: update of
  upload statistics was O(n) but is now O(1).
- Background TTH file verification now lights an icon in the GUI.
- Show TTH tree depth in the download "Details" pane.
- Update the bitzi metadata info box when a query finishes, so that it is
  not required to click on the result again after requesting bitzi data.
- Added MIME type column for search results.
- Added "Last Request" and "Last Upload" columns to the Upload History.
- Almost complete DHT support (missing only publishing of data), but code
  needs to be explicitly enabled by setting "enable_dht" to TRUE.  The DHT
  knows how to look for alt-locs for files and push-proxies for firewalled
  hosts, and will store local data for others to query.
- New shell commands "stats", "download", "echo".
- It is now possible to rename files being downloaded (through GTK2 or shell,
  no support in GTK1).
- Added more filename extensions to the built-in search filters.
- Switch resources after getting an HTTP error if the connection is kept alive
  and the error permits follow-ups (non-busy conditions).
- Improved ability to switch resources after file completion by ignoring
  trailing swarming data, to keep the connection alive.
- Bitzi tickets are refreshed when explicitely requested, avoiding reuse
  of stale metadata
- Completed files are displayed during hash verification.
- Only propagate good alt-locs for files we are downloading, i.e. addresses
  of hosts which we know to be serving that file because we contacted them.
- Many new statistics counters.
- Allow scheduling of special downloads without considering per-host limits,
  as these are of a much shorter duration (THEX and browse host requests).
- Always seed completed files, regardless of their size (no PFSP minimum as
  with partial files), when their SHA-1 has been verified.
- Incorrectly encoded Bitzi metadata is translated to Unicode.
- Browse-host responses are sorted alphanumerically on relative pathnames to
  allow users to relate files together if they don't understand GGEP "PATH".
- Improved routing of PUSH messages by also looking whether targetted hosts
  happen to be one of our immediate neighbours.
- Updated Norwegian Bokmal and Spanish translations.

Under the hood:

- Parse legacy Shareaza THEX URIs "urn:tree:tiger/:" (extra "/" here).
- Handle non-standard  X-Thex-URI headers if peer provides a valid
  X-Content-URN header (Shareaza 2.1.0.0).
- Also attempt to give priority to the last "pfsp_last_chunk" bytes of
  downloaded files, since that can contain important indexing information to
  enable pre-view of partial video files.
- More MIME types known (derived from file extensions).
- Can now download THEX data at a tree depth of 11 for files larger than 1 GiB.
- Can download sub-optimal THEX data, as non-optimal data is better than none,
  but keeps looking for THEX data at the optimal tree depth nonetheless.
- Reimplemented scanning of shared directories as a background task so that
  the process (not just the GUI) is fully responsive during the whole scan.
- Let the background task scheduler compute the proper amount of ticks to
  use for each task.
- Upload statistics now record the file's SHA-1, so that we can consolidate
  partial file sharing with library sharing statistics, with the filename
  being forced to the library's filename.
- Avoid starting moving a completed file if there is not enough space on
  the targetted file system.
- Recognize and propagate the "DHT" GGEP extension in pongs.
- Added support for "DHTIPP" GGEP extension in pings, used for DHT bootstrap.
- Added more entropy to the random number seed.
- Plugged memory leaks
- No longer send SHA-1 queries on the Gnutella network. They are now performed
  through the DHT, which has the suitable topology to do so efficiently.
- Fixed UDP bandwidth computation, and removed any limit on UDP incoming.
- Updated list of hostile IP adress ranges, Geo-IP data, spam patterns and
  spam samples.
- Property loading from files was in O(n*n), made it O(n).
- Now detect property files being blindly copied over from another
  gtk-gnutella's config directory and reset properties whose value needs to
  be unique.
- The GUID and the KUID (Kademlia ID, the DHT node ID) were made sticky.
- Optimization of QRP lookups in tables ranging from 16k to 2M slots.
- Limit amount of hits to 10 per query hit packet, as LimeWire chokes otherwise.
- Limit amount of alt-locs in hits to 10 or LimeWire chokes.
- Keep connection alive when reporting an HTTP error to allow remote resource
  switching if necessary.
- Emit and parse new X-Downloaded header, apparently introduced by LimeWire.
- Added parsing of X-FW-Node-Info headers to grab push-proxies from firewalled
  hosts, as well as gather the proper GUID and host address/port.
- Emit X-FW-Node-Info if node is firewalled but continue to list our
  push-proxies in the standard X-Push-Proxies header.
- Avoid endless aggressive chunk splitting during swarming.
- Proper parsing of comma-separated values in Accept and other Accept-Encoding
  HTTP headers.
- Reject UDP packets from unspecified addresses.
- Drain more data out of the UDP receive buffer to prevent it from filling up.
- Strip at most 5 trailing characters from words when building the QRP table,
  thereby inserting less radices and making the table more sparse.
- Removed workarounds for dealing with broken 0.96.2 nodes and earlier 0.95.x.
- Extended syntax for push:// exact sources in magnets to be able to supply
  all the known push-proxies, even if that is an empty set.  Since downloads
  are persisted as magnets, this also allows keeping all the previously
  known push-proxies accross sessions.
- Upgraded PARQ to version 1.1 (mostly specification cleanups).
- Added additional anti-hammering for cases where many files on the same
  server are queued and gtk-gnutella is configured to launch more than 1
  connection per IP.  Connection attempts to the same server are now limited
  to 5 per minute.

Limitations:

- DHT code is still experimental, although functional: configuration of
  parameters can only be done through the shell, and there is no support
  for publishing yet.

# v 0.96.5   2008-04-01  [stable]

Bug Fixes:

 - #1870957: Wrong sign could cause out-of-bounds read and potentially a crash.
 - Firewalled status was not re-verified after a port change if the previously
   used port was open.
 - Fixed issue that caused the local peer cache to degenerate.

Improvements:

 - Client-side support for tigertree hashes (TTH/THEX).
 - Replaced navigation tree by tabs.
 - Redesigned download user-interface to make it more accessible.
 - Added some selectable pre-defined search filters.
 - Bitzi tickets are displayed in full raw indented XML.
 - Display Bitzi and ShareMonkey URLs as search result details.
 - Topless mode is available at run-time via command-line switch.
 - Added default shared filename extensions:
   .7z, .bittorrent, .oga, .ogv, .spx, .tbz2
 - Removed default shared filename extensions: .doc
 - Updated translations: Japanese, Norwegian Bokmal, French.

Under the hood:

 - Changed default to dual use of IPv4 and IPv6 instead of IPv4-only.
 - Support the "as" (Alternate Source) key in magnet links.
 - Eszett is finally normalized to "ss" in search queries.
 - Avoid display updates for elements not currently visible.
 - Take full advantage of persistent HTTP connections to fetch multiple
   files from the same peer through over the same connection if scheduling
   permits.
 - Improved TLS support and blocking detection.
 - Updated list of hostile IP adress ranges, bogons, Geo-IP data,
   spam patterns and spam samples.

# v 0.96.4   2007-07-07  [stable]

Bug Fixes:

 - The download overlap checking was incorrectly detecting mismatches.
 - A bug in the network queue caused frequent crashes (#1601523).
 - A bug in the event timing caused failures after 25 days uptime.
 - A stalling issue with TLS connections.
 - The search retry timeouts weren't accepted (#1568205).
 - The order of items in the search history was wrong (#1568206).
 - The quick-connect limit wasn't respected causing too frequent
   connection attempts during startup.
 - Removed incorrect use of SF_NODISKIO flag for sendfile() on FreeBSD.
 - Fixed crash that could be triggered by changing the listening port
   temporarily to zero.
 - iconv() was not used correctly which could cause wrong conversions
   for longer strings.
 - Generated filenames weren't properly restricted in length which
   could cause crashes.
 - There was a compile issue on NetBSD caused by namespace pollution.
 - Added workaround for the issue that on Solaris only the file descriptors
   0..255 can be used for stdio.

Improvements:

 - Finished downloads are now seeded for the whole session or until
   they are manually purged, if partial file-sharing is enabled.
 - Server-side support for Tigertree hashes and THEX thanks to patches
   provided by Martijn van Oosterhout.
 - Improved spam filters.
 - Slightly better drag & drop support.
 - Removed GWebCache support so only UHCs are used for bootstrapping.
 - Improved the shell interface somewhat.
 - Downloads can be paused now.
 - Added a simple query syntax for easier creation of result filters.

Under the hood:

 - Added support for HEAD Pings and Pongs which improves the download mesh.
 - Implemented for Out-of-Band result delivery protocol v3 which protects
   against certain kinds of forged results.

# v 0.96.3   2006-11-09  [stable]

Bug fixes:
 - Portability fixes which affect the ARM architecture.
 - Ultrapeers could be unnecessarily demoted to leaves in auto mode.
 - [GTK2] Fixed a bug that could cause spurious assertion failures or memory
   corruption.
 - Fixed bug that might have caused truncation of printed numbers in certain
   places.
 - Rewrite the upload_history file if the history was cleared.
 - Fixed crash caused by an assertion failure that could occur if IPv6
   support was disabled at compile-time.
 - Fixed buggy utf8_is_valid_data().
 - Fixed a couple of small technical mistakes in translations.
 - Fixed compilation for Cygwin without IPv6 support.

Updated:
 - Updated French translation.
 - Updated list of hostile IP ranges.
 - Updated list of bootstrap caches.
 - Updated list of country names and codes for Serbia and Montenegro.

Improvements:
 - Turkish translation.
 - New shell commands: online, offline, props, status.
 - The search list allows selection of multiple items and applying actions to
   them now.
 - Added a tray icon to hide the gtk-gnutella application windows. This
   feature requires Gtk+ 2.10 or newer.
 - Added a limit of downloads per file which defaults to 40 to prevent using
   an unreasonably large amount of sources.
 - Keep certain irrelevant columns empty for "local:" searches instead of
   showing bogus data.
 - Added README.Debian with instructions how to compile gtk-gnutella yourself
   on Debian-derived systems.

Under the hood:
 - Rewrote "fast" assertions so that they are sufficiently portable and do
   not mess with debugging. Thus they are always enabled now which reduces
   code size signifcantly.
 - The TLS cache is now persistent without SQLite too.
 - Disabled reservation of Gnutella slots and vendor limits because it's not
   useful with the current population of Gnutella.
 - Disabled GWebCache updates.
 - Configure bails out now if a mandatory dependency e.g., libxml2, GLib,
   zlib isn't available.
 - Added -Wshadow to the default compile flags for GCC for even cleaner code.

# v 0.96.2   2006-10-16  [stable]

Bug fixes:
 - Fixed bug #1467793 "uname() return value".
 - Fixed bug #1467681 "weird HTTP acknowledgment".
 - Fixed bug #1422526 "`Drop results' should prepend, not append, to filters".
 - Fixed bugs in the dynamic querying logic that caused leaves to
   receive very few results through gtk-gnutella ultrapeers.
 - Fixed crash on 64-bit platforms when using the navigation tree.
 - Fixed format mismatches in some translated message catalogs.

Updates:
 - Updated French, Japanese and Ukrainian translations.
 - Updated list of hostile IP ranges.
 - Updated list of bootstrap caches.
 - Updated list of country names and codes.

Improvements:
 - Italian translation.
 - Fairly complete support for magnet-links; magnets can be passed per
   drag & drop or entered via the search box. Magnets can be generated
   from the search results display and the downloads display through
   the context menu.
 - SHA-1 based spam filtering.
 - Built-in spam detection for certain kinds of spam.
 - [GTK2] Overhaul of the downloads display.
 - [GTK1] Downloads can be sorted albeit the sorting does not persist.
 - Compiling the topless is variant is now as easy as
   "./Configure -Oders -Dd_headless".
 - Support for several command-line options like "--help".
 - A local shell interface accessible with "gtk-gnutella --shell".
 - New shell commands "nodes" and "shutdown".
 - All downloads are stopped now if the disk apparently filled up.
 - Caching of TLS-support allows automatic use of TLS.
 - ~/.gtk-gnutella/whitelist supports the "tls:" as well.
 - More search results columns for experts (hidden by default).
 - Diverse IPv6 settings can be configured in the GUI now.
 - The setting "IPv4 and IPv6" works now; the default is "IPv4 only".
 - Results bearing no SHA-1 are suppressed by default.
 - Results from hostile IP ranges can be made visible; they are discarded
   by default.
 - One's own shared files can be search by using the prefix "local:"
   for searches. Local searches uses regex syntax unlike Gnutella searches.
   "local:" alone will list all shared files. Local searches results
   allow drag & drop and generation of magnet links.
 - Support of Socker for access to privileged TCP and UDP ports below 1024.
 - Optionally bind sockets to a configured address instead of the wildcard
   address.
 - Support of IPv6-to-IPv4 Transport Relay Translators (RFC 3142).

Under the hood:
 - mmap()-based memory allocation to decrease fragmentation and
   increase performance.
 - Support of socket option TCP_DEFER_ACCEPT (Linux).
 - Support of accept() filter "dataready" (FreeBSD).
 - Support of /dev/poll on Solaris and IRIX.
 - Sharing of file descriptors so that we don't require a file descriptor
   per swarm source but only one per file.
 - Use of pwrite(), pwritev() for flushing download buffers.
 - Reopen log files on SIGHUP if the command-line options --log_stderr or
   --log_stdout are specified which is useful for topless mode.
 - Disabled following of HTTP redirects.
 - Support of "deflate" transfer-encoding for all downloads.
 - Support for compression of UDP packets.

- (2006-04-22 - RAM)
 * Moved downloads were not lingering in the GUI once completed.

- (2006-03-11 - RAM)
 * Fixed improper UDP overhead accounting.
 * Flush ASAP when file is overcommitted: we have more data buffered than
   there are in the file.

# v 0.96.1   2006-02-22  [stable]

Bug fixes:
- Fixed issue when browse host is the only search in the list (bug #1421196).
- Reset download buffers on incomplete writes (fixes bug #1429981).
- Fixed ever-growing sidebar at each relaunch under GTK1 (bug #1421940).
- Fixed misdetection of chunk completion, causing undue abortion of downloads.
- Was wrongly showing the source download speed twice in download status.
- Range column was sometimes inexact in downloads.

Improvements:
 - Print PFS indication for actively queued entries as well.
 - Take buffered data into account when showing download progress.
 - Downloads now show how many HTTP requests were made on the same connection.
 - Try to reposition the main window correctly.

Configuration Changes:
 - Minimum connection timeout is set to 15 seconds.
 - Default for "maximum % of slots / vendor" raised to 90.

- (2006-22-01 - RAM)
 * Further fix for #1421940, regarding the vertical position of the search
   list on the sidebar, which continuously went off after each restart.
 * Made root window position fixup more robust to avoid random jumps when
   we cannot determine the window position correctly.
 * Was wrongly showing twice the same b/w rate in downloads with more than one
   source: the second rate is supposed to be the aggregated rate of all the
   sources.
 * Downloads now show how many HTTP requests were made on the same connection,
   if more than one, by appending a "#n" at the end of the status.
 * Only update the range in the GUI after we decided which boundaries we'll use.
 * Added workaround against broken HTTP servers such as GnucDNA which don't
   show us the HTTP version in their statuses.
 * No longer need to fake presence of a README.debian: manifests were updated!

- (2006-19-01 - RAM)
 * Fixed misdetection of chunk completion, causing undue abortion of downloads
   each time a chunk was completed.
 * Take into account buffered data when showing download progress, instead
   of waiting for the data to be flused on disk to update the counters.

- (2006-16-01 - RAM)
 * Minimum connection timeout is set to 15 seconds.
 * Default for "maximum % of slots / vendor" raised to 90.
 * Forgot to reset download buffers on incomplete writes (fixes bug #1429981).

- (2006-04-01 - RAM)
 * Print PFS indication for actively queued entries as well.

- (2006-02-01 - RAM)
 * Fixed issue when browse host is the only search in the list: it could not
   be closed, and GTKG would dump a core at exit time.  Fixes bug #1421196.
 * Use conditionnal form when reaching "code that should not have been".

- (2006-01-30 - RAM)
 * Fixed line incorrectly starting with a leading $ instead of %.

- (2006-01-26 - RAM)
 * Desktop and png files are located in extra_files now, no longer at the
   root of the source tree: fixed debian/rules accordingly.

# v 0.96   2006-01.24  [stable]

New features:
- Browse Host (HTML and Gnutella), TLS and IPv6 support.
- Chinese and Greek translations of the user interface.
- D-BUS plugging.
- Added hot keys: F2, F8 and F9 (see menu View->...).
- Searches are now created with a configurable expiration date.

Improvements:
- Optimization of the UTF-8 processing.
- Better filename conversion to locale, with automagic charset detection.
- General performance improvements in QRP and search filters.
- Full "nl" translation.
- Sorting persistence.

Under the hood:
- Buffering of downloaded data to avoid excessive disk fragmentation
- Support for the epoll()/kqueue() system calls.
- More optimistic PARQ ETA, and PARQ back-off when QUEUE are unanswered.
- NFS-compatible session locking if anyone cares.
- Nifty property browser.

- (2006-01-21 - RAM)
 * [GTK1] Do not deselect items on menu "browse host" selection.
 * Added option to copy browse-host results to passive searches (disabled
   by default).  Setting done in GUI from search option pane.
 * Added cygwin directory containing rules suitable for building cygwin
   binaries (on a cygwin platform, no cross-compiling).
 * Fixed crash on exit when hosts are browsed.

- (2006-01-13 - RAM)
 * Guard against servers incorrectly shrinking the HTTP range in such a
   way that the end is lower than the beginning! (Shareaza 2.1.0.0 does this)

- (2006-01-01 - RAM)
 * Distinguish between fully completed browse host requests and those that
   are aborted in the middle of the transmission.
 * Added properties "html_browse_served" and "qhits_browse_served".
 * Added property "browse_host_max_results".

- (2005-12-21 - RAM)
 * Use specialized routines for 8-bit and 4-bit patches to increase the speed
   of QRP patching, which is CPU intensive. [Patch from Bill Pringlemeir]
 * Blindly accept remote GTKG version identification if we're expired.
 * Removed unused version_newer() routine.

- (2005-12-11 - RAM)
 * Allow launching of "browse host" on expired (completed) uploads from the GUI.
 * Configure updates to allow configuration of madvise(), sigaction(),
   the SA_INTERRUPT flag for sigaction(), and FAST_ASSERTIONS.

- (2005-12-10 - RAM)
 * [GTK1] Browse all the hosts of the selected entries like GTK2 does, not
   simply the host listed in the detailed search information pane.

- (2005-11-29 - RAM)
 * Always collect the TX and RX stacks asynchronously.
 * Update downloads pane when browse-host is created or when search is closed.

# v 0.96   2005-11.22  [beta]

New features:
- Browse Host (HTML and Gnutella), TLS and IPv6 support.
- Chinese and Greek translations of the user interface.
- D-BUS plugging.
- Added hot keys: F2, F8 and F9 (see menu View->...).
- Searches are now created with a configurable expiration date.

Improvements:
- Optimization of the UTF-8 processing.
- Better filename conversion to locale, with automagic charset detection.
- General performance improvements in QRP and search filters.
- Full "nl" translation.
- Sorting persistence.

Under the hood:
- Support for the epoll()/kqueue() system calls.
- More optimistic PARQ ETA, and PARQ back-off when QUEUE are unanswered.
- NFS-compatible session locking if anyone cares.
- Nifty property browser.

- (2005-11-21 - RAM)
 * [GTK1] Added ability to launch a browse-host from a download or a node.
 * Will now correctly mark as finished browse host entries which have
   a known size (maked when they're done, that is).

- (2005-11-17 - RAM)
 * Added counting of received bytes during host browsing.
 * Better handling of sudden file size knowledge.
 * Update GUI information when size of browse host is known.

- (2005-11-17 - JA)
 * PARQ now backs-off everytime a QUEUE failed to send.

- (2005-11-15 - RAM)
 * Added client-side "browse host" support in the core.
 * [GTK1] Initial implementation of client-side "browse host".

- (2005-11-11 - RAM)
 * [GTK1] Changed the way autoselection works in search results: it now
   happens only when one selects the root of a folded tree, and it
   auto-selects all the (hidden) children.

- (2005-11-10 - RAM)
 * When a bg_task is killed, don't launch any more processing in the
   "done" callback: this cause QRP compression to attempt to send data
   on a node that was being removed.

- (2005-11-09 - RAM)
 * Re-activated suffix filtering rules.

- (2005-11-03 - RAM)
 * Added .srt (video subtitles) to the default list of shared extensions.
 * Tuned algorithm for PFSP with low amount of sources: use the amount of
   alive sources instead of the amount known in the mesh.  Also request
   the minimum filesize for PFSP as quickly as possible, but otherwise
   request the smallest chunk size first to have rapid exchanges with the
   remote server to gather more sources.
 * Added GUI mapping for new pfsp_minimum_filesize property.

- (2005-10-31 - RAM)
 * Don't pursue QRT patch sending when node connection has been broken.

- (2005-10-20 - RAM)
 * When we know a small amount of alternate sources and PFSP is enabled,
   always include ourselves in the X-Alt we generate to help propagation
   of alternates, even if the bandwidth is saturated.

- (2005-10-02 - RAM)
 * GTKG was not tracking the TTL of broadcasted messages received along a
   given connection, thereby leading it to believe it was receiving undue
   duplicates whereas the node was simply resending it with a higher TTL.
   This unfortunate bug was introduced on 2004-08-28 so all 0.95.x suffer
   from it...
 * Added workaround to allow ultra connections to old (broken) GTKGs to be kept
   without remote ending it abruptly: simply never send duplicates to those...

- (2005-10-01 - RAM)
 * Fixed buffers_strip_leading() when the stripped size equals the buffer size.

- (2005-09-29 - RAM)
 * Fixed buffers_strip_leading() when trailing I/O vector is emptied.
 * Show estimated remaining time in the Download pane as well.

- (2005-09-28 - RAM)
 * At exit time, one must not try to flush download buffers holding nothing.
 * Performance improvement, especially when running as ultra peer.

- (2005-09-27 - RAM)
 * Flush pending download buffers at exit time.
 * [GTK1] When download is done / checking SHA1 / moved, update parent's
   status in case tree is collapsed.
 * [GTK1] Always freeze the Active and Queue pane trees, updating them only
   once per second, as controlled via main_gui_timer(), or when a button press
 * Show SHA1 checking status and file moving feedback in the Download pane.
 * Revisited chunk size computation: use a more realistic estimate of the
   potential concurrency we'll get, and account for the shrinking size of
   the remaining data to be downloaded.

- (2005-09-26 - RAM)
 * Added "download_buffer_size" and "download_buffer_read_ahead" properties.
 * Buffer more data per download to avoid endless lseek()/write() system
   calls when swarming with lots of sources, and try to reduce filesystem
   fragmentation by writing more data at once.
   was done that should trigger a display refresh.

- (2005-09-25 - RAM)
 * Don't honour settings for monitoring node "bad IP / unstable" addresses
   when we're low on pongs: we don't want to discard IP addresses or
   connections and end up being forced to contact web caches for new addresses.
 * Don't use alternate locations as source for "semi-pongs" when we're not
   low on pongs: we can't know for sure that those nodes have free slots and
   that their HTTP port is the same as their Gnutella port.
 * Disable "monopoly protection" when we're low on pongs (fixes #1177512).
 * [GTK1] Buffer updates to fileinfos to avoid too frequent GUI redrawing,
   like GTK2 is already doing.  Update every second though, don't enforce a
   3 second limit. (fixes #967781)
 * Only redraw visual progress if the currently shown fileinfo is updated.
   (fixes #967781)

- (2005-09-16 - RAM)
 * Now monitors the CPU usage and lower consumption if we detect overloads.
 * Reduce amount of GUI refreshing done when CPU overloaded.
 * Added chip.xpm icon, lighted on when CPU is overloaded.
 * Optimized query routing via QRT.

- (2005-09-14 - RAM)
 * Configure will now use "mkdir -p" over "install -d" if possible to create
   directories (fixes bug #972777).
 * Detect too large UDP messages explicitly to log their dropping in the
   proper category.

- (2005-09-13 - RAM)
 * Fixed file descriptor leak in uploads (bug #1285670).

- (2005-09-11 - RAM)
 * Added robots.txt file to forbit all web crawlers from browsing us.
 * The mechanism to add special shared files was made generic.  The table
   listing them is specials[] in core/share.c.
 * Added property "bootstrap_debug" to monitor the bootstraping process.
 * [GTK1] Added GUI settting for bootstrap_debug.

- (2005-09-04 - JA)
 * [PARQ] Implemented option to always allow uploads which would take less
   than a certain amount of seconds to complete.
 * [PARQ] Show an astrisk in front of uploads which are given a quick
   upload slot (time or size based).

- (2005-08-31 - RAM)
 * Reduce the amount of time() and gettimeofday() system calls drastically.
   This should reduce the kernel time used by GTKG.

- (2005-08-31 - JA)
 * [PARQ] Added option to allow small uploads to always continue.

- (2005-08-30 - RAM)
 * Revisited download selection logic when a GIV string is received.
 * Improved tracing of the download selection logic for debugging.
 * Added another banned GUID from Morpheus hosts.
 * Added fast UTF-8 char decoder to try to reduce overhead of remappings.
 * Validate the CHNK list from the fileinfo database, using the trailer
   information if it is corrupted or missing.

- (2005-08-30 - JA)
 * [PARQ] Added setting to allow more optimistic calculation of ETA. 
   default is TRUE.

- (2005-08-28 - RAM)
 * Will now serve GTKG's favorite web icon when "/favicon.ico" is requested.
 * Typo in metaconfig symbol prevented the use of sendfile() on platforms
   that have it.
 * The OOB-proxying ultrapeer would send back the local hits to the leaf
   using the mangled MUID, instead of the original, surely causing the leaf
   to discard the replies.

- (2005-08-27 - RAM)
 * Adapt stalling threshold to the amount of upload slots configured.
 * Reduced stalling TX buffer down to 1K.
 * Count HTML and Gnutella browse host requests.
 * Show HTML and Gnutella browse host request counts in upload stat pane.
 * Don't allow dynamic upload slot allocation when uploads are stalling.
 * Added internal GUID to each fileinfo, to be perused by downloads at
   retrieval time, ensuring a download source is uniquely linked to a given
   fileinfo.
 * [GTK1] Added GUI setting for "parq_debug".

- (2005-08-24 - JA)
 * [PARQ] Added parq_debug property for PARQ specific debugging
 * [PARQ] Fixed bug where an upload got queued, with an ETA of 0s
   and all upload slots where available

- (2005-08-21 - RAM)
 * GTKG is no longer explicitly asking replying servents to skip XML in
   query hits, since it can now show the XML.

- (2005-08-20 - RAM)
 * [GTK1] Added 7 new GUI-settable debug levels.
 * [GTK1] Added provision for displaying XML data from search results.
 * [GTK1] Search results now show XML payload, if any.

- (2005-08-15 - RAM)
 * Show GTKG's version, amount of files and total size shared in HTML browsing.
 * If they advertise a host name in query hits, redirect an HTML browsing
   to the qualified host name if it was directed to the IP address, so that
   the links shown there have a longer lifetime.
 * Allow the TX deflate layer to have its buffer size / flush / nagle params
   configurable externally.

- (2005-08-14 - RAM)
 * Added size of shared files within brackets in HTML browse-host output.
 * Fixed buglet that caused no status to be displayed for completed uploads.

- (2005-08-13 - Hans)
 * Include configure options for GNU TLS. GNU TLS is enabled when
   found.

- (2005-08-10 - Hans)
 * Include configure option for IPv6. Ask the user if this should be
   enabled.
	
- (2005-08-04 - RAM)
 * Make sure we abort the upload immediately if the shared file is no longer
   present on the disk, especially when they are being queued for that
   no-longer-existing file.
 * Added full support for browse-host (server side): can now serve both
   HTML and query hits.

- (2005-08-03 - RAM)
 * Added "eager mode" to the TX stack to always have it serviced.
 * Browse host is now honouring deflate and chunked encoding.

- (2005-08-02 - Hans)
 * Initial optional D-BUS support. This code only supports D-BUS
   0.35.2. Currently only 'started' and 'stopped' events are sent. The
   gtkg-dbus-listener.py script listens for these events.
	
- (2005-08-02 - RAM)
 * New TX "chunking" driver to be able to send HTTP chunked data.
 * Both TX and RX stacks now use walloc() for memory allocation.
 * Added tx_has_error() to check for TX errors.
 * Added tx_close() with callback to be notified when transmission is closed.

- (2005-08-01 - RAM)
 * Update the server IP when we get a GIV, and recompute the server's country
   appropriately, with immediate GUI feedback.
 * Try to compute a suitable upload filename for the SHA1 digest, especially
   when PFS is enabled and we're given the digest of a file we downloaded
   but chose not to share once completed.
 * Was wrongly reporting "Already downloading that file" when the same host
   requested two distinct files via PFS.

# v 0.95.4  2005.07.31  [stable]

- The last-byte download bug, where a download would not complete if
  only the last byte needed to be downloaded, has been fixed.
- Preliminary browse-host support, allowing other servents to browse
  the files that are shared. This is disabled by default.
- GTKG will detect online status again after temporary network failure.
- The .desktop file and application icons are now properly installed.
- Downloads are now sorting in a more logical way.
- Bug fixes in UTF-8 support.
- Doxygen documentation updates.
- Japanese and Spanish translation updates.

- (2005-07-31 - RAM)
 * Added the "update" target to update the bogons and GeoIP database.
   Requires wget and perl to be installed. (meant for developers only)
 * Updated the bogons.txt and geo-ip.txt files by running "make update".
 * Mention the "make update" step in the RELEASE guide.
 * Re-instantiated step #7 in the RELEASE guide.

- (2005-06-29 - RAM)
 * Was mistakenly thinking it was reading data from the network whereas it
   simply had socket connections timeouting.  Therefore, the "offline" status
   was never activated after an Internet connection breakdown (fixes #1144460).

- (2005-05-23 - Hans)
 * The gtk-gnutella.desktop file is now properly installed so that
   GTKG can be started from the desktop menus.	
	
# v 0.95.3  2005.05.22  [stable]

- Fixed a potential denial-of-service problem.
- Fixed OOB reply code which would lead to failed assertions.
- [GTK1] Show Enable option and Remove button in Filter editor again.
- Fixed inadvertent truncation of large files (> 4 GB).
- Compatibility fixes for 64-bit platforms.


# v 0.95.2	2005.05.10	[stable]

- GTKG generated up to four times more traffic than was needed between
  GTKG Ultrapeer and GTKG leafs.
- Improved firewall status detection: if you are not firewalled then GTKG
  is now less likely to claim that you are.
- Fix a build problem for some versions of Glade
- A few minor bugs fixed
	
# v 0.95.1	2005.05.06	[stable]
	
- Bitzi tickets are now persistently cached so that tickets are
  available again after restarting GTKG.
- Improved Unicode support:
  * The use of Unicode in queries now matches that of other Gnutella
    clients. This will make it easier to search for file names which
    contain non-Latin characters. At the time of release only
    gtk-gnutella 0.95.1 and Limewire will respond properly to Unicode
    queries.
  * Files are shared with their names converted to UTF-8, and
    downloads are stored with UTF-8 file names.
  * Unicode support is now built-in, we no longer depend on the ICU
    library.
- Search improvements:
  * It is now possible to enter negative matches in search strings. If
    you enter "blah -blubb -nada" as search string, results matching
    "blubb" or "nada" are automagically filtered.
  * The search filter allows filtering for files larger than 4 GiB and
    you can also use suffixes like KB, KiB, MB, MiB etc.
- [GTK2] GUI updates:
  * You can drag & drop items under Downloads->Files e.g., to pass
    them to a audio/video player, picture viewer etc. Drag & drop is
    dangerous when used on files from unknown sources. You have been
    warned.
  * GnutellaNet has a new item "Reverse DNS lookup" in its context
    menu to perform a lookup of the peer's IP address.
  * XML data contained in search results is shown in the results
    details pane.
  * The search edit field has been moved to the top.
  * The Downloads pane was split into "Active Sources" and "Queue".
  * Compatible with GTK 2.6.x and older versions.
- The GUI uses SI prefixes according to IEC 60027-2 (2000-11) Ed. 2.0
  everywhere, so hard disk vendors won't fool you any longer.
- Compatibility fixes to allow compilation on more architectures,
  including 64 bit architectures.
  * Systems with a sendfile() that is not largefile compatible work
    again. On platforms without sendfile() we now use mmap() for
    improved efficiency.
- There are now two hostiles.txt, a system-wide ("global") and one in
  the ~/.gtk-gnutella directory. So you only need to put private
  additions into ~/.gtk-gnutella/hostiles.txt. These files are also
  automagically reloaded on change, so you don't need to restart
  gtk-gnutella to make the changes effective.
- Updated listings for geographic information, bogus addresses and
  spam sites.
- Greatly enhanced stability as compared to 0.95 due to many bug
  fixes. Other noteworthy bugs fixed are:
  * gtk-gnutella as ultrapeer was not routing any searches iff uploads
    had been disabled.
  * Problems with the UDP/TCP port setting have been fixed (bug #1091827).
- German, Japanese, and Spanish translation updated.
	
- (2004-12-23 - RAM)
 * Reject HTTP ranges for which start > end.
 * If server gives us an inconsistent Content-Length compared to the total
   file size found in Content-Range, abort the download and mark that source
   as being bad.
 * Use gm_slist_insert_after() to optimize new chunk insertion in list.
 * Added file_info_check_chunklist() assertions right after modifying the
   chunk list.
 * Added contract in file_info_update() to require from < to.

- (2004-12-04 - RAM)
 * Provide empty bitzi_init() and bitzi_query_byurnsha1() when they don't
   have libxml2-dev installed.  The GUI should disable the menu entry for
   Bitzi searches as well.

# v 0.95	2004.11.27	[stable]

- Support for very old Gnutella features has been removed or deprecated
  to keep the network healthy.  Note that GTKG 0.94 is now considered a
  deprecated servent in terms of Gnutella features.  Every GTKG user
  MUST upgrade to 0.95 as soon as possible.
- GUI updates:
 * [GTK2] Enable drag and drop for magnet links
 * [GTK1] Search results have less columns, and the hit details are now
   displayed in a separate pane underneath.
 * Visual progress indicator correctly shows newly downloaded
   fragments, shows fragments currently available for download more
   accurately, and active downloads are marked with arrows.
 * The maximum amount of search results has been lowered to 1000.  
   Please use filters or more specific queries to find what you are
   looking for if you get many search results.
 * A detailed view has been added to the search results to show all
   available information for a search result.
 * The status bar will now give feedback about the contacted host caches.
 * Gnutella node stats can now show how many bytes were sent/received.
 * In the node pane, right-clicking now allows to configure which columns
   should be displayed, just like in the search pane.
 * More general statistics in the stats pane.  It is possible to see TCP and/or
   UDP traffic stats separately (for messages only, not flow-control).
- Bitzi support has been added to retrieve additional information on
  possible downloads. See http://bitzi.com/ for details.
- The geographic location of hosts can now be shown courtesy of MaxMind.
- Recently developed features of the Gnutella network are now supported:
 * High outdegree provides better connectivity between Gnutella hosts.
   The maximum TTL in the network is now 4 and ultra nodes must maintain
   at least a connection with 30 peers.
 * Last-hop QRP between ultra peers.
 * Dynamic querying support, allows selective querying of peers instead
   of simply broadcasting the query.  It is used for leaf queries and
   for your queries when running as an ultra node.
 * OOB (out of band) query hits lets other servents deliver search
   results directly to you instead of going through the Gnutella network.
 * OOB proxied queries, allowing direct hit delivery at the ultra node level
   for queries emitted by legacy leaves.
 * GTKG will now prevent firewalled hosts from running as ultra nodes.
 * In "auto mode", GTKG will revert to leaf mode when uploads are stalling
   at an abnormally high rate, indicating bandwidth is saturated.
- UDP is now also supported as a transport protocol in addition to TCP.
  You may need to make changes to your firewall settings to take full
  advantage of this.  The UDP port used is the same as the one used for TCP.
- Firewall detection has been improved to include UDP firewalling detection.
- Clock skew computation for hosts not running NTP has been redesigned.
  Also, GTKG will now automatically detect a locally running NTP.
- Japanese translation added.
- French and German translation updated.

- (2004-11-27 - RAM)
 * Don't drop queries that have travelled more than our max TTL if they
   are requesting OOB hit delivery and we are configured to honour that flag.

- (2004-11-26 - RAM)
 * (fileinfo.c) Fixed static assert in READ_INT32 for Alpha, where time_t
   is larger than 32 bits: we just need to know that we're reading into a
   variable holding at least 32 bits.
 * Renamed configure as configure.gnu for case-insensitive filesystems.

- (2004-11-22 - RAM)
 * When sending non "alive" pings, include the "SCP" mark to get packed pongs.
 * When replying to pings from Gnutella, give them "IPP" packed addresses if
   they mentionned support for "SCP", even though the request comes via TCP.

- (2004-11-21 - Richard)
 * Merge most of hache_remove into hcache_unlink_host and made the first
   use the latter.
 * [Gtk1] Added settings_gui_init_late() to restore split_pane positions after
   main window is resized and visible.
 * [Gtk1] Added viewport around result details.

- (2004-11-20 - RAM)
 * Was only storing the freshest hosts from the cache, not the whole cache.
 * Give priority to UDP host caches.

- (2004-11-14 - RAM)
 * Don't remove a host from the cache whilst iterating over it.
 * Generation of X-Features appended a trailing space after feature name.
 * Don't send out GGEP "LOC" indication in pongs until they can configure
   that from the GUI.
 * Limited number of "normal" (legacy) nodes to which we can connect to 1 max.
 * Only emit warnings about unknown / too numerous extensions when debugging.
 * Adopted the same variable reply lengh on errors as in HTTP when bandwidth
   is saturated.  Added new error code 409 for "conflicts" and don't send out
   connection "pongs" in the headers on all 403, 406 and 550 errors.  Also
   don't send them GTKG-specific headers if we determined they were not GTKG.
 * Must shutdown OOB query hit delivery or we'll crash at shutdown time after
   having freed the UDP socket.
 * Added zlib_is_valid_header() to check for valid "deflated" buffer.
 * [GTK2] Removed spurious g_assert() when no parent for SHA1-less results.
 * Raised the max amount of alt-locs sent in GGEP "ALT" in query hits to 10.
 * Added back accidentally removed sanity check during COBS decoding.
 * Added extensive sanity checks on extensions marked as COBS and/or deflate,
   to avoid parsing garbage as GGEP.
 * Added GUI feedback in the statusbar about the web cache operations.
 * Added UDP host cache support.
 * Alternate between UDP host caches and TCP web caches when missing hosts.
 * Regenerated po/gtk-gnutella.pot and friends.

- (2004-11-14 - Hans)
 * Added Japanese translation (ja.po) from Daichi Kawahata.
 * Updated .po files to include all files containing translatable strings
   in the new directory layout.
	
- (2004-11-13 - RAM)
 * As a leaf node, refuse to connect to "ancient" ultra nodes.
 * Most vendors now send small ~4K max query hits: lower max hit size to 16K.
 * The dynamic query layer expects much less results out of a SHA1 query.
 * Added knowledge about GGEP "PATH" (unhandled for now).
 * Make sure reserved word tables are lexically sorted, for binary search.
 * Limit frequency of UDP ping replies.
 * Limit frequency of TCP/UDP crawler replies.

- (2004-11-12 - RAM)
 * Properly echo UDP crawler's ping MUID in the pong.
 * LimeWire added the user-agent of the node replying at the tail of the
   user-agent vector in the UDP crawler pong.
 * Made GGEP parsing more robust, in case we parse garbage: avoid creating
   needless extensions.  Limit GGEP IDs to ASCII strings.
 * Forgot to emit the X-Dynamic-Querying header to signal we're issuing
   dynamic queries.
 * Trim down TTL of queries coming from "older" hosts not performing dynamic
   querying if the hops+TTL is larger than the TTL at which we're broadcasting.
 * Set default for max_ttl to 4.  Cannot set a my_ttl greater than 4.
 * Added knowledge about GGEP "BH" and "CT" (unhandled for now).
 * Search results now ignore unknown GGEP extensions in tags, thereby avoiding
   display of "funny" characters in tag.
 * Handle older LIME/21v1 and LIME/22v1 messages (older specifications of
   the push-proxy requests, still used by outdated servents like GnucDNA).

- (2004-11-11 - RAM)
 * Refactored decoding of GGEP extensions: this is now done transparently
   for compressed / COBS encoded extensions.  All accesses to payload length
   and the actual (decoded) payload must now be done via routines.
 * Got rid of false plural forms "source(s)", "upload(s)", etc...

- (2004-11-10 - RAM)
 * Fixed "completion test" in incremental deflater.
 * When we don't have leaves, the UDP crawler pong builder would fail.

- (2004-11-09 - RAM)
 * Forgot to alter host_count when moving hosts between caches.
 * Added support for LimeWire's UDP crawling.
 * New properties "pcache_debug" and "udp_crawler_visit_count".

- (2004-11-08 - RAM)
 * Use MEM_ALIGNBYTES to let Configure compute the proper memory alignment.
 * Moved STATIC_ASSERT() to "common.h".
 * Make sure atom's arena is properly aligned.
 * Now parses GGEP extensions in "fat" pongs and saves them in the pong cache.
 * Emit "fat" pongs for ourselves unless we're replying to an "alive" ping.
 * Replies to UDP host cache pings ("SCP") with "IPP" extension in pongs.

- (2004-11-07 - Hans)
 * Show arrows in visual progress to indicate downloads in progress more
   clearly.

- (2004-11-07 - RAM)
 * Allow zlib_deflater to perform deflation into a supplied buffer.
 * Keep track of the amount of input we see for incremental deflation.
 * Allow COBS to perform streaming operations.
 * Fixed bug in COBS decoding.
 * Added the "ggep_debug" property.
 * New streaming interface to generate GGEP extensions replaces older one.

- (2004-11-01 - RAM)
 * Integrated GTK1 patch from Alex to display feedback on Bitzi query queuing.
 * Don't kick out nodes for relaying high TTL routed messages.

- (2004-10-31 - RAM)
 * Changed the interface for hashlist iterators.
 * Move bogons and hostiles closing after host_close() since the cache can be
   updated during the closing, and the cache now uses bogons and hostiles.
 * Periodically sync host cache to disk if dirty.
 * Converted host cache to the use of hash lists, and added save routine.
 * When inserting a host in the busy/unstable/timeout caches, remove it from
   the other host/ultra caches.
 * Don't add bogons/hostiles to the cache.
 * Disallowed the choice of "legacy mode" as peer mode.

- (2004-10-27 - RAM)
 * New property "ntp_detected" to track whether we detected NTP or not.
 * Raised default TCP RX buffers for downloads and gnet to 64K and 16K.
 * When they say they're running NTP, trust them as far as the clock skew
   goes, but don't advertise NTP unless we detect it.

- (2004-10-26 - RAM)
 * Optimized SHA1 computation (~10% gains with -O2, 20% with -O0 on a P3).

- (2004-10-23 - Richard)
 * [Gtk1] Removed autoselection controlling. Now we only autoselect the whole
   branch.
 * [Gtk1] Press "del" to discard selected search results.

- (2004-10-20 - RAM)
 * Record incoming activity to avoid marking a node "offline" too aggressively.
 * Save position of the "vpaned_results" vertical pane when exiting.
 * Save position of the "hpaned_filter_main" horizontal pane when exiting.

- (2004-10-19 - Richard)
 * [Gtk1] Added "Configure columns" to nodes pane
 * [Gtk1] [Gtk2] Removed nodes column configuration checkboxes

- (2004-10-19 - RAM)
 * Added workaround for GnucDNA bug in BYE messages.
 * [GTK1] Added bottom information for selected hits.
   Removed Host, SHA1 and Speed columns for search results.
   This now matches the GTK2 font-end presentation.

- (2004-10-18 - RAM)
 * Fixed small memory leak in core/uploads.c.
 * Remember IP of stalling uploads for a while, via the new "aging" table,
   so that we don't increase our stalling counter too rapidly when uploads
   to the same host keep stalling.

- (2004-10-17 - RAM)
 * When running out of leaf slots, kick non-sharing leaves or leaves preventing
   querying via hops-flow.

- (2004-10-16 - RAM)
 * Added bogons.txt and geo-ip.txt databases.
 * Fixed inverted logic test, causing spurious "got metainfo in filecache"
   warnings and not doing the proper things.
 * GUI properties capturing column positionning no longer rely on hardwired
   constants but use the definitions from ui/gtk/columns.h.
 * Added columns showing the country codes of the hosts (labeled "Loc").
 * Added mention that we use MaxMind's GeoIP database, per their license.

- (2004-10-11 - RAM)
 * Added "convert_old_filenames" property, FALSE by default, governing the
   sanitization of existing files in the download directory.

- (2004-10-10 - RAM)
 * Added filepath_exists().
 * Fixed indentation of parse_uint64().
 * When fileinfo's file name is sanitized and changed, the corresponding
   disk file needs to be renamed as well.

- (2004-10-06 - RAM)
 * Limit dispersion to 60 seconds for clock skew updating.
 * If they disabled uploads, don't compare leaf node outgoing b/w with HTTP.

- (2004-10-05 - RAM)
 * Ensure we always start on the Gnet pane, where connections are shown.

- (2004-10-04 - RAM)
 * Integrated bitzi patch #1037927 [From Alex Bennee].
 * Include user-supplied headers in the private file as well, in case they
   refer to constants in the vectorized properties.
 * Control dispersion during clock skew updates.

- (2004-10-03 - RAM)
 * Added pre-send checking hook to the PDU message descriptor.
 * Added the tx_flush() operation to force buffer flushing, if any.
 * The "Time Sync" messages now use the pre-sending checking hook to write
   an accurate clock timestamp.
 * Message queue now rely on the pmsg_check() pre-send hook to determine
   whether a message can be sent or not.
 * When writing a control message, make sure TX buffers are flushed, if needed.
 * Alive pings now use the pre-send checking hook to ensure that only the
   pings recorded last are sent on a given connection.
 * Fixed memory leak in alive ping management.
 * Switch to TCP if they don't answer our "Time Sync" requests via UDP.
 * Added auto-detection of NTP running on local host.
 * Tooltip for "Host runs NTP" now mentions GTKG will auto-detect NTP.
 * Correct remote clock seen in the Date HTTP header by the amount of time
   necessary for the headers to travel back (estimated from HTTP roundtrip).
 * Better clock skew computation and update algorithm, based on statistics.
 * The Date HTTP header was not using clock skew to correct time.

- (2004-09-29 - RAM)
 * Added "Time Sync" vendor messages.
 * Accept clock synchronization from same IP if the precision is better.
 * Count unclaimed and partially claimed OOB locally-generated hits.
 * Show TCP/UDP round-trip times as determined from "Time Sync" messages.

- (2004-09-28 - RAM)
 * The header to emit is X-Push-Proxy now, not X-Push-Proxies.

- (2004-09-27 - RAM)
 * Assume the majority of servents will now understand bounded Range requests.
 * Leaf node's TX buffer size was too small for decent output.
 * Count GIV callback requests we get.
 * Count QUEUE callback requests we get.
 * Ensure UDP socket gets a large RX buffer size, to avoid dropping datagrams
   if we're busy and we can't process them yet.
 * The "improbable SHA1" detection now recognizes trivial sequences.
 * Check GGEP "H" and "u" in query hits for improbable SHA1.

- (2004-09-26 - RAM)
 * When debugging, always show bad SHA1 and old-style SHA1 in the logs.
 * Force "auto mode" when they run as ultra mode and get firewalled.
 * When bandwidth is not capped, adjust the maximum used to show the
   used bandwidth so that sudden bursts don't cause subsequent display
   to show negligeable percentage.
 * Ensure we see either the yellow or the red bomb icons, but never the two
   at the same time.
 * Don't decrement TTL during routing if it was 0.
 * Always send a PONG with personal information, even when the local IP
   address is unknown.
 * Raised max # of downloads to 5000, default auto-retry timeout to 300 secs, 
   and default connecting timeout to 60 seconds.

- (2004-09-25 - RAM)
 * Now assumes that all servers support the /uri-res/N2R? file requesting.
   We don't really want to download anything from older servents anyway.
 * Ignore improbable SHA1 made of identical bytes, either in their base32
   encoding or in their binary form.
 * Count the GTKG queries and requeries we see, as well as queries for which
   we can reply using GGEP "H" for SHA1.
 * Tell them every 5 attempts that they're banned instead of 10.
 * Revisited the computation performed to determine whether we can be an
   ultra node: only use the EMA of the outgoing b/w if they have running
   uploads.  Lowered b/w requirements to only 128 B/s per connection.
 * Account for "uploads_stalling" when determining whether we have enough
   b/w to stay an ultranode.
 * Double time spent as a leaf node in auto-mode each time we switch back
   to leaf mode.

- (2004-09-24 - RAM)
 * Fixed warning about badly configured proxy, which must be emitted only
   when a proxy is chosen.
 * New "H=xxx" statistics for nodes, enabled when dups/bad etc... are
   configured for display, showing the amount of messages bearing an
   hostile IP address which we get from the node.
 * Tell them in the search statusbar when the search was stopped.
 * Don't show the origin IP address of UDP-delivered hits if it matches the
   one held in the query hit.
 * Append "alt" to query hits bearing alt-locs.

- (2004-09-23 - RAM)
 * Keep track of whether we receive solicited UDP traffic.
 * Send an UDP ping to our peers when we connect and we're not sure whether
   we can get UDP solicited traffic.
 * Ensure we can receive solicited UDP traffic before advertising OOB hits.
 * New property "uploads_stalling" to track abnormal upload stalling.
 * New property "recv_solicited_udp" to determine whether we can perform
   UDP hole punching.
 * [GTK1] [GTK2] Will now show a warning if uploads are stalling abnormally,
   and a firewall with a green hole if we can perform UDP hole punching.
 * Count UDP hits bearing a different IP address from where they're sent from.
 * Don't count the IP as alien if the hit's address is that of a private
   network, in case the servent is firewalled.
 * Have shell announce the program's version.
 * [GTK1] Frame where icons are displayed will now properly shrink when an
   icon is hidden.
 * Named frame where icons are displayed to be able to shrink it.
 * Setting of OOB queries is now an "expert" frame.
 * Don't send PUSHes too often.  Just because we don't get a reply immediately
   does not mean the PUSH is not travelling its way.
 * Show IP address of UDP-delivered hits.

- (2004-09-21 - RAM)
 * Added dh_would_route() for the OOB-proxying layer to be able to determine
   whether the hits it would claim would be delivered to the leaf or
   thrown away by the dynamic hit layer.
 * Deleted obsolete code in download_push_insert() and download_push_remove():
   select_push_download() has already all the logic to grab the proper
   download when a GIV is received.
 * Let dynamic query know about unclaimed OOB-proxied hits.
 * Raised timeout for "Query Status Response" to 30 seconds.
 * Don't send dynamic query to another node if we already queued but not
   sent 3 queries to other nodes.
 * Send "Query Status Request" as a control prioritary message.

- (2004-09-20 - RAM)
 * Fixed OOB-proxy routing logic to no longer use the routing table: we keep
   the ID of the leaf node originating the query around.
 * Don't claim UDP results fro OOB-proxied query when the leaf node is
   in TX flow-control.
 * Don't check for TTL=0 on hits for OOB-proxied queries.
 * Can only check the IP of neighbours setting the OOB flag on queries, since
   the UDP port can be different from the TCP port.
 * Was not displaying instantaneous RX traffic rate for the pseudo UDP node.
 * Count the amount of OOB hits received for OOB-proxied queries.
 * Count the amount of queries we see with the OOB flag set.
 * Improved delivery of query hits to searches by making it faster to locate
   a search given a MUID.
 * Raised the timeouts for dynamic querying slightly, to see if we can get
   less traffic overall and less results during lingering period.
 * Monitor the hostiles.txt file and reload it automatically if it changes
   (closes RFE #1003129).

- (2004-09-19 - RAM)
 * Automatically demote an Ultrapeer that appears to be TCP-firewalled.
 * Fixed routing debugging logs.
 * Added core -> UI bridge routine guc_statusbar_warning().
 * New property "routing_debug" to control debugging for message routing.
 * Warn them in the statusbar if they attempt to choose a non-leaf mode
   and they are firewalled.
 * [GTK1] [GTK2] Added GUI mapping for new "routing_debug" property.
 * Implemented OOB-proxying of queries, when running as ultranode.
 * Ammended the routing policy of queries to account for duplicate OOB-proxied
   queries that would differ only in the IP:port of their MUID.
 * New property "proxy_oob_queries" to control OOB-proxying by the ultranode.
 * New general statistics: GNR_OOB_PROXIED_QUERY_HITS,
   GNR_QUERY_OOB_PROXIED_DUPS and GNR_OOB_PROXIED_QUERIES.
 * [GTK1] [GTK2] Added GUI mapping for new "proxy_oob_queries" property.

- (2004-09-18 - RAM)
 * Must not reset n->socket after processing data from UDP node, since we
   can issue an UDP message at any time, therefore the n->socket must stay
   set at all times.  Removed node_udp_release().
 * Fixed binary search for vendor messages: was assuming there would not
   be duplicates with only the version number changing in the table, but
   this was forgotten and the table lists messages with different versions
   as different entries.  Caused it to not process UDP connect back correctly.
 * Added more search statistics at the bottom of each search window.
 * Drop OOB queries with a bad "return address" i.e. queries coming from a
   neighbouring node and whose IP:port for return does not point back to the
   issuing node.
 * Strip OOB flag on queries whose return adddress is a private IP.

- (2004-09-15 - RAM)
 * Was not accounting received queries and query hits for the UDP node.
 * If they remove the pseudo UDP node, it will disable UDP.
 * Handle GTKG/7v2, where GUID of the ping is taken from the MUID instead
   of from the payload.

- (2004-09-13 - RAM)
 * RX dropped packets are now accounted for in gnet_stats_count_dropped().

- (2004-09-12 - Hans)
 * Update visual progress code to avoid flickering and fix small problems
   with the code.
 * Create separate event for available ranges updates for more efficient
   handling of fileinfo information.
 * Provide initial version of a manual in doc/manual. The manual is in
   DocBook XML format. Currently it is only an outline. Please commit
   a placeholder or let me know if you would like to work on a specific
   part.

- (2004-09-11 - RAM)
 * Will now send queries marked for out-of-band hit delivery.
 * Out-of-band hit delivery is now enabled by default.
   Changed tooltip comment for property to explain the user benefits.
 * Tag hits received from UDP in search results with the string "udp".
 * Strip OOB flag for leaf queries that also advertise they're firewalled.
   Chances are that if they are TCP-firewalled, then they're UDP-firewalled
   as well.
 * Added GUID generation for OOB queries.
 * Forgot to arm the timer for monitoring absence of unsolicited UDP traffic.
 * Update RX traffic size for the pseudo UDP node.
 * Fixed statistics bookkeeping for dropped UDP messages.
 * New properties "show_gnet_info_tx_wire" and "show_gnet_info_rx_wire"
   to govern display of TX and RX bytes, as sent/read from the wire.
 * [GTK1] [GTK2] Can now ask to display bytes sent/read from the wire for
   each node connection.

- (2004-09-10 - RAM)
 * UDP listening is now enabled by default.
 * Strip OOB flag of OOB queries from leaves where the IP:port encoded in
   the GUID of the message does not match the leave's ones.
 * Dropped stats did not update the TCP-only and UDP-only stats.
 * Smarter UDP-firewall (unsolicited traffic) detection: now keeps track of
   the IP to which we sent datagrams for 2 minutes to avoid falsely marking
   the node as not-firewalled when we receive data from those IPs.
 * Added node_gnet_ip() and node_udp_get_outq().
 * Will now drop UDP messages coming from hostile IP addresses.
 * Added an "alive_ping" object to the pseudo UDP node for proper display
   of round-trip stats for that node.
 * Adapted the query hit generation process to OOB hits, since we must not
   deliver those immediately but need to buffer them instead.
 * Can now honour the OOB flag in queries and deliver hits out-of-band.
 * Added support for vendor messages LIME/12v2 and LIME/11v2, delivered via
   UDP to negotiate delivery of OOB query hits.
 * New property "query_debug" for debugging queries.
 * GUI was not reporting Gnet b/w properly: it needs to sum the TCP and UDP
   traffic shapers since allocated b/w is halved between those two.
 * [GTK1] [GTK2] Added spinbutton for "query_debug" setting.
 * Skip messages that cause an error during UDP write, but continue processing
   remaining messages.
 * Allow EINVAL as a legitimate error cause for sendto(), since apparently
   linux returns this for weird IP addresses, like "0.76.207.219".

- (2004-09-08 - RAM)
 * Moved query hit generation from share.c to new qhit.c.
 * Changed process for generating query hits: the matching code now generates
   a list of hits, and that list is then traversed to generate the necessary
   query hit messages.
 * Changed frequency of inter-UP QRP exchanges: now performs one update every
   5 minutes instead of one every 90 secs.

- (2004-09-06 - RAM)
 * Added UDP bandwidth schedulers for Gnet traffic, taking half the bandwidth.
   The other half being given to the TCP Gnet traffic.  Both auto-steal their
   unused bandwidth, if necessary.
 * Added new UDP message queue.
 * The pseudo UDP node is now advertised and shown in the GUI.
 * Extended the wrapped I/O with sendto().
 * Show pseudo UDP node in GUI as being of type 'P'.

- (2004-09-04 - RAM)
 * Fixed typo causing aggregated TCP+UDP stats to be returned when TCP stats
   were requested.
 * Fixed the "crash when closing search" bug.
 * Was accounting stats for HSEP message exchanges as "unknown"!
 * Reply to an UDP ping with an UDP pong.
 * Keep statistics about UDP traffic.
 * Found the origin of the "race condition" that caused assertions to fail
   in dh_pmsg_free().  We just can't assert at that point.

- (2004-09-03 - RAM)
 * Keep and allow retrieval of TCP and UDP stats, separately or in
   aggregated form.
 * New property "gnet_stats_source" to select the TCP/UDP source for stats.
 * Added gnet_stats_tcp_get().
 * [GTK1] [GTK2] Message stats can show TCP-only traffic, UDP-only, or both.
 * [GTK1] [GTK2] Added icons showing TCP-only and UDP-only firewall status.
 * Firewall status can now have 4 states: fully firewalled, TCP-only,
   UDP-only and not firewalled.  The UDP firewall is shown only if UDP is
   enabled.

- (2004-09-02 - RAM)
 * Implemented dynamic querying for local queries, when running as an
   ultra node.

- (2004-09-01 - RAM)
 * Made sure we keep the route on GTKG/21v1 reception, and that we simply
   remove the new NODE_F_PROXIED flag on the node.
 * Lowered the default maximum amount of results shown from 5000 to 1000 to
   both save on memory and incite users to setup filters or emit more specific
   queries.

- (2004-08-31 - Hans)
 * Visual progress indicator now correctly shows previous and newly
   downloaded chunks.
   
- (2004-08-30 - RAM)
 * Message queue now maintains whether queue is within the warn-zone range
   (between hiwat and lowat) to update node's flag as soon as the condition
   changes.
 * Added support for GTKG/21v1 "Push-Proxy Cancel" vendor message.
 * Show used charset at startup time.

- (2004-08-29 - RAM)
 * Added count of bytes/packets queued to be able to monitor the amount of
   bytes/packets dropped whilst in the TX queues.  New columns "queued" and
   "gen. queued" will show the queued bytes/packets from received and locally
   generated packets respectively.  Column "generated" renamed "gen. sent".
 * Check for OOB queries in node_can_send(), since we need to forward them
   regardless of whether there exists a route for replies.
 * Split huge route_message() routine in smaller parts.
 * When we get unsollicited guidance info for a dynamic query, there is no
   need to query the leaf before proceeding with the next ultra node.
 * Vendor message table was accidentally not sorted, messing the binary
   search logic and causing valid messages to be ignored.
 * Now sends BEAR/12v1 "query status response" as a prioritary message.
 * Leaf nodes will now send unsollicited BEAR/12v1 to their ultranodes
   reporting kept results each time they get new query hits from the network.

- (2004-08-28 - RAM)
 * Allow forwarding of queries and pushes that were already seen with a
   lower TTL, but don't process them again.
 * Raised max for "reserve_gtkg_nodes" to 90 and lowered min for
   "unique_nodes" to 10.
 * Forgot to tie the GUI button for "convert_spaces" to the property, hence
   setting in the GUI had no effect.

- (2004-08-28 - Hans)
 * Move available ranges (blue line in visual progress) code from the gui
   to the core.
	
- (2004-08-18 - RAM)
 * (move.c) Fixed stupid floating point exception on a debug message
   when elapsed == 0
 * Removed dependency between file.c / sockets.c and ban_reclaim_fd().

- (2004-08-16 - RAM)
 * Added new properties for UDP support: "udp_debug", "enable_udp",
   "is_udp_firewalled", "process_oob_queries", "send_oob_queries".
 * Added support for UDP firewalling detection.
 * Can now process incoming UDP Gnutella messages as if originating from
   a "fake" UDP node.
 * Will now recognize incoming UDP ping bearing our GUID as a sign that
   we can receive unsollicited UDP traffic.
 * pcache_pong_fake() now takes only ultranode addresses.
 * Make sure we never route queries and query hits received from UDP.
 * Added support for UDP sockets.
 * Special-case display of vendor code with all zeroes as "null".
 * Added support for GTKG/7v1 "UDP Connect Back" vendor message.
 * [GTK1] Updated GUI to be able to configure UDP, OOB querying, and
   debug levels.
 * (settings_gui.c) Shuffled to move the propery table near the end to
   avoid pre-declaration of most callbacks.  Added UDP configuration
   and debug level settings.

- (2004-08-14 - RAM)
 * Added gmsg_infostr_full_split() and gmsg_infostr_full() that can
   add extra information when logging vendor messages.
 * New vmsg_infostr() to extract vendor message information for logging.
 * (qrp.c) Fixed memory leak.
 * Accept BYE, HSEP and vendor messages with TTL=0 or TTL=1.
 * New properties "vmsg_debug" and "search_debug".
 * Always reply to handshaking ping (first ping we accept) with personal info.
 * Don't revitalize route entries for leaf nodes but for the PUSH routes we use
   when we're sending PUSH messages.
 * Parse (but ignore for now) the "features supported" NULL/10v0 message
   which supplies extra capabilities without negotiating them via handshake
   headers.
 * If leaf queries us with OOB hits delivery and does not support guidance,
   strip the OOB flag from the query to be able to monitor the hits they get.

- (2004-08-13 - RAM)
 * Removed the "unrequest reply" drop reason, replaced by "no route".  It was
   used only by query hits, whilst "no route" was used only by "pushes".
 * Changed the way the routing table is organized to be able to remember
   active routes (for query hits or pushes) longer than unused ones.

- (2004-08-12 - RAM)
 * Increased routing table size to keep at least 30 minutes of traffic.
 * Handle query hits we don't route, in case they have alt-sources we
   could peruse.
 * If query hit is dropped for flow-control reasons, account it as such.

- (2004-08-10 - RAM)
 * Ensure "size != 0 => file_size_known" in fileinfos and create_download().
 * Added parsing of GUID for queries with OOB query hit delivery.

- (2004-08-09 - RAM)
 * Whith leaf-guided dynamic queries, adjust the number of kept results when
   comparing to the maximum allowed, since leaves return the total amount
   of results, not the ones received from just our connection.
 * Fixed assertion that forgot to account for kept results.
 * No longer drop node for sending/relaying messages with TTL=0: simply
   ignore the bad message and go on.
 * Now try to support BearShare and its great (not!) idea of acking an
   alive ping with a TTL=0 ping!
 * Make sure we always log something in debug mode when seeing a bad packet.
 * Send PUSH requests at the highest TTL we can, i.e. hard_ttl_limit and
   not max_ttl which is only for broadcasted messages.
 * Use ping-pong roundtrip times to guess a relevant timeout for the
   "Query Status Request" message sent for leaf-guided dynamic queries.

- (2004-08-08 - RAM)
 * To allow safe data access to the free routine invoked for extended messages,
   we must not unref the data before calling the free routine in case we were
   holding the last reference to those data.
 * Refactored the single monolithic message_array[] routing table into
   a dynamic set of smaller chunks, to ensure we will keep routes at least
   20 minutes.
 * Fixed unfortunate bug in token.c that prevents an older version from
   validating the token from a more recent version if the recent version
   has more keys to compute the level with than the older can check for.
 * Fixed assert failure on reception of query hits that is handled
   locally but not routed.
 * Added support for leaf-guided dynamic queries (client and server sides).

- (2004-08-07 - RAM)
 * Forgot to call node_inc_sent() when sending a queued message, as opposed
   to one immediately written at mq_putq() time.
 * Added "n->last_tx" and use that when detecting activity timeouts, making
   sure that there is something in the queue (or it would not be updated).
 * Reverted changes made to node_reserve_slot() and node_avoid_monopoly()
   which tried to make a distinction for UPs between incoming and outgoing.

- (2004-08-06 - RAM)
 * Fixed some of the "file_size_known" madness.
 * Whether the file size is known or not is now persisted in the fileinfo,
   as the "FSKN" attribute in the ASCII file, and as part of the version 5
   binary format in the file.
 * Show "no size" when the size is unknown, shorter than "unknown size".
 * Fixed qrp_route_query() to send query to all non-QRP aware UPs if TTL=1.
 * Fixed improper routing of TTL=1 queries, which could be sent twice to
   QRP-capable nodes: once if the QRP matched, and once via regular broadcast!
 * Make dynamic queries that stopped linger for a while to see how many
   extra results we get due to node latencies.  New statistics track the
   amount of extra results we get that way.
 * Don't send a TTL=1 dynamic query to a host whose QRP says it won't be
   able to match.
 * If a QRP-capable UP did not send its table yet, forward it everything.
 * Introduced the "dynamic query hit" algorithm: this actively monitors
   hits we relay, keeps track of how many hits we sent and can decide
   to drop hits if we're in flow control or relayed too many hits already.
 * New "dh_debug" property.
 * Drop query hits with 0 results.
 * Have search_results() indicate to caller the amount of hits held in the
   query hit it parsed.
 * The flow-control flag can now show 'D' if we're not in flow-control
   yet but the queue is more full and bears a greater delay for sent
   messages (queue size above the low watermark).

- (2004-08-05 - RAM)
 * Implemented dynamic querying.  For now, it's only plugged for leaf queries.
 * Fixed re-entrance problem when an event was rescheduled before the current
   trigger time by another event that fired.
 * Added 5 general statistics about dynamic queries and their status.
 * Added new "dq_debug" property for debugging dynamic querying.
 * Emit and parse headers for dynamic querying.
 * Added hack for LimeWire, emitting the garbage it wants from leaves to
   consider them good.
   It is a bug from LW to require those meaningless headers from leaves.
 * Enhanced pmsg to have support for free routine callbacks.
 * It is now possible to mark messages as being sent, for checking in the
   free routine afterwards.

- (2004-08-05 - Jeroen)
 * When avoiding vendor monopoly, make a difference between outgoing and
   incoming connections. 

- (2004-08-05 - Jeroen)
 * Commited some stuff for G2 support, to avoid I lose it again.

- (2004-08-03 - RAM)
 * Updated hostiles.txt from BearShare's list.
 * Removed spurious and wrongly placed call to header_features_generate()
   from http_async_build_request().
 * The "up_req_*" properties were wrongly saved in the config file.  Since
   they're transient and dynamic, it's useless to persist them.
 * New "up_req_enough_conn" property to track whether they configured enough
   peer connections to maintain to become an ultra node.
 * Show whether they configured "Enough min # of connections" to be
   auto-promoted an ultra node.
 * New flag "Z" for connections that compress both TX and RX.  "T" is shown
   when only TX is compressed, "R" is shown when only RX is compressed.
 * New flag "X" indicating whether we sent our last-hop QRP table to the remote
   ultra node.  The "Q" flag in that case indicates whether we received the
   last-hop QRP from the remote node.
 * Added support for high outdegree and last-hop QRP between ultra nodes.

- (2004-08-02 - RAM)
 * Converted getline.c and http.c to doxygen-style comments.
 * New IO_SAVE_HEADER flag to instruct the ioheader parsing layer to
   save a copy of the header text, as it was received.
 * Forward queries with TTL=0 to leaves, as QRP tables permit.
 * Added specifications for inter-UP QRP, dynamic queries and leaf-guided
   queries.

- (2004-08-02 - Hans)
 * Show gray progress bar when the file size of a downloadable file is not
   known.

- (2004-08-01 - RAM)
 * Made gchar_to_ip_strict() return host byteorder IP addresses, to be
   consistent with gchar_to_ip().
 * Updated styleguide: in files using doxygen comments, the function name
   must now be put at the very beginning of the line to have it stand out.
 * Added new fields in fileinfo trailer: CTIM the creation time and NTIM
   the last time when we got a new source.
	
- (2004-07-24 - Hans)
 * Make 'Purge' button on the 'Files' tab inactive when file has been
   completely downloaded. Fixes #922920.

- (2004-07-19 - TNT)
 * Added option 'ALL' to the remote shell command 'HORIZON'. This option
   will output the total horizon size as usual (including non-HSEP nodes) and
   will then output the horizon size of each directly connected HSEP node. May
   come handy for checking/debugging purposes.

- (2004-07-15 - Jeroen)
 * Enabled drag and drop for the GTK2 interface for magnet links.

- (2004-07-14 - Jeroen)
 * Added initial support for downloads with unknown size. Patch from emile
 
- (2004-07-13 - RAM)
 * Make sure PONG messages hold a reasonable number of files, i.e. detect
   servents that did not encode the value correctly by advertising an
   absurdly large number of files.  Then try to fix the total size shared.

- (2004-07-10 - Richard)
 * [Gtk1] Replaces GtkFrame around progress indicator in fileinfo pane
   with a GtkViewport
 * Removed gui_update_all()
 * Renamed gui_update_global() to gui_general_timer()
 * Moved gui timer calls from gui_update_global() to main_gui_timer()
 * Added doxygen support to: gui.c search_gui_common.c
 * Moved gui_add_targetted_search() as search_gui_add_targetted_search()
   to search_gui_common.[ch].

# v 0.94	2004.07.10	[stable]
- GUI updates:
 * File info pane renamed to downloads
 * Downloads pane renamed to sources
 * Progress of a download can now visually be showed. This will show which
   fragment of a file was downloaded, which fragment gtkg currently is
   downloading and which fragments are availalbe on the gnutella network.
 * Uploads and download sources pane now contain a visual progressbar.
 * GTK2 can now be resized smaller then 933 pixels width.
 * Search results now include an extension column so you can sort by
   extension if needed.
- HSEP included, this will give you an estimation of the horizon size. This
  includes the number of files and the total size of all files on the network.
- If no default port was specified, gtkg will now bind to a random port and
  will use that port from that point.
  If you are behind a firewall and routed a port to gtk-gnutella, please check
  gtk-gnutella still runs at the port you want it to run!
- Will parse up to 150 hosts in a gwebcache reply to bootstrap from.
- New hostcache to make gtk-gutella faster connect to the network.
- Dutch translation updated.
- German translation updated.
- Spanish translation updated.
- French translation updated.
- Hungarian translation updated.

- (2004-06-25 - Richard)
 * Reverted changes in hcache.c from last commit. Instead made those changes:
 * No longer call hcache_remove_all() from hcache_free().
 * Made hcache_free() fail if hostcache is not empty.
 * Fail if for some obscure reason hosts are added during hcache_close. This
   can normally only happen if we are multi-threaded, which we are afaik not.
 * Check that hostlist and host_count are in sync when hcache_remove_all() is
   done.

- (2004-06-24 - Richard)
 * Fixed segfault in hcache.c on shutdown due to accessing hostcaches
   which had already been freed at that point. 
   (Thanks to Clayton Rollins for the backtrace)

- (2004-06-23 - Richard)
 * [Gtk1] Ported "extension" column in search results from Gtk2.

- (2004-06-21 - RAM)
 * Switched to ISO date formats in ChangeLog, as well as in code comments.
 * Don't loose a source if we can't connect due to a lack of file descriptors.
 * Remind them they're banned every BAN_REMIND attempts.

- (2004.06.16 - JA)
 * Hopefully fixed phantom downloads due to PARQ callback

- (2004.06.14 - TNT)
 * Changed HSEP implementation to also send out information about all
   our non-HSEP neighbors (PONG-based library size). This should make the
   horizon stats more accurate, even though we don't know anything about
   what non-HSEP neighbors see as their horizon.
 * [Gtk1] [Gtk2] Changed statusbar and gnet stats panel to also include
   horizon information about all non-HSEP neighbors. The horizon stats
   on the gnet stats panel are now updated every 2 seconds.
 * Updated .pot/.po file generation to include all source files that contain
   translatable strings.

- (2004.06.10 - Hans)
 * The blue line in visual progress indicating the bytes available on the
   network now also takes servents sharing the full file into account.
	
- (2004.06.09 - Hans)
 * [Gtk1] [Gtk2] Use more efficient handling for size of visual progress
   indicator and remove obsolete code.
	
- (2004.06.08 - Richard)
 * Use hash table instead of list for faster lookup in node_is_connected()
   and node_host_is_connected().
 * Split up gnet.h into several files for better readability. 
   All are included from gnet.h.
 * Changed algorithm for quick-connecting to utilize only up to 
   PROP_QUICK_CONNECT_POOL_SIZE connections instead of using 
   them additionally to the maximum number of connections.
 * Changed large parts of the host cache code. We now have seven host caches
   and we can get stats for them.
 * Adjusted default hostcache capacities.
 * Removed "unstable ip" code from nodes.c. This is now handled in hcache.c.
 * Started with doxygen support.
 * Added file_config_open_append to file.c. Needed by new hostcache code.
 * Moved host_hash, host_eq and host_cmp as public functions to hosts.c.
 * Made host_is_valid(ip,port) a define. The function is now ip_is_valid(ip).
 * Pongs from hosts that are marked bad in the host cache are no longer added
   to the recent pong cache.
 * [Gtk1] [Gtk2] Minor layout fixes which were not in the last commit.
 * Manually added new files to the build files. Somebody who can regenerate 
   the build files and known about the package files has to double-check this.
   
- (2004.06.07 - Richard)
 * [Gtk1] [Gtk2] Added hostcache panel.
 * [Gtk1] [Gtk2] Added horizon stats labels to the statusbar.
 * [Gtk1] [Gtk2] Made quick-connection pool size configurable.

- (2004.06.06 - TNT)
 * Added German translation (de.po). Still needs a little
   fine-tuning.

- (2004.06.04 - TNT)
 * [Gtk2] Added horizon stats table to gnet stats pane. Rearranged
   and optimized pane layout.

- (2004.06.04 - Jeroen)
 * Fixed compilation error due to removed property

- (2004.06.03 - Jeroen)
 * Applied HSEP patch 8, this adds HSEP info to the gnet stats pane
   for gtk1. By Thomas Schuerger

- (2004.05.01 - Hans)
 * [Gtk1] [Gtk2] Fix crash bug in visual progress indicator when
   displaying info for small files.
	
- (2004.04.25 - Hans)
 * [Gtk1] [Gtk2] Show ranges which we have seen to be available on the
   network as part of the visual progress indicator.
	
- (2004.04.18 - Richard)
 * [Gtk2] Activated 'fixed_height_mode' for the nodes TreeView.
 * [Gtk1] [Gtk2] Made the search retry timeout an expert setting.
 * [Gtk1] [Gtk2] Made the autoselection feature an expert setting.
 * Renamed some of the autoselection properties to assure they are
   reset an a new start.
 * [Gtk1] [Gtk2] Changed autoselection policy and moved relevant code
   to search_gui_common.c
 * [Gtk1] Reducted number of times results are resorted in
   download_selection_of_ctree().

- (2004.04.18 - Hans)
 * [Gtk1] [Gtk2] Fix several bugs in visual progress code.
	
- (2004.04.15 - Richard)
 * [Gtk1] [Gtk2] Changed layout of fileinfo pane to integrate progress indicator.
 * Made progess indicator use the complete drawing area.
 * [Gtk2] Added toolbar buttons back.
 * [Gtk2] Minor adjustments to the layout of the network config pane.
 * [Gtk2] Removed searches combo from search pane put a label there instead.

- (2004.04.15 - Jeroen)
 * Added cache.kicks-ass.net:8000 to the webcaches
 * Check for new version now only checks for newer releases of the current
   version if the current version is unstable. But will still look for newer
   releases of stable versions

- (2004.04.15 - Richard)
 * [Gtk1] Added toolbar style selection combo to gui config pane
 * [Gtk1] [Gtk2] Added icons for PROP_FILE_DESCRITOR_SHORTAGE and
   PROP_FILE_DESCRIPTOR_RUNOUT
 * Updated filter.xpm
 * [Gtk1] [Gtk2] Tried to fix memory lead in visual progress indicator. 
   Small leak is still reported but probably due to the gui never being 
   actually destroyed.
 * [Gtk1] [Gtk2] Adjusted colors in progress indicator.

- (2004.04.12 - RAM)
 * (gwcache.boot) Re-initialized from GhostWhiteCrab's verified peer list.
 * Don't publish our IP to web caches if we're a normal (legacy) node.
 * Removed connection to GWC at startup.  Wait 8 hours to do that!

- (2004.04.11 - RAM)
 * Renamed parq_is_banned_source() into parq_banned_source_expire() and
   have it return the expiration date of the banning.
 * When GTKG rejects an upload with "403 ... removed from PARQ", it will
   include a Retry-After header to indicate the banning limit, since
   further requests from the host will be back-holed.
 * When downloading, treat GTKG's "403 ... removed from PARQ" specially,
   looking for a possible Retry-After to know when retrying will be possible.

- (2004.04.11 - Hans)
 * [Gtk1] [Gtk2] Fileinfo pane now contains a visual indication of the
   download progress for the selected file.
	
- (2004.04.10 - RAM)
 * Will now parse up to 150 hosts in hostfile replies.
 * Change webcache everytime we want to perform an action, in case we
   hit a bad cache that ignores our updates silently or replies with
   bad (static!) data.

- (2004.04.07 - RAM)
 * Added my own web cache, now that I run GhostWhiteCrab/0.1.
 * Only write readable filenames in done.sha1.

- (2004.04.02 - RAM)
 * (hostiles.c) Avoid side effect when calling isspace().
 * Removed default cache on raphael.manfredi.free.fr, which was erased.

- (2004.03.28 - RAM)
 * [GTK1] Fileinfo filtering now also applies the regexp to fileinfo aliases.
 * Compile glade-generated files last, to save time when there is an error
   elsewhere.

- (2004.03.26 - Richard)
 * Show queued status in fileinfo pane. (Closes #916976)
 * Comment out GTK_GNUTELLA_DIR export in run script.

- (2004.03-17 - Richard)
 * [GTK1] Slight layout change in the fileinfo pane.
 * [GTK2] Purging of multiple files is now possible.

- (2004.03.15 - RAM)
 * [GTK1] Added anti-crash countermeasures for memory corruption in GUI
   search results data.  Does NOT fix the root cause!

- (2004.03.14 - Richard)
 * [Gtk1] [Gtk2] No longer clear "Select" field in the download queue
   after pressing [enter].
 * [Gtk1] Add filtering to fileinfo pane.
 * [Gtk1] Minor layout change on the downloads pane.
 * Really remove file from disk when pressing "Purge" in the fileinfo page.

- (2004.03.10 - RAM)
 * Increased size of gnet header response for better Crawler replies, since
   GTKG can support 200+ leaves.

- (2004.03.09 - RAM)
 * Don't call make_room() with "needed <= 0".
 * Applied HSEP patch #6 from Thomas.

- (2004.03.06 - RAM)
 * Fixed typo that prevented renaming files to *.OK/*.BAD correctly when the
   filename on disk was not readable (i.e. an URN).
   
- (2004.03.03 - Richard)
 * [Gtk2] Minor layout change on the nodes panel
 * Regenerated glade files

- (2004.03.03 - RAM)
 * Removed constraint on bg_task_signal(): can be called from a non-running
   task, since otherwise daemon taks can have difficulties using it in their
   start/end callbacks!
 * (move.c) Added termination signal handler to allow background task to
   remove the target file if GTKG is shutdown in the middle of a move
   operation.
 * On restart, when re-queuing a file with a computed SHA1 for moving, don't
   forget to suspend all the queued files.  Normally this is done when we
   start the SHA1 computing process, but that can be bypassed when restarting.

- (2004.03.02 - RAM)
 * As per RFE #906834, use ISO timestamps in User-Agent string.
 * New version of Spanish translation by Paco Arjonilla.
 * [GTK2] Updated for 64-bit Gnet stats. [Patch from Russell Francis]

- (2004.03.03 - Jeroen)
 * Fixed compiler error on some compilers
 * When in random port mode, retry a new port of the random chosen port
   could not be binded. (Also the 1 - 1024 is now tried)
 * HSEP Typo fix from Thomas

- (2004.03.02 - Jeroen)
 * Included HSEP patch 5 from Thomas.
 * Added shell patch 6
 * Default port is now 0, which is now treated as 'choose a random port'. So
   all new installations will now choose a random port to listen on.

- (2004.03.01 - RAM)
 * (hsep.c) Cleanup of code, and fixed a bug on big-endian machines.
 * Made header_get_feature() more robust, to avoid matching sub-words.

- (2004.02.29 - Jeroen)
 * Included HSEP patch 3 and 4 from Thomas.

- (2004.02.24 - Jeroen)
 * Included initial HSEP support files from Thomas Schuerger.

- (2004.02.21 - RAM)
 * Added compact_size64().
 * Switched Gnet stats to 64-bit arithmetic.

- (2004.02.16 - Emile)
 * [GTK1] When a parent node is downloaded from the search tab (but not its
   children), GTKG will now correctly update parent hashtable
   (fixes bug #892593).
 * [GTK1] When search results are sorted by count, GTKG will now correctly
   re-sort column if a single node is downloaded

- (2004.02.15 - RAM)
 * Also use "friendly download name" (i.e. non-URN) when renaming completed
   file locally after a failed copy.
 * Protect against "errno == 0" on failed open().
 * Even if we can't start the move/verify thread correctly for an item,
   invoke the download state change callbacks.
 * Must use integer arg when calling ctype functions (fixes bug #897252).
 * Must count two file descriptors per upload slot and active download: one
   for the socket and one for the file being read/written.
 * New properties "file_descriptor_shortage" and "file_descriptor_runout".
 * Activate "file_descriptor_shortage" each time we call ban_reclaim_fd()
   and we succeed.  We set "file_descriptor_runout" when there is nothing
   more to reclaim.  Both properties are reset after 10 minutes.

- (2004.02.14 - Richard)
 * [Gtk1] Try to avoid memory corruption during selection in search results due
   to recursive calls of on_ctree_search_results_select_row(). 
   Should close #892802.
 * [Gtk1] Added a general gtk_ctree_count_node_children() to gtk-missing.[ch].
 * [Gtk1] [Gtk2] Removed property PROP_JUMP_TO_DOWNLOADS. 
   I don't think we need this anymore.
 * [Gtk1] Added PROP_SEARCH_CASESENSE. This controls if the name column in the
   search results is sorted case-sensitive.
 * [Gtk1] Cleant up a few places in search_gui.c and fixed part 2 of bug #892593
   in the process. Maybe part one is also fixed.
 * [Gtk2] Fixed compiler warnings about redefinition of g_string_printf and
   g_string_printfa in malloc.h.
 * Number of leaks is now reported in the leak summary.
 * [Gtk1] Small GUI layout fixed in the downloads and fileinfo panes.

- (2004.02.13 - RAM)
 * Don't call unicode_canonize() on non-UTF8 strings.

- (2004.02.06 - Jeroen)
 * I am back, so lets start with tiny things ;)
 * Fixed a couple of compiler warnings
 * Fixed a possible segfault when using ICU and iconv_open failed

- (2004.02.06 - Richard)
 * [Gtk1] Fix sorting by name in the search panel. Result from 
   search_gui_compare_records() was interpreted wrong.
 * [Gtk1] Changed search_gui_quick_sort_array_swap to be faster.

- (2004.02.01 - RAM)
 * Don't include a partial file in the mesh if we don't have 512K of it, or
   at least 10% of it.
 * Added IP:port + vendor string to warning about weird HTTP status.
 * Fixed looks_like_urn() which was not detecting names made out of a
   single SHA1.

- (2004.01.31 - RAM)
 * Reopening the 0.94u line.
 * Allow main window to shrink width below 933 pixels (fixes bug #885659).
 * When moving files, don't leave the target file around when an error occurs.

- (2004.01.27 - RAM)
 * Security fix in proxy code [Found by Leonardo H. Liporati].

- (2004.01.27 - Hans)
 * [Gtk2] Show progress bars in the up- and download lists to indicate
   progress [from Russell Francis, patches 873182 and 874590].
	
# v 0.93.3   2004.01.25  [stable]

- GUI updates:
  . New node info display configuration: show library size / # of files shared,
	configurable from the Config / User interface pane.
  . Number of file descriptors currently used for banning is now shown.
  . Increased search results sorting speed for GTK1.
  . Moved "close" button for searches to a more convenient position, in
	the upper right corner.
- Default number of node connections raised to 12 now that many servents
  support high outdegree.
- Eradication of memory leaks.
- Enhanced flow-control algorithm that will more aggressively drop packets
  (including query hits) when the connection remains clogged for too long.
  This new "swift" mode is indicated by the 'S' flag instead of 'F'.
- Bug fixes: #846755, #876011, #857075, #874596, #859761, #762121.

- (2004.01.25 - RAM)
 * If the last QRP patch message contains only zlib trailer data to mark
   the end of stream, don't consider it as a spurious message: just ignore it.

- (2004.01.20 - RAM)
 * Only call message_add() at the end of forward_message() since that call
   could modify the validity of the `dest' list we get as an argument.
   (should fix bug #846755 and bug #876011).

- (2004.01.19 - RAM)
 * Abort download_clear_stopped() if there's nothing in `sl_unqueued'.
 * Don't call downloads_gui_init() before settings_gui_init().
 * Fix overwriting of already read data when parsing more than one line
   [Patch from Thadeu Lima de Souza Cascardo, fixes bug #857075].

- (2004.01.18 - RAM)
 * Changed minimum for "node_connected_timeout" to 120 and the default to 180,
   since we must account for possible flow-control, both at the node and TCP
   level.
 * Try to account for PARQ active upload slots when looking whether we have
   enough file descriptors to become an UP, but lower the impact of banned
   fd since we can now steal them when we run out of available ones.
 * Lowered banned IP timeout to 6 hours, and mark IP as bad on connect timeout.
 * Fixed default returned value for add_host_to_cache() to FALSE.
 * (downloads_gui.c) Optimized to do without the costly count_node_children()
   routine.
 * Routine gui_update_download_clear() now only records that we need to
   figure out the sensitivity of "Clear Stopped".  However the real change is
   only performed once per second via gui_update_download_clear_now().
 * Must perform downloads_gui_init() before settings_gui_init() due to
   the use of property callbacks that can trigger GUI code, and because we
   now cache the results of lookup_widget() in downloads_gui.c.
 * Periodically call gui_update_download_clear_now() from download_timer().

- (2004.01.18 - Richard)
 * Count number of unstable nodes and hits on node_is_bad and node_ip_is_bad.
   Numbers are reported if core debug level is > 1.
 * Don't add bad ip adresses to the host caches in extract_field_pongs.
 * [Gtk1] Disable "expand all" and "collapse all" when no search is open.
 * [Gtk1] Fix possible crash if sorting on less then 50 results (Thanks Emile).

- (2004.01.17 - RAM)
 * Allow 6 unanswered "alive pings" in a row instead of 4 for UP connections.
 * Fixed incorrect list_delete_link_track() implementation causing memory havoc.
 * (search_gui.c) Removed needless atom_str_get() calls.
 * Redirect big walloc() calls to malloc_track() under TRACK_MALLOC,
   instead of g_malloc(), to not lose the source of the leak.
 * (dmesh.c) Made sure we cleanup the banned mesh by IP at close time.
 * Added g_string_*() trapping when -DTRACK_MALLOC.
 * Fixed stupid (recent?) typo preventing proper recording of the user-agent
   for uploads.
 * (downloads.c) Fixed memory leak.

- (2004.01.17 - Richard)
 * Cleaned up gtk-missing.h.
 * [Gtk1] Hopefully fixed sorting when any node in the results was expanded
   by iterating only over the top-level nodes when sorting. Refactored
   some of the code in the process and added a couple of FIXMEs for later
   releases.
 * [Gtk1] Hopefully fixed a few memory leaks in the download pane probably
   caused by calling g_list_free() not on the first element of a GList.
 * [Gtk1] In the search pane two more leaks reported by the leak detection 
   code should be fixed.
 * [Gtk1] Fixed crash when "expand all" or "collapse all" was pressed and
   no search was open.

- (2004.01.16 - RAM)
 * Added trapping of g_slist_() and g_list_() routines that allocate linkable
   objects under the hood.  Added trapping for hash_list new/free as well.
 * (bsched.c) Fixed list leak.
 * (uploads.c) Fixed possible atom leak.
 * (downloads.c) Forgot to cleanup d->escaped_name at exit time.
 * (uploads_gui.c) Made an explict free_data() callback for TRACK_MALLOC.
 * (nodes.c) Fixed memory leak.

- (2004.01.16 - Richard)
 * Replaced a number of g_free with G_FREE_NULL.
 * [Gtk1] [Gtk2] Moved "close" button for searches to a more convenient 
   position in the upper right.
 * Made dmesh_remove state if it really removed something (preparetion
   for XNalt support).
 * [Gtk1] Integrated fast-sorting patch from Emile le Vivre.
 * Moved init code from main_gui to downloads_gui.
 * Moved hash_list code from glib-missing.[ch] to hashlist.[ch].

- (2004.01.15 - RAM)
 * Added tracking for atoms (enabled with -DTRACK_ATOMS).
 * (dmesh.c) Fixed atom leak.
 * (gwcache.c) Fixed atom leak.
 * (huge.c) Fixed memory leak.

- (2004.01.14 - RAM)
 * Added custom debugging malloc support.
 * Added trailing inclusion of "override.h" to all C files.
 * (share.c) Removed spurious comment termination.

- (2004.01.13 - RAM)
 * (downloads_gui.c) Removed spurious g_strdup() call.

- (2004.01.12 - RAM)
 * Display the amount of file descriptors currently used for banning.
 * New property "banned_count".
 * Default number of node connections raised to 12 now that many servents
   support high outdegree.
 * Don't ping all our neighbours on pong-cache expiration: only select
   20% of them, randomly, with at least 3 being selected.
 * (event.c) Fixed free(0) call and switched to walloc() for subscriber
   allocation.
 * Must use file_fopen_missing() when reading the pid file.
 * New flow-control mode called "swift" mode, shown with an 'S' instead of 'F'.
   This mode is activated when we have spent some time in flow-control and
   need to flush the queue faster, at the price of dropping more messages,
   and possibly some query hits.
 * Changed minimum for "node_tx_flowc_timeout" to 90 secs (was 60 secs)
   since new "swift" mode needs at least 70 secs to clear the FC condition
   with 95% probability.

- (2004.01.11 - RAM)
 * Fixed "fi->lifecount > 0" assertion failure when backing out data after a
   resuming mismatch.
 * When we run out of socket descriptors, try to close a banned fd, if any
   (both when making out a new connection or accepting one).
 * Made ban_reclaim_fd() a public function, that can be used when we run out
   of file descriptors.
 * Make sure pixmaps and other regular files are installed without
   the 'x' bit set.
 * Generalized call to ban_reclaim_fd() when opening files on out-of-fd
   condition by introducing the file_open() and file_create() calls.
 * Decreased node unstable cleanup timer from 1 day to 0.5 day.
 * New node info display configuration: show library size / # of files shared.
 * New properties: "show_gnet_info_shared_size", "show_gnet_info_shared_files".
 * When applying a patch message, make sure they did not already fill the
   QRP table before processing (should fix bug #762121).
 * Don't blindly assume pong information with hops=0 comes from the node,
   as LimeWire suffers from a bug breaking this assertion.
 * For prettyness, don't show a library size of 8K when the # of files shared
   is 0 (all UP will advertise 8K sharing so that this amount is a power of 2).
 * Remove -licuuc from the list of libs when it is present but does not
   contain the functions we want (fixes bug #859761).
 * Don't force bit 0 of amount of Kbytes shared to 1 if they share nothing.
 * Don't consider pongs with less than 8 kbytes shared as being ultra pongs.
 * Added file_open_missing(), and file_fopen*() routines.
 * Error logging is now assured by file_open*() and file_fopen*() routines.

- (2004.01.10 - RAM)
 * Fixed assert failure when all the entries from the cache are deleted.
 * When GTKG thinks it is offline, don't even try to do GWebCache updates.
 * [GTK1] Fixed titles[] array sizing using enum constants, avoiding too
   small sizing causing memory corruption [Patch from Thomas Schuerger].
 * [GTK2] Don't abort a download entry if it is a pseudo-header [Patch
   from Russell Francis] (fixes #874596).

- (2004.01.10 - Richard)
 * [Gtk1] [Gtk2] Reverted changes to hostcount display from 2004.01.08
 * Moved generation of hostname for downloads pane to downloads_gui_common.c.
 * Fixed a memory leak in search_gui_common.c when search_hide_downloaded
   was activated.

- (2004.01.08 - Richard)
 * [Gtk1] [Gtk2] Show active and trying hosts seperatly when counting hosts
   in download pane. Format: "n hosts (m)" n - active, m - trying.

# v 0.93.2   2004.01.05  [stable]

- (2004.01.05 - RAM)
 * Fixed memory leak.

# v 0.93.2   2004.01.04  [stable]

- Numerous GUI updates:
 . GTK1 now supports groupped searches and groupped downloads, like GTK2 did.
 . GTK1 and GTK2 GUIs were brought in sync feature-wise, as much as possible.
 . Gnet pane will now show leaf nodes and normal nodes in light gray.
 . Fixed memory leak problems in the GTK2 interface that slipped in 0.93.1.
- Bandwidth requirements to become an ultranode were lowered significantly.
  This is due to the filtering of SHA1 queries through QRP now, instead of
  systematically forwarding them: gtk-gnutella assumes all servents out there
  include the SHA1 URNs in their QRP tables.
- As a result of the above, default amount of leaf nodes was increased.
- Added a special fix for BearShare: the HTTP headers which gtk-gnutella
  emitted used continuations, and were well-formed, but BearShare was
  misparsing those, causing it to enter an endless loop...
- Search results are now buffered by the GUI for burst updates, which reduces
  CPU usage and the amount of redrawing significantly.  The buffering time
  is configurable from the GUI.
- gtk-gnutella is now fully compliant with LimeWire regarding I18N queries,
  provided you have the ICU library.  Otherwise, it should be OK for roman
  charsets only.

- (2004.01.04 - RAM)
 * New property "search_accumulation_period" for burst period configuration.
 * Made the burst interval period for search refresh configurable from the GUI.
 * New header formatting routines: header_fmt_set_line_length(),
   header_fmt_value_fits() and header_fmt_append_value().
   Changed signature of header_fmt_make() to include default separator.
   Default line length set to 78 chars (was 72).
 * Changed signature of dmesh_alternate_location() to include whether we're
   emitting alt-locs in a request or in a reply.
   No longer format X-Alt and X-Nalt with continuations in requests, and
   to BearShare nodes on replies (due to a parsing bug in BS causing its crash).
 * Lowered min size for QRP tables to 16K.
 * Finished normalization of filenames/queries when the ICU library is
   present [From Stephane Corbe].

- (2004.01.04 - Hans)
 * [Gtk1] Show leafs and "normal" (legacy) clients in grey in the nodes list.
 * [Gtk2] Update nodes and uploads lists to show rows in grey in line with Gtk1
 * Updated i18n .po and .pot files based on current code
 * Updated Dutch translation
	
- (2004.01.04 - Richard)
 * [Gtk1] [Gtk2] Show icon when gtkg determines that it is ancient.
 * Props that have default values are saved as comments, so they can be
   upgraded to new defaults on version upgrades. [from Globuz]
 * Fixed critical bug in results-bursting code.

- (2004.01.04 - Emile)
 * [Gtk1] Fixed autosort for "count" column
 * [Gtk1] Added "Push mode" status for downloads tree
 
- (2004.01.04 - Richard)
 * Implemented "results bursting". That means that the gui accumulates
   incoming results over a period of time and then flushes them out to display
   in a burst.
   This technique drastically reduces the number of redraws. Unfortunately I
   had to inject some #ifdef USE_GTK1 into search_gui_common.c. I hope you can
   bear with me ;) The burst interval is currently hardcoded at 5 seconds
   in search_gui_common.c::search_gui_flush().
 * [Gtk1] "results burting" causes CTrees affected by the burst to be frozen
   during the burst and unfrozen later.
 * [Gtk2] the TreeViews are not frozen, but Gtk2 seems to handle the burst 
   intelligently and doesn't redraw during the burst all by itself. *shrug*
   Further testing is required here.

- (2004.01.03 - RAM)
 * Added a continuation on X-Queued: line, which was longer than 80 chars
   when we emit lifetime and ETA information.
 * Now count failed push proxy resolutions as well.
 * Now always emit alternate locations via X-Alt:, so got rid of the old
   code that emitted X-Gnutella-Alternate-Location headers.
 * Lowered maximum query monitoring half life to 10 seconds.
 * Changed computation formula for QRP pass-throw now that we filter SHA1
   queries through the table.  The cut-off is now fixed at 5%.
 * Another series of patches from Emile le Vivre:
   [GTK2] emove expand/collapse all buttons from search pane because they
   didn't fit and because the expand all button wasn't updating the
   treeview.
   [GTK1] Fixes autosort (except for count column for some reason)
   [GTK1] Adds "connecting" and "queued" status messages to grouped downloads
   [GTK1] Fixed "restart search" seg fault
   [GTK1] Fixed autoselect to update the ctree so autoselected rows show up
   immediately.
 * (downloads_gui*.c) Removed spurious atom_int_get()/atom_int_free() calls
   that do not strike me as beeing needed, but added explicit atom_int_get()
   in the add_parent_with_fi_handle() routine.
 * (downloads_gui.c) Made sure the hash tables are declared with g_int_hash
   and g_int_equal to work properly with integer keys.
 * (downloads_gui.c) Avoid too frequent updates and structure traversals to
   update the parent tree summary info when its GUI info is fresh enough.
 * Fixed long-standing race condition when receiving a GIV string.
 * [GTK2] Fixed crash when clicking twice on Purge in the fileinfo pane [From
   Hans de Graaff].
 * Changed default for "node_rx_flowc_ratio" to 70%, and raised minimum
   to 30%, to allow traffic bursts.

- (2004.01.03 - Richard)
 * [Gtk1] [Gtk2] Lots of layout changes to assimilate the gtk1 and gtk2 guis,
   to clean up layout in general and to fix paddings and spacings.
 * [Gtk1] [Gtk2] Unhid the "current search" entry in the search panel again
   as users requested so.
 * [Gtk2] Applied patch to fix column visibility on the gnet pane
   [from Clayton Rollins].
 
- (2004.01.02 - RAM)
 * Fixed conflict ratio computation when they don't share anything.
 * New properties to control ancient versions.
 * Warn them before the version becomes too old, and refuse to run without
   user manual action when we become old, after some grace period.
 * A series of patches from Emile le Vivre:
   [GTK1] Adds grouped downloads
   [GTK1] Adds collapse/expand buttons to downloads tab
   [GTK1] Fixes errors in autoselect
   [GTK1] Fixes memory leak
 * Offer ability to backout file by some amount on resuming mismatch
   [From Hans de Graaff].
 * Changed definition of char_map_t to be guint8 instead of (signed) char.
 * Count and display in gnet stats pane the amount proxified push messages
   we relayed or broadcasted.
 * Fixed hole in flow-control updating after message write.

- (2004.01.01 - RAM)
 * Halved requirements for gnet connections: with dynamic querying, there is
   less traffic between peers (GTKG does not support it yet though).
 * Raised size of gnutella handshake reply and that of generated crawler
   info to accomodate the larger number of leaves we can now support.
 * [GTK1] Added treeview in search results, in line with GTK2's GUI [From
   Emile le Vivre].
 * Don't remove gtk-gnutella.pot in "realclean" since we distribute it.
 * When looking at memory requirements for becoming an ultranode, take into
   account flow-control via the maximum message queue size.
 * Fixed assertion failures, and cleaned-up style issues, unused variables.
 * Update gnet connection counts in gnet bandwidth progressbar immediately
   when user changes some maximum, in ultra mode.
 * Factorized drop message logging in gnet_stats.c.
 * A series of patches from Emile le Vivre:
   [GTK2] Adds "expand/collapse all" popups for search and download tabs
   [GTK2] Adds "expand/collapse all" buttons for search tab
   [GTK2] Adds "Search results" frame around searches tab (missing since
   we moved the new search entry to the lefthand pane).
 * Applied ICU patch from Stephane Corbe.

- (2003.12.31 - RAM)
 * Added "emergency fixing" code: if the downloading partition gets trashed,
   one can now reconstruct a fileinfo with "grep -v ^CHNK fileinfo", and
   gtk-gnutella will correctly reset the entries on startup (all empty, but
   kept; otherwise gtk-gnutella would delete entries for missing files).
 * Moved periodic refreshing of fi->recv_last_rate into the core, where
   it belongs.
 * Wrote qrt_eq() to check whether the new table we've built is identical
   to the previous one: don't install if no change.
 * If the incremental routing patch is larger than the default one against an
   empty table, discard it in favor of a RESET plus the default patch.
 * Filter SHA1 queries differently: don't forward them blindly if there's no
   matching in the QRP table, and don't forward them to leaves in TX flow
   control.
 * [GTK2] Fix time remaining and k/s status for grouped downloads: now
   uses the core-computed fi->recv_last_rate value [From Emile le Vivre].
 * A series of patches from Emile le Vivre:
   [GTK2] Fixes the memory leaks introduce by Emile's grouped downloads patch.
   [GTK2] Fixes quirky behaviour for abort popups.
   [GTK2] Aborted grouped downloads now update status column correctly.
 * Apply socket RX buffer changes for downloads and nodes immediately to all
   existing connections.
 * Now advertises Query-Routing 0.2.
 * Now that we no longer forward all SHA1 queries to leaves, the bandwidth
   requirement per leaf has dropped significantly.  Increased the default
   number of leaves and halved b/w requirement to 32 bytes/sec/leaf.
 * Update flow-control indication within make_room() in case we dropped
   enough messages to go below the low watermark.

- (2003.12.29 - RAM)
 * Removed logical negation causing extra ultranode connections to be rejected
   with "Reserved slot" instead of the appropriate "Too many ultra nodes".
 * [GTK2] Fixed column selection in gnet pane: it's a tree in GTK2, not
   a clist [From Clayton Rollins].

# v 0.93.1   2003.12.28  [stable -- 2nd version]

- (2003.12.29 - RAM)
 * Restored "hu" support -- did not see the hu.po there.
 * Added po/hu.po and src/downloads_cb2.h to MANIFESTs.

# v 0.93.1   2003.12.28  [stable]

- Simplified the GUI for non-experts.  Beginners will now see less
  curious things on the screen, until they become more acquainted and
  turn on "expert" mode.
- Many improvements in the GUI:
  . The Gnutella node information displayed can now be configured in
	detail, and is by default reduced to four statistics only.
  . It is possible to hide the handshaking version and the Uptime column
	from the Gnutella pane.
  . When running in auto mode, show the criteria for becoming an ultranode.
  . The leaf node bandwidth odometers are by default automatically hidden
	when running as a leaf node.
  . GUI refreshing has been optimized so we don't unnecessarily refresh
	screens that the user is not looking at.  The downside is that when
	moving to that screen, stale data is presented for about 1 second until
	the refreshing takes place.
- 0.93 was not reporting uploaded partial files as such to downloading peers.
- Remote control "shell" is now compiled in by default but needs to be
  explicitly enabled in the GUI to become operational.
- Improved connectivity between ultrapeers to avoid frequent disconnection
  due to "activity timeout".
- Bugfixes:
  . Was misparsing query hits bearing alt-locs attached to each hit, causing
	GTKG to possibly drop those hits and close the connection when coming
	from an immediate neighbour.
  . When restarting a search from menu, re-enable it automatically if it
	was disabled (fixes bug #864348).
  . Upon restart, a disabled search will now be shown in gray in the
    search list (fixes bug #857972) -- feature only implemented for GTK1.
- Many other little changes that we'll let you discover...

- (2003.12.28 - RAM)
 * [GTK1] Renamed "Search for" as "Search:" to save horizontal real-estate
   and have a larger search box.
 * Ensure that we update the uploads every 5 minutes at least, even if nobody
   is watching to perform cleanup of dead entries.
 * [GTK2] Brought up in sync with GTK1 [From Clayton Rollins].
 * Ensure that we update the nodes every 5 minutes at least, even if nobody
   is watching to perform cleanup of dead entries.
 * Cache result of lookup_widget(main_window, "notebook_main").
 * Put column definition enum for gnet pane in gui.h, to be in line with
   the way it's done for others.
 * Only update downloads if we're in the "Downloads" tab.
 * Put column definition enum for fileinfo pane in gui.h, to be in line with
   the way it's done for others.
 * Some download states must always be updated whether they are looking or
   not since we won't periodically refresh the GUI.
 * Added statistics properties about library scanning and QRP patch generation.
 * [GTK1] Added "expert" statistics frame showing library scanning time and
   some properties about the QRP table and the generated patch in the upload
   config pane.
 * New "fileinfo_divider_pos" property to remember the postion of the
   fileinfo vertical separation.
 * [GTK1] Remember the vertical position of the fileinfo pane separation.
 * Fileinfo callback were not prepared to handle (FREQ_SECS, 2), otherwise
   change notifications are lost when adding/removing sources.
 * Forgot to handle the GTA_DL_REQ_SENDING state in download_timer().
   Now that we do, we can skip the GUI update for that state if they're
   not looking.
 * [GTK1] Turned off "expand" from "frame_gnet_can_become_ultra".
 * [GTK2] GUI brought up in sync with GTK1 again [Thanks to Clayton Rollins].

- (2003.12.27 - RAM)
 * Due to a stupid typo, we were denying promoting nodes to UP even if the
   bandwidth requirements were met [Patch from Sebastian Bork].
 * [GTK1] Upon restart, a disabled search will now be shown in gray in the
   search list (fixes bug #857972).
 * When restarting a search from menu, re-enable it automatically if it
   was disabled (fixes bug #864348).
 * Added properties to track ultrapeer eligibility status and switching time.
 * [GTK1] Added a frame showing ultrapeer promotion statistics when running
   in "auto" mode.
 * Applied cleanup patch for tree-view downloads (GTK2) [From Emile le Vivre].
 * Added new properties for configuring the search queue, whether to enable
   the "shell" remote control, whether and how tightly we should monitor
   query traffic for duplicates, and for how long we should keep "dead"
   entries for GUI display before removing them.
 * Fixed download columns for GTK1, broken by Emile's patches.
 * Raised atexit() timeout to 20 seconds.
 * When computing average servent uptime and IP lifetime for ultranode
   promotion, take into account the current uptime and IP lifetime.
 * Query traffic monitoring is now controlled by GUI-settable properties.
 * Must always perform nodes_gui_node_info_changed().
 * Must always perform upload_info_changed().
 * When autoselect is disabled in the search pane, prevent them from being
   able to select the fuzzy matching or identical settings...
 * Now that remote control can be disabled from the GUI, compile it by
   default but do not activate it.

- (2003.12.26 - RAM)
 * Don't send QUEUE callbacks for entries we no longer share [Patch from
   Hans de Graaff].
 * Changed min/max values for Gnutella message sizes now that they can be
   configured from the GUI.
 * Introduced many new GUI properties:
   . node_show_uptime
   . node_show_handshake_version
   . node_show_detailed_info
   . show_gnet_info_XXX [15 of them]
 * [GTK1] Added ability to configure Gnutella message sizes in expert mode,
   as well as the ability to customize some of the columns and info display
   in the gnutellaNet pane.
 * Use dynamic configuration to generate the node "Info" column display.
 * Added symbolic constants to refer to node columns.
 * Optimize GUI refreshing of nodes and uploads to only perform it when
   the GUI displays the node or upload page.
 * Integrated bugfix in random chunk shuffling for PFSP [From Hans de Graaff].
 * Applied patch to introduce tree-view for downloads [From Emile le Vivre].

- (2003.12.25 - Richard)
 * Increased similarity between gtk1 and gtk2 interfaces.
 * [Gtk1] [Gtk2] More padding fixes.
 * [Gtk1] In bandwidth config panel changed layout to match that of the 
   Gtk2 interface.
 * [Gtk1] [Gtk2] Updated gui maintainer entry in about dialog.
 * [Gtk1] [Gtk2] Changed label of expert mode toggle to
   "Show additional information and settings for advanced and expert users"
 * [Gtk2] Added "Compute upload connection speed" setting to config pane.
 * [Gtk2] Socket recieve buffer size settings visible only in expert mode.
 * [Gtk2] No more Gtk-Critical when loading gtkrc file. rc-file loading code
   now uses ~/gtkrc for gtk1 and ~/.gtkrc-2.0 for gtkg. This is correct 
   on my Debian system and hopefully also on other systems. (Analogous for
   the rc files in the gtkg config dir.)

- (2003.12.24 - RAM)
 * Transferred bytes are now shown in short size form, followed by the
   verbatim value between parenthesis.
 * Added a short_size64() routine for 64-bit values.
 * Don't call bsched_clear_active() too often: only once per period.
 * PARQ will now guard a slot for 45 seconds after a remote disconnect.
 * Special handling for stalled uploads being replaced in parq_upload_get().
 * Enforce the maximum uploads per IP after PARQ, since it seems there is
   a race condition somewhere.
 * [GTK2] Fix from Russell Francis putting back socket RX buffer size
   selection into an "expert" frame.
 * Treat all input exceptions during download as an EOF condition.

- (2003.12.24 - Richard)
 * [Gtk2] Changed lots of paddings and spacings so they are more uniform.
 * [Gtk1] [Gtk2] Applied suggestions of Emile le Vivre for gui simplification:
   - moved to expert mode:
     - hostcatcher (gnet panel)
     - transfered files stats (gnet panel)
     - local node information (gnet panel)
     - 'add passive' searches (sidebar)
   - Searches: current search combo removed (only hidden for now), 
     redesigned settings panel, moved adding of new searches to sidebar,
     moved a few buttons around
   - Sidebar: moved adding of new searches here
   - Config: a few minor changes in the gnet settings to make gtk1 and gtk2
     look more similar.
 * [Gtk1] [Gtk2] Added option to automatically hide leaf bandwidth stats
   when not in ultrapeer mode (default: on).
 * [Gtk1] Fix sidebar resizing when traffic stats are hidden (a hack, but 
   it seems to work)

- (2003.12.21 - RAM)
 * Don't update drop statistics on high TTL when running as a leaf node and
   don't bother running through the routing computation for forwarding
   a message since leaf nodes will never actually route messages.
 * Don't queue up a new query message in the queue if we already have an
   unsent message in the queue originating from the same search.

- (2003.12.20 - RAM)
 * PARQ will no longer send QUEUE when uploads are disabled.
 * Changed semantics of reported connection speed: it is now the connection
   speed in kbits/s for each upload slot, not a global one.
 * New property "compute_connection_speed", TRUE by default.
 * [GTK1] Added GUI interface for "compute_connection_speed" configuration.
 * [GTK2] Patch from Russell Francis adding the avail b/w display like in GTK1.

- (2003.12.17 - RAM)
 * Changed some property defaults:
	 node_monitor_unstable_servents -> FALSE (was TRUE)
     max_leaves -> 48 (was 100)
 * Changed minimum bandwidth requirements per leaf (128 bytes -> 64).
 * [GTK1] Removed unused "Default minimum speed" configuration in the
   Config / Gnutella pane.
 * [GTK1] Changed increments for bandwidth changes via PageUp and PageDown
   to be 5 units, and increments for the speed reported to peers to be 8 units.

- (2003.12.16 - RAM)
 * New property "dl_http_latency".
 * Downloads now maintain a measure of the HTTP latency between request
   and reply.
 * [GTK1] Added display of total limited bandwidth in the Config / Bandwidth
   pane, as well as the current measure of the HTTP latency.
 * Don't count TTL=0 messages when we're a leaf node since we handle them.

- (2003.12.15 - RAM)
 * Changed some timeouts minima values, and added the ".aac" extension (MP3
   clone from Apple).
 * Added two new properties: "download_rx_size" and "node_rx_size" to
   configure the socket RX buffer size.
 * [GTK1] Added "expert" settings to configure the RX buffers of sockets.
   This can greatly impact the latency when downloading many files or
   connected as an ultranode.

- (2003.12.14 - RAM)
 * Removed remaining Gnutella 0.4 handshaking code.
 * Fixed IP TOS settings: only change it when downloading/uploading, but
   leave normal TOS when exchanging headers.
 * Don't forward random pongs to leaves that are already in TX flow control.

- (2003.12.13 - Jeroen)
 * Intergrated patch from Clayton, adds vendor preferencing to the gui 

- (2003.12.11 - RAM)
 * Changed compact_size() to display an even more compact string when the
   size is an even multiple of Kbytes, Mbytes, etc...
 * Added some query routing table stats for ultrapeers to monitor their leaves.
 * Suppressed activity timeout between ultra nodes and leaves.

- (2003.12.10 - RAM)
 * Added warning when running under debug level tracing the BYE received.
 * When we're a leaf node, don't issue any "Activity Timeout" to our
   Ultranodes.  If the connection went dead, this will be caught by their
   not replying to our alive pings, after 8 minutes.
 * Added query throttle.
 * Make sure to initialize `last_update' when creating a node, to avoid
   it being immediately selected by the node_timer() thread for removal!
   Restored the activity timeout check...
 * When remote Gnutella node does not reply correctly or issues a 401 reply,
   remember his IP address as being bad.
 * Keep query/ hit statistics per node (TX & RX) and measure QRP efficiency
   for leaf nodes.

- (2003.12.09 - Jeroen)
 * Intergrated and somewhat adjusted patch from Thadeu Lima de Souza Cascardo.
   Use the WHATIS command in the remote shell to get the 'tooltip' of a
   property
 * Intergrated and modified patch from 'wwp' to parse gtkrc file in local
   directory and gtk-gnutella config directory
 * Intergrated and somewhat adjusted patch from Paco Arjonilla. 
   Added internationalization for the gnutellaNetstats tab messages.
 * Changed the following default settings:
   - max_connections 			4 -> 9
   - node_connecting_timeout 		10 -> 30 seconds
   - node_connected_timeout  		45 -> 90 seconds
   - node_tx_flowc_timeout		60 -> 180 seconds
   - scan_extensions added: 		xvid
   - strict_sha1_matching    		FALSE -> TRUE
   - prefer_compressed_gnet  		FALSE -> TRUE
   - download_require_server_name 	FALSE -> TRUE
   - max_leaves				15 -> 100
   - node_monitor_unstable_servents	FALSE -> TRUE
   - unique_nodes			67	-> 50
   
- (2003.12.09 - RAM)
 * Allow them to issue a duplicate upload if the original began to stall.
   The new upload will simply replace the previous one.
 * Added "[weird #n]" tagging string to all debugging warnings emitted when
   we increase the weird message count for a node.
 * Was misparsing HUGE URNs followed by GGEP extensions, causing spurious
   "Security Violations" disconnections from GTKG peers.
 * Throttle queries that are re-emitted too soon or too closely in time
   to not be related.
 * Renamed "Ping throttle" as "Message throttle" since we can now throttle
   both pings and queries.

- (2003.12.07 - RAM)
 * Count the amount of bytes actually sent back for each upload request.
   This amount is displayed when a data timeout occurs.

- (2003.12.04 - RAM)
 * Don't attempt QUEUE callback if we don't have enough bandwidth left to
   issue a connection.
 * Exported socket_tos_*() routines and added sock_is_corked().
 * Detect recurrent upload stalling conditions, and try to workaround
   the problem.

- (2003.12.03 - RAM)
 * Try to account for the bandwidth used by TCP/IP, which can become
   significant when many connections are issued concurrently.
 * Don't return alt-locs for ourselves if they enabled PFSP-server but
   disabled sharing for now.

- (2003.12.02 - RAM)
 * Now shows real instantaneous bandwidth usage and not a fast EMA.
 * Fixed some possible usage of uninitialized variables.

- (2003.11.25 - Jeroen)
 * Removed dead gnucleus gwebcache

- (2003.11.24 - RAM)
 * Don't hammer the same webcache if we can't connect.
 * New strcmp_delimit() routine to compare strings up to a delimitor.
 * Revisited node_avoid_monopoly() and node_reserve_slot().
 * [GTK1] Was not low-lighting the right search in list when disabling.
 * Added check for EACCES for FreeBSD.

- (2003.11.22 - Jeroen)
 * You can now reserve a number of slots for gtk-gnutella nodes only
   (current default: 33%)
 * You can now prevent one vendor from taking over all your gnutella
   node slots. Current efault one vendor may take maximum of 67%.
   These settings are not available through the GUI

- (2003.11.11 - RAM)
 * Fixed http_send_status() to no longer ignore the given keep_alive parameter,
   even with 2xx return codes.
 * Pass the u->keep_alive status to http_send_status() on 2xx replies.

- (2003.11.10 - RAM)
 * Use average upload bandwidth consumption to compute PARQ ETA values.
 * Flag query hits carrying a push-proxy indication.

- (2003.11.09 - RAM)
 * Forgot to include "settings_gui.h" in main.c.
 * Forgot to allow X-Available-Ranges emission on HTTP 2xx returns.
 * Don't expire pong cache for leaves as often as in ultra mode.

- (2003.11.08 - Jeroen)
 * Fixed hevcnt <= G_N_ELEMENTS(hev) assertion bug
 * Purge button now available in GTK2 interface
 
- (2003.11.07 - Jeroen)
 * Added Hungarian translation from Sulyok Pï¿½ter

- (2003.11.06 - Jeroen)
 * Intergrated shell patch from Thadeu Cascardo.
 * Fixed assertion bug for GTK2.
 - Both GTK1 and GTK2 should be fully functional / usable again
 
- (2003.11.03 - Jeroen)
 * Fixed a lot of compilation warnings, also fixed some errors which actually
   could cause a segfault when running in a high debug level
 * Was not always sending the X-Features were it actually should, fixed.

# v 0.93   2003.11.02  [stable]

- GTK-Gnutella now support both Partial File serving, as a client as well
  as a server. As soon as a download is started, can be used as an alternate 
  source for others even though the download is not completed yet.
- When a mismatch happens during downloading the file can now be automatically
  removed and restarted again. 
- Improved GUI to specify better which downloads should be cleared from the 
  list (completed, failed, unavailable)
- Collects alternate download locations aquired from query hits.
- Support for hostname instead of only an ip. If you have a dynamic ip
  but got a static hostname, for example a .dyndns.org address, gtk-gnutella
  can try to connect to the ip associated with the hostname.
- Sends out alternate locations which should not be tried.
- Won't send full headers when short on bandwith.
- Any changes in settings are now automatically saved, there is no need to quit
  the client anymore to make sure the settings are saved.
- Running gtk-gnutella in Auto peermode should no longer cause a crash.
- New addresses in hostiles.txt to protected against malicious hosts.
- gwcache.boot was cleaned up. Dead links were removed.
- Remote control should actually work without crashing gtk-gnutella.
- The build problems which occured in 0.92.1 due to the switch to metaconfig
  should be (mostly) gone. 
- Code cleanup to build on more platforms.
- GTK2 interface currently does not have a maintainer, not all options which
  are available in the GTK1 interface might have made it in the GTK2 interface.

- (2003.11.02 - RAM)
 * Added the concept of "established" Gnutella connection: don't relay
   Gnutella traffic to non-established connections.  A connection becomes
   established when we receive traffic or got the 3rd handshake.
 * Don't forget a cache URL when it reports an ERROR: can be a transient
   problem.
 * Don't mark node as bad when an EOF condition occurs but the Gnutella
   connection is not "established".  It could be the result of a timeout
   on the other end, and without an established connection, no BYE is
   possible.

- (2003.11.01 - RAM)
 * Account for BearShare 4.3.x no longer sending the X-Ultrapeer to signal
   Ultrapeer status but relies on X-Ultrapeer-Needed instead.
 * Cleanly deny the connection to Ultrapeers requesting us to become a leaf
   when we cannot be demoted.
 * Do not send "alive" pings if we've been receiving data from the remote
   node recently.
 * Take into account the last ping round-trip time for spacing out our pings.
 * Fixed getting of GUI colors in search: is done differently for GTK1/GTK2.
 * Remove bad URLs from the Gnutella web cache as soon as we encounter them.

- (2003.11.01 - Jeroen)
 * Now sends the X-Nalt header with sources that should not be tried.
   GTKG won't parse and use it though.
 * Intergrated patch from Clayton. Which adds PFS configuration options
   in GTK2 too.
 * X-Features now sends all features, won't skip the last feature anymore

- (2003.10.31 - RAM)
 * Disable non-passive searches that became full (max configured amount
   of result displayed).
 * Let the GUI side tell the core side how much items were found and are
   still listed in the search window.
 * Added a bunch of new addresses to hostiles.txt, collected from a
   .htaccess and converted to our format.

- (2003.10.31 - Jeroen)
 * Added support for X-Features header parsing.
 * Added support for X-Features generation.
 * PARQ now also accepts the X-Features: Queue/1.0 as a queue enabled indicator
 * PARQ now also emits queuing capabilities in the X-Features header.
 * Don't add the X-Features header when the header would be empty

- (2003.10.29 - RAM)
 * No longer emit the X-Try header during Gnutella handshaking unless we're
   runnning in normal (legacy) mode.
 * Changed the way the `fi_by_namesize' hash is handled: we non longer keep
   one alias per (name, size) tuple but a list of them.  This avoids dropping
   alternate names between different fileinfo for the "same" file (albeit
   bearing disctint SHA1).  Non-SHA1 matching of query hits will now autoselect
   an entry for downloading only if there is one known entry by (name, size).
 * When a download is done, try to rename it using one of the non URN-like
   aliases we have for it.

- (2003.10.29 - Jeroen)
 * Fixed some inconsistent code. This should make the code even more
   portable

- (2003.10.28 - RAM)
 * When checking for an up-to-date SHA1 in a partial file, don't bother
   verifying whether the file is still present on the disk.
 * Got rid of obsolete file_info_filesize() routine.
 * Added file_info_has_trailer() to check whether a file has a trailer,
   indicating it is being downloaded but still incomplete.
 * Don't share partial files, even if the "tmp" directory is shared.

- (2003.10.27 - RAM)
 * Handle '_' as a space in looks_like_urn().
 * The download pane will now try to show a non-URN alias for filename.
 * Must reparent all downloads to common server when there is an IP conflict
   due to DNS resolution of the server name.

- (2003.10.26 - RAM)
 * Fixed async DNS resolution to behave properly when pipe with ADNS fills up.
 * When creating downloads, one can optionally supply a hostname as well.
 * New servent code "FEVR" for FileFever.
 * Added support for symbolic hostname in downloads.
 * Added parsing support for new GGEP "HNAME" extension.
 * Generate the GGEP "HNAME" extension in our query hits, if possible.
 * New properties "server_hostname" and "give_server_hostname" controlling
   the setup and the advertising of the server's hostname.
 * Added generation of the X-Hostname header.
 * Added parsing of the HNAME extension in query hits.
 * Added socket_bad_hostname().
 * Return the X-Hostname to uploaders if possible.
 * Display hostname when known for downloads.
 * [GTK1] Added configuration of the server's hostname.
 * [GTK1] Display hostname when known in searches.

- (2003.10.25 - Jeroen)
 * Don't allow removing a download for which a background task is active. EG,
   while verifying an SHA1 hash.
 * Remove file on mismatch option is now also available for GTK2

- (2003.10.21 - Jeroen)
 * Intergrated patch from Thadeu Lima de Souza Cascardo. This fixes a segfault
   with remote control.
 * Leaf, normal, ultra node counters are now updated as soon as the connection
   was established. This should avoid an assert when changing modes while still
   in handshake. 

- (2003.10.19 - RAM)
 * Rotate sources in bandwidth scheduler at each timeslice, since apparently
   the order used to insert them as I/O callbacks determines the order with
   which glib calls us back when they trigger.

- (2003.10.18 - RAM)
 * [GTK1] Added GUI configuration for server-side PFSP.
 * Trace amount of bytes in HTTP requests and replies.
 * Improved limitation of HTTP replies: now based on the error code with
   explicit sizing of the header and with flag propagation to callbacks, to
   tell them more about the context of the reply they're generating.
 * Refactored the gtk_gnutealla_exit() destruction order to avoid assertion
   failures in GUI code.
 * Moved some PARQ constants to parq.h.
 * More carefully control the generation of the PARQ headers depending on
   the callback flags.
 * Keep information about the mesh information being sent to uploaders for
   a longer period, to better accomodate with PARQ's long retry timeouts.
 * Added more stringent size control on the generated headers in replies.

- (2003.10.13 - RAM)
 * Fixed file_info_available_ranges() to avoid assertion failure at the end.
 * Detect and ignore exact duplicate entries in the hostiles.txt file.
 * Because of PFSP-server, we can get our own alt-locs back: make sure we
   don't try to download a partial file from oursevelves!
 * Added ip2_to_gchar() in case we want to format two IPs in the same printf.
 * Bearshare changed its vendor tag to "BARE" in query hits.
 * Re-organized gtk_gnutella_exit() to perform only minimal activities
   when being called from atexit().

- (2003.10.12 - RAM)
 * Added file_info_readable_filename() to get a meaningful name for uploads
   related to partial files, and not an URN if possible.
 * Now remember explicitly when list_clone_shift() was called and cloned,
   to avoid problems with the list changing underneath.
 * Removed assertions when re-reading fileinfo trailer: they could be harmful
   when the trailer is inconsistent / corrupted.
 * In the upload pane, prefix the Range column with a '*' when dealing with
   a partial file.
 * Remember the time when we rewrite the properties to disk, to avoid spurious
   warning about the file having changed whilst we were running.
 * Fixed `running_uploads' counting when waiting for follow-up request after
   an "unavailable range" error: decrement it before waiting, since we don't
   even know whether there will be a follow-up at all!
 * When unlinking or resetting a fileinfo, kill all uploads targeted to it.
 * When outgoing bandwidth is saturated, limit the size of the HTTP replies
   we make, or the size of our HTTP requests.  This includes emitting shorter
   version strings, less alternate locations, etc...

- (2003.10.12 - Jeroen)
 * Intergrated patch from Richard Hyde which implements the Purge button for
   the gtk2 interface.

- (2003.10.11 - RAM)
 [This batch of changes implements server-side PFSP]
 * Add ourselves to the sent alternate locations when server-side PFSP is on
   and we have some data for a partially downloaded file.
 * Tell the mesh to include ourselves in the alternate locations when
   downloading a file for which we have data (PFSP).
 * Adapted the "shared file" structure and the lookup routines to handle
   partially downloaded files: a fileinfo can now contain a "shared file" and
   the "shared file" is marked as being partial by referencing its associated
   fileinfo.
 * New upload state GTA_UL_PFSP_WAITING entered when they request an
   unavailable range and we give them one more chance to get a correct chunk
   by retrying on the kept-alive connection.
 * Emit header continuations with leading "\t" instead of 4 spaces.
 * Raised HTTP reply size to 2.5K to give room to available ranges.
 * Don't ignore files for which shared_file_by_sha1() returns something but
   which are actually partial files.
 * Remember in each upload whether the previous request was for an unavailable
   range.
 * Return a 416 to uploaders requesting an unavailable range, keeping the
   connection alive to give them a chance to re-request the proper range
   immediately without loosing the connection.

- (2003.10.06 - RAM)
 * The property system now remembers when a saved property is changed, and
   supports a new prop_save_to_file_if_dirty() call that will perform a
   save only if a saved property changed since last flush to disk.
 * Added lazy property saving to the slow main timer.
 * Added atexit() hook to allow GTKG to cleanup properly when a library
   calls exit() directly, especially when the connection with X is lost.
 * Now uses GGEP "ALT" to provide known alternate locations in query hits.
 * Terminate connection when peermode changed during handshaking, using
   a BYE message with code 504.  This race condition is rare enough to not
   warrant recovery (fixes bug #799675).

- (2003.10.05 - RAM)
 * Added parsing of new compact X-Alt header and generation of that new header
   to servents who have shown support for it.
 * Added collecting of alternate locations on HTTP 416 replies.
 * Fixed update of the dl_byte_count/ul_byte_count properties (now a guint64).
 * Now passes vendor string to alt-loc collection routine so that we can
   record who supports X-Alt and who doesn't.
 * Suppressed range header parsing warnings when not debugging.
 * Now look at X-Alt when collecting alternate locations and record vendors
   known to support that new compact form.
 * Skip leading whitespaces when parsing IP address.
 * Don't hardwire 6346 as default port, use the new GTA_PORT definition.
 * Added version_newer() to check for GTKG versions being newer than a date.
 * Assume all GTKG versions newer than 05/10/2003 support X-Alt even if we
   have never seen an X-Alt from them.

- (2003.10.05 - Jeroen)
 * Closed bug [ 790622 ] change "fuzzy filter" tooltip contents. The tooltip
   was: "... Thepurpose of this filtering..." which should be ".... The 
   purpose of this filtering..."

- (2003.10.04 - Jeroen)
 * Closed bug #784574 Transferred files byte counter rollover. Transfer counter
   is now a 64 bit counter.
 * Added GUIN64 to the props.tpl and corresponding files.
 
- (2003.10.03 - Jeroen)
 * Don't assert when u->name == NULL. EG, when a file is not found

- (2003.10.02 - Jeroen)
 * Added extra assertions to parq to verify u->name != NULL. Trying to track
   a porting problem

- (2003.09.11 - RAM)
 * My farewell to gtk-gnutella...  Appointed Jeroen as new leader.
 * No longer aborts downloads when we can't write data to disk: requeue them
   with the "busy" retry delay.
 * Fixed definition of QUERY_SPEED flags to match LimeWire's interpretation.
   When they talk about bit #15, it's the bit on the wire, but since the
   field is little-endiant, that's really bit #7 in the definition.
 * New "dl_remove_file_on_mismatch" property to request file removal when
   there is a resuming mismatch for a download.
 * [GTK1] Added a "remove file on mismatch" checkbutton in download pane.

- (2003.08.26 - RAM)
 * Optimized file_info_update() to not call file_info_merge_adjacent()
   systematically.  It now also behaves more efficiently for the common
   case where we append new data to an already "done" chunk.

- (2003.08.20 - RAM)
 * Had forgotten to fix IP endianess issues in filter_gui.c.

- (2003.08.19 - RAM)
 * Escape leading '.' in filenames as '_' to avoid downloading "hidden" files.
 * Flag aborted downloads with server unavailable as "Aborted (Server down)".
 * When removing downloads from a peer that is unavailable, flag all those
   downloads as unavailable as well.
 * Fixed endless "Request" -> "Sinking" -> "Request" cycle.
 * Changed jmake so that all install directories are made if they don't exist.
 * Regenerated Configure with newer units.
 * Fixed wrong Configure flags in gtk-gnutella_spec.SH.
 * Configure will now ignore your xgettext if it does not support --from-code.

- (2003.08.16 - Jeroen)
 * PARQ: Update all IP / Port info for all PARQ entries for this servent
   when a servent sends his new IP / Port.
 
- (2003.08.16 - RAM)
 * Updated metaconfig so that the generated config.h can compile properly
   with the broken gcc 3.x pre-processor.
 * Added size of arrays in external declations from gnet_stats_gui_common.h.
 * [GTK1] Added new download auto-clear option: unavailable downloads only.
 * New property "autoclear_unavailable_downloads" to clear unavailble
   downloads only.  TRUE by default.
 * Renamed "Clear completed" button as "Clear stopped".
 * All downloads that timeout or for which the push route is lost are
   stopped via download_unavailable().

- (2003.08.15 - RAM)
 * Moved the manual page from debian/ to src/.
 * [GTK1] Added display of the amount of fileinfo entries, and which have
   sources in the Fileinfo pane.
 * New properties "fi_all_count" and "fi_with_source_count".
 * Count all fileinfo, and those with sources.
 * Factorized "Malformed SHA1 query" and "Query hit had bad SHA1" statistics
   into "Malformed SHA1 message", since we keep track of message types.
 * Renamed "Malformed UFT-8 query" into "Message with malformed UTF-8".

# v 0.92.1 2003.08.20 [stable]

These are some of the changes made since 0.92 stable:

 * Support for push proxies was added which reduces problems with
   firewalled servents.
 * Support for pre-0.90 configuration files has been dropped.
 * Improved PARQ and fixed some problems with it.
 * The default directories for downloads are now set to $HOME.
 * A lot of minor bugfixes and code clean-ups so that it compiles on
   even more platforms and with other (C99) compilers.
 * GTKG can now monitor unstable IP addresses and unstable servents, to
   avoid keeping connecting to bad nodes.
 * The download pane now shows how many items are actively and passively
   queued.
 * The search pane allows one to hide hits that are either ignored or
   which have been already queued up by the core due to a matching SHA1
   or filename.
 * The "Purge" button could be hidden due to long filenames (#770625).
 * A duplicate free() problem was fixed in _search_send_packet() (#706014).
 * The "Purge" button doesn't cause crashes any longer (#757276).
 * The bug which could cause a crash when resuming a download was fixed
   (#739262).

The following changes affect only the GTK+ 2.x front-end:

 * XFT support is not turned off by default.
 * The node and the uploads panel have been tuned (a little).
 * No more crashes if the uploads are sorted by status.
 * Non-UTF-8 encoded strings were passed to GTK+ 2.x causing warnings
   (#769342).

The following changes affect the build system:

 * Switched to metaconfig, and abandonned autoconf/automake.  There may
   be some portability issues introduced on non-linux system since there
   are lots of new metaconfig units that had to be developped for the
   configuration of GTKG.  In the long run, it will catch up.
 * The "intl" directory containing GNU gettext() is no longer supported,
   because it is currently only configurable via autoconf.  If you don't
   have proper GNU gettext() support on your system, you might have to
   disable NLS support to be able to compile.

- (2003.08.10 - RAM)
 * Replacement inet_aton() was using same parameter and local variable names.
 * [GTK2] Integrated GUI update from Andrew Barnert, propagating changes
   made to the GTK1 interface.

- (2003.08.09 - RAM)
 * Switched to metaconfig.

- (2003.08.08 - RAM)
 * [GTK1] Renamed "Abort all from host" as "Forget all from host" since we're
   no longer paying attention to the "delete file on abort" setting here.
 * Was unduly removing downloaded files when removing all queued download from
   a host on timeout when they had "delete file in abort" turned on.
 * Allow them to abort/forget a download when it is in "Sinking" mode.
 * Moved GUI callbacks for upload stats to new upload_stats_cb.c.
 * Fixed config_comment() to have readable and nicely-formatted comments.
 * Updated the French translations.
 * [GTK1] Changed label to "Report an upload connection speed of" to avoid
   confusion on asymetric lines.
 * [GTK2] Applied Emile le Vivre's update.
 * Applied update from Stephane Corbe and reran autogen.sh.
 * Added 64.15.0.0/255.255.0.0 to the list of hostile IPs.
 * Manually patched generated po/Makefile.in.in and Makefile.am because of
   crappy auto* tools: it would not build on my machine, yet those files
   were generated/updated!

- (2003.08.07 - RAM)
 * [GTK2] Integrated Emile le Vivre's patch adding support for the two
   "node_monitor_unstable_ip" and "node_monitor_unstable_servents" properties.
 * [GTK1] Added GUI configuration for "checkbutton_auto_feed_dmesh" and
   "checkbutton_fuzzy_filter_dmesh" in the Config/Downloads pane.
 * [GTK1] Reworded text for the checkbox controlling "auto_download_identical".
 * When they don't monitor unstable IPs, gray out monitoring of unstable
   servents in the GUI.

- (2003.08.06 - RAM)
 * Count actively and passively queued downloads.
 * [GTK1] Display actively and passively queued downloads.
 * Obsoleted "mark_ignored": only retained for GTK2, and replaced with
   "search_handle_ignored_files" for GTK1.
 * Can now prevent display of search results that will be ignored.
 * [GTK1] New combo to handle ignored files: 3 choices: display / mark / skip.
 * Also consider 172.31/12 as a private IP range, and 255/8 as unroutable,
   instead of just 255.255.255/24.
 * Ooops -- 172.31/12 does not exist as a defined private IP range!

- (2003.08.05 - RAM)
 * Forgot to customize the HTTP async layer when we're using the IP
   swapping hack for client-side push proxy.
 * After having swapped the IP, reswap it back before reporting failure to the
   download layer.
 * Don't display negative uptimes, force 0.
 * When computing the remote node's uptime, use our clock offset to correct
   the remote timestamp.
 * Default for "nodes_monitor_unstable_servents" is now FALSE.
 * [GTK1] Turned on gettext support in glade.
 * [GTK1] Added GUI settings for the "node_monitor_unstable_ip" and
   "node_monitor_unstable_servents" properties in the Gnutella config pane.
 * [GTK1] New "Hide downloaded files" setting in Search to control display
   of entries that were auto-downloaded already.
 * New "search_hide_downloaded" GUI property.
 * Don't show them auto-downloaded files if they don't want to see them.
 * Plugged the necessary tieing update logic for the update of the three
   new checkboxes.

- (2003.08.04 - Jeroen)
 * 'Banning' of unstable servents and IPs is optional now using the
   node_monitor_unstable_ip and node_monitor_unstable_servents config
   settings which defaults to TRUE. node_monitor_unstable_servents
   won't work when node_monitor_unstable_ip is disabled though.

- (2003.08.04 - RAM)
 * Made a distinction between "connection timeout" and "data timeout" for
   asynchronous HTTP requests.
 * More endianness IP fixes.
 * If we can't connect to a push-proxy, try swapping the IP as a temp hack.
   (legacy servents were sending the IP in little-endian form in GGEP "PUSH".)

- (2003.08.03 - RAM)
 * Only compute the "escaped filename" for downloads once, not at every
   saving of the download queue.
 * Added two new properties: "node_monitor_unstable_ip" and
  "node_monitor_unstable_servents".
 * Forgot one more instance where writing of IP address was incorrect (the
   IP in the GGEP "PUSH" extension).
 * Reverted Christian's optimization of timestamp emitting on log messages:
   now always emit the timestamp on messages, otherwise it is a major pain
   when grepping through logs and trying to correlate events, or simply
   whem montitoring a logfile via "tail -f log | grep pattern".
   [Fixes bug #778183]
 * Fixed query_make_word_vec(), changed by Christian to make the first
   argument a const: it was not filling the vector at all when there was
   only one word in the query.
 * Now tells them exactly why they were denied a Gnet connection.
 * Fixed computation order for bw_max to avoid integer overflow.
 * Added url_params_xxx() routines to get parameters in URL query strings.
 * Added support for the "file=" parameter in push-proxies.
 * Removed all the code that dealt with legacy 0.4 servents.
 * Now that 0.4 support is gone, there cannot be any "ponging" connection.
 * Editing pane for filtering "flags" rules had fixed hardwired values for
   the "Mark only" and "Active" checkboxes instead of the current rule's ones.

- (2003.08.02 - Jeroen)
 * PARQ was banning an IP pernamently instead of max 20 minutes.
 
- (2003.08.02 - RAM)
 * Rolled back invalid change wrt reading/writing of IP addresses from/to Gnet.
 * Added magic number at the head of the cproxy structure.
 * Was writing the IP addess in LIME/22v2 as a 16-bit quantity!

- (2003.08.01 - Jeroen)
 * When an IP got banned by PARQ, it won't be added to the upload
   list anymore

- (2003.07.30 - Jeroen)
 * PARQ will now treat servents which do not honour the Retry-After header
   as hosts which are hammering the connection

- (2003.07.29 - Jeroen)
 * Increased dbg level for ultrapeer client/ip 'banning'

- (2003.07.27 - Jeroen)
 * Downloads through a push proxy should no longer crash gtkg due to 
   download_clone

- (2003.07.22 - Jeroen)
 * Fixed path array in gwebcache.c when in unstable mode.

- (2003.07.21 - guruz)
 * Added giFT vendor code

- (2003.07.20 - Jeroen)
 * Try to avoid to connect to unstable ultrapeer hosts. An ultrapeer
   is marked unstable when we are unable to connect to it for more
   than 2 hours
 * Initial import of tigertree source code.
 
# v 0.92.1c 2003.06.20 [candidate]

These are some of the changes made since 0.92 stable:

 * Support for push proxies was added which reduces problems with
   firewalled servents.
 * Support for pre-0.90 configuration files has been dropped.
 * Improved PARQ and fixed some problems with it.
 * The default directories for downloads are now set to $HOME.
 * A lot of minor bugfixes and code clean-ups so that it compiles on
   even more platforms and with other (C99) compilers.
 * The "Purge" button could be hidden due to long filenames (#770625).
 * A duplicate free() problem was fixed in _search_send_packet() (#706014).
 * The "Purge" button doesn't cause crashes any longer (#757276).
 * The bug which could cause a crash when resuming a download was fixed
   (#739262).

The following changes affect only the GTK+ 2.x front-end:

 * XFT support is not turned off by default.
 * The node and the uploads panel have been tuned (a little).
 * No more crashes if the uploads are sorted by status.
 * Non-UTF-8 encoded strings were passed to GTK+ 2.x causing warnings
   (#769342).

- (2003.07.19 - RAM)
 * Added server-side push-proxy support.
 * New routine base32_encode_str_into().
 * Added optional padding emission to base32_encode().
 * Factorized dl_request handling code into http.c, as http_buffer_t.
 * Fixed pushed download selection on GIV reception to also consider running
   downloads expecting a GIV when no exact fileindex is found.
 * Check for X-Push-Proxies lines in HTTP replies from firewalled hosts.
 * Allow http async users to customize the building of the HTTP request.
 * Now handles partial sending of the HTTP request for async http.
 * Added calls to pproxy_close() and pproxy_timer().
 * Fixed hex2dec() to report -1 on invalid hex char.
 * hex_to_guid() now returns boolean indicating proper decoding.
 * New guid_base32_str() and base32_to_guid() routines.
 * Added node_http_proxies_add() so we can send them our known push-proxies
   when we are firewalled.
 * Added paranoid sanity checks on reception of push-proxy request messages.
 * Added route_proxy_find() so that we can resolve push-proxy HTTP requests.
 * Added two new socket types: SOCK_TYPE_PPROXY and SOCK_TYPE_CPROXY.
 * Redirect incoming HTTP requests to /gnutella or /gnet to push-proxy.
 * Added upload_send_giv() to be able to send a GIV string directly.
 * Allow sending of push-proxy ACK (LIME/22v2) messages now that the
   server-side works and we can act as a push-proxy.
 * Replace all control characters in filename by '_'.
 * Added client-side push proxy support, with GUI feedback.
 * Added node_became_firewalled(), called whenever we are becoming firewalled
   to send push-proxy requests to non-leaf servents that we are connected to.
 * Made "data_ind" callback optional in HTTP aync.
 * Added message argument to the "header_ind" callback in HTTP async.
 * Added new optional callback to monitor HTTP async state changes.
 * Disable redirections by default, unless specified otherwise.
 * Added ip and port to http_async_get(), for when we know them.
 * Added new 'p' or 'P' node flag to indicate either our push-proxy or a
   node for which we are push-proxy, respectively.
 * Disabled broken equlity fix in qrp_step_compute(), pending later fix.
 * Now always send the GGEP "GTKGV1" in query hits, regardless of query sender.
 * Added sending of GGEP "PUSH" in query hits to list our push proxies.

- (2003.07.18 - RAM)
 * Always set QUERY_SPEED_NO_XML since GTKG does not parse XML in query hits.
 * Removed the "[No Push]" indication in download status: was misleading.
 * Added generic header formatting routines: header_fmt_xxx().
 * Rewrote formatted_connection_pongs() to use generic header_fmt_xxx().
 * Added state indication in HTTP async requests, for external monitoring.

- (2003.07.17 - RAM)
 * Reserved bit 10 of "min speed" for out-of-band reply delivery.
 * Added more debugging warning when parsing "ALT" in query hits.
 * Only open "u" in query hits if it looks like a sha1 or a bitprint URN.
 * Renamed alt_locs_t into host_vec_t and gnet_alt_locs_t into gnet_host_vec_t.
 * Added knowledge about the GGEP "PUSH" extension for push-proxy, and created
   new READ_GUINT16_BE() and WRITE_GUINT16_BE() supporting macros, required
   by "PUSH".
 * Changed signature of download_new() and download_auto_new() to include
   the known push proxies.
 * Moved search_gui_got_results() to search_gui_common.c
 * GUI now uses gnet_host_vec_t instead of host_vec_t: no need to make a
   particular data structure.
 * Result set now stores push-proxies given in query hit.
 * Finally, the IP is stored in big-endian within GGEP "PUSH".
 * Added logic for processing LIME/21v2 and LIME/22v2 messages (push proxy
   request and ack, respectively).
 * Heavy callback signature and message building refactoring in vmsg.c.
 * Can now send and receive LIME/21v2 and LIME/22v2.

- (2003.07.17 - Jeroen)
 * Made GtkG compile when xml was disabled

- (2003.07.16 - RAM)
 * Forgot to initialize `len' in dl_req_alloc().
 * Factorized common search GUI code to search_gui_common.c.
 * Moved type-specific GGEP extraction code to new ggep_type.c file.
 * New property "auto_feed_download_mesh", defaulting to TRUE, used to
   control whether we monitor query hits for alt-locs of files we are sharing
   or already have in our mesh.
 * Added read-only support for new GGEP "ALT" extension carrying alt-locs
   in query hit records.
 * Not only refuse to add private IPs in the mesh, also refuse multicast et al.
 * Factorized definition of blank_guid[] into guid.c.
 * Refactored checking of results set: moved file_info_check_results_set() and
   file_info_check_alt_locs() to search.c with proper name change.
 * Added indication of support of GGEP "H" in the "min speed" query field.
 * Will now reply with a GGEP "H" to servents that claim support for it.
 * Upgraded file_info_store() to use common file.c routines for saving.
 * Further factorized code into search_gui_common.c: search saving / restoring.
 * Rename XML searches as .orig before parsing.
 * Switched GGEP "H" support indication from bit 12 to bit 11, since bit 12
   is used for leaf-guided queries.
 * Handle retry-after time on a per-download basis, not only on a per-server
   one because of PARQ: we might need to retry one particular download earlier
   than the others queued on the same server.
 * The download "waiting" list is now sorted by increasing download retry time.
 * Processing of EXT_T_URN_BITPRINT in query hits was incorrect.
 * Added processing for GGEP "u" and "T" extensions in query hits.
 * Will now protect against a query hit record having several SHA1, to avoid
   memory leaks mainly.
 * Make a distinction between re-queuing a download that must not be
   rescheduled before some delay, and re-queuing a download from a host
   that is busy or is timeouting, in which case we want to hold further
   requests to that host.
 * Make sure to space requests to same host by 15 seconds or so.

- (2003.07.15 - Jeroen)
 * Made search_gui.c compilable again when xml was disabled

- (2003.07.15 - RAM)
 * Ran the new "fix_copyright" script to update all copyright notice dates.
 * Removed support for the loading of old (legacy) config files.

- (2003.07.14 - RAM)
 * Handle partial sending of the HTTP request, instead of stopping.
 * Fixed encoding of saved strings [Patch from Stephane Corbe, fixes #747501].

- (2003.07.13 - Jeroen)
 * PARQ won't assert on bad behaving clients anymore

- (2003.07.13 - RAM)
 * Fixed ban_record(): could be using the wrong callout queue callback.
 * Added ban_is_banned() to allow checking for the ban status without calling
   ban_allow() which is only supposed to be called on new connections.
 * When host refuses that we download from it, ban it for some time and kill
   all its pending uploads.
 * Don't send back QUEUE to a host that is banned.
 * Protect against subsequent ban_record() calls: free existing ban mesasge.

- (2003.07.12 - Jeroen)
 * PARQ doesn't like it when gets multiple requests for the same file from the
   same host while it is allready being upload to that host. Duplicate upload
   detection is now done before handing the upload over to PARQ.
 * PARQ now keeps track to an upload structure so it can look up information
   faster, as well as testing parq <-> upload integrity

- (2003.07.09 - Jeroen)
 * PARQ: Uploads->parq pointers were only assigned during parq_upload_create.
         Pointer is now also set when a existing parq upload is rerequested.
         Pointer is removed as soon as PARQ strucuture is freed.

- (2003.07.08 - RAM)
 * Call setlocale() and determine proper codeset [Path from Stephane Corbe].

- (2003.07.07 - Jeroen)
 * PARQ: Uploads contain a pointer to a parq structure now for fast lookups.

- (2003.07.06 - RAM)
 * Broadcast Push messages to all known routes to increase reception likelihood.
 * Double grace period when running in ultra mode: more connections to flush.
 * Added -mieee to the compile flags when building for Debian on Alpha
   [Patch from Christoph Reichenbach on Debian].
 * Raised default gnet connection timeout to 10 seconds.
 * Now fully supports special "min speed" field in queries.  The GUI min speed
   value as well as the default min speed are now ignored and should be removed.
 * We now have the IP address in version checks: log it when bad token is seen.
 * Added string evaluation code, that can evaluate ~/foo and $HOME or ${HOME}.
 * Added new generic prop_name() to convert a property into its name.
 * Property initialization strings are now run through eval_subst() to allow
   environment variables and ~ in their value.
 * Factorized setting callback for file path into one file_path_changed(),
   and added a verification callback for PROP_BAD_FILE_PATH.
 * Simplified debugging code to use new xxx_prop_name() calls.
 * File path properties have their default set to "~" instead of "/tmp".
 * Call locale_to_utf8() on filenames for GTK2 [Patch from Uriel].
 * Also "broadcast" our own Push requests if we have multiple routes.

- (2003.07.05 - RAM)
 * Parse all query hits for inclusion into the download mesh.
 * Don't activate the "no keepalive" flag on downloads if we detect that
   the server is performing some kind of "rotation" in the queue by closing
   our connection after having shrunk our request.
 * Prefix user-agent strings with a '*' when server appears to be banning us.
 * Only use an IP for clock skew computation once per 24 hours.
 * Apply queue regexp search to both download's filename and output filename
   [Patch #754923 from Stephane Corbe].
 * [GTK1] Print message in statusbar showing how many downloads were created
   from the many items selected.
 * Don't use GNU-isms for variadic macros, prefer the ANSI way
   [Patch #755639 from int_80h].
 * Avoid duplicate free in _search_send_packet() when empty word vector
   (fixes #706014).
 * Don't send queries unless there is a route for the possible replies.

- (2003.07.04 - RAM)
 * Added anti-403 "Network Disabled" code.
 * Don't insert alt-locs pointing to hostile IPs in the mesh.
 * Navigation pane updates correctly with 'jump to downloads' (fixes #612799
   and #629299) [From Emile le Vivre].
 * When banning due to vendor user-agent string, record the IP and forcefully
   ban it for 3 hours from then on, to defeat GTKG's own anti-banning code.

- (2003.07.03 - Jeroen)
 * PARQ: Should only actively queue one upload per ip

- (2003.07.01 - RAM)
 * Sort by size, then by SHA1 when sorting by size [From Thomas Schuerger].

- (2003.06.28 - RAM)
 * Added "torrent" to the default list of sharing extensions.

- (2003.06.25 - RAM)
 * Don't pick a suspended download in download_find_waiting_unparq().
 * Asserted that a verifying download must be in DL_LIST_STOPPED.
 * Mark fileinfo database as being dirty when a fileinfo is reset.
 * Code cleanup in parq.c.
 * Send blanked GUID in vendor messages that don't need a particular GUID.

- (2003.06.25 - Jeroen)
 * PARQ: QUEUE callback should now also 'help' activly queued downloads
		 (untested)

- (2003.06.24 - cbiere)
 * [GTK2] Re-worked removing of rows. Due to enabled sorting it seems to be
   possible that a list store contains the same row twice. I consider this
   a GTK+ bug, thus the changes are a bug workaround. The important part is
   setting the data column to NULL to prevent accessing already freed data.

- (2003.06.22 - Jeroen)
 * PARQ: Only sends one QUEUE command per IP at once. And aborts any other
		 pending QUEUE callback for that IP if the first one can't connect

- (2003.06.19 - RAM)
 * Optimized server banning test.
 * Don't send pong-cache pings on a flow-controlled connection.
 * Finished application of Angelo's symlink patch (fixes bug #756146).
 * Restored stripped out gtk_init(&argc, &argv) call (fixes bug #757504).
 * Moved verify_close() and move_close() calls before main_gui_shutdown()
   so that no ticks to the daemon thread be made whilst in shutdown!

- (2003.06.17 - Richard)
 * [Gtk2] No longer disable antialiasing. This confuses people who are 
   using Gtk2 and get font problems. If they want better performance, they
   should turn off AA manually using "export GDK_USE_XFT=0".
   (closes 754998).

- (2003.06.17 - RAM)
 * Now supports collection of multiple URNs from X-Gnutella-Content-URN,
   but still only look at ones containing a SHA1.
 * Use new dmesh_collect_sha1() to collect URNs.
 * Collect URNs from non-standard Shareaza X-Content-URN header.
 * When remote host turns out to be a genuine GTKG, stop anti-banning
   protection by faking a user-agent string, since we know the remote end
   won't be discriminating us.

# v 0.92   2003.06.15  [stable]

- Now supports Ultrapeers, which means GTKG can work as an ultra node or as
  a leaf node.  You can still run as a normal node, although this is not
  something wise to do, because that will likely relagate you in a small part
  of the Gnutella network.
- New icons for showing node state (leaf or ultra mode).
- The GTK2 front-end is no longer experimental, albeit it is slower than
  the GTK1.2 front-end.  This is due to the somewhat inefficient
  implementation of the underlying GTK library.  Don't use GTK2 unless you
  have the equivalent of a 1 GHz Intel chip.
- Added client-side PFSP support (partial file sharing). GTKG can download
  from servers holding partial files.
- Added full PARQ support (Passive / Active Remote Queuing), both for uplaod
  and downloads.
- New Gnet statistics: flow-controlled packets per TTL and hops.
- The "Type" column in the Gnet connection pane was turned into "Flags".
- Added support for GGEP in pings/pongs/pushes: those packets are now
  accepted and forwarded to connections advertising GGEP support.
- New "use surplus bandwidth" setting: all unused bandwidth for Gnet or HTTP
  can be stolen by the other in case it needs some.
- Added count for total bytes uploaded and downloaded.
- Added support for vendor-specific messages.
- New hops-flow support: remote flow-controlled connections can now warn us
  that thye are flow-controlling us, and so we can drop queries immediately
  instead of sending them, saving outgoing bandwidth.
- Will now show the GTKG version in query hits.
- The queue now shows the count of alive downloads, as well as the queue count.
  An "alive" download is an entry for which the remote server replies.
- Changed the connection algorithm: will now attempt to connect to more
  nodes than really configured, dropping the surplus connections later, when
  needed at all.
- Filters out hostile IP addresses.
- New "fileinfo" pane in the download screen.  Not finished, but will show
  the currently registered downloads and their status.
- Domain name resolution for Gnutella web cache are now done asynchronously.
  The GUI will no longer freeze due to a DNS request.
- Some performance improvements: removed the most important bottlenecks.

- (2003.06.14 - RAM)
 * Updated hostiles.txt to follow BearShare's modifications, and sorted it.
 * Forgot to mention PARQ id in header of persisted downloads.
 * Changed tooltip for "listen_port".
 * The new default listening port is now set to 8436 to avoid ISP censorship.
 * Fixed typo appereance -> appearance in GTK2.

- (2003.06.12 - Jeroen)
 * PARQ: Max uploads from single host is also detected and used in PARQ now.
 * PARQ: Timesout small upload chunks sooner now. This should make sure people
         who were unable to have all there upload slots used before, because
	 they were only sharing relative small and popular files, to maximize
	 their bandwith usage again if they want. This shouldn't affect PARQs 
	 behaviour for small files.
	 NOTE: This is:  #if 0 in the parq code, and thus actually disabled.
 * PARQ: No more assertion failure on gtk-gnutella shutdown (I hope)

- (2003.06.10 - RAM)
 * Don't send out an invalid IP/port in the X-Node header.
 * Integrated GTK2 icon patch [From Russell Francis].

- (2003.06.09 - RAM)
 * Raised default amount of downloads from 10 to 50.
 * Doubled max PARQ retry time, and lowered retry frequency for queued entries.
 * Fixed English: SHRINKED -> SHRUNK.
 * Avoid endless request/sinking loops: only allow one sinking per session.
 * Added some extra assertions in PARQ, little cleanup.

- (2003.06.09 - Jeroen)
 * PARQ: PARQ IP entries are now stored using their dotted notation.
 * PARQ: Fixed: Slots by IP didn't work yet
 * PARQ: Also preference by IP and not just by filename only. If client has
		 2 files A (pos 1) and B (pos 66) and it is requesting file B it will
		 still be allowed to upload. file A will have to wait for file B though.

- (2003.06.08 - Jeroen)
 * Prefer compressed connections should now also work in Ultrapeer mode
 * PARQ: Should not block anymore when a queued upload is not allowed to
		 continue due to 'max allowed uploads per ip'

- (2003.06.07 - RAM)
 * Decode base32 case-insensitively.
 * Fixed stupid memory leak: pmsg_free() called in a debug block.

- (2003.06.05 - RAM)
 * Don't parse incoming X-Node headers for PARQ if requestor did not advertise
   support for PARQ, since X-Node is not necessarily PARQ-specific.

- (2003.06.03 - RAM)
 * Append a trailing '-' in the download range size indication when the server
   is answering us with less data than we requested.  The amount shown then
   reflects what the server is giving.
 * Don't store downloads to disk every time we abort/stop one.  This should
   improve speed noticeably when aborting by SHA1 or by server!

- (2003.06.02 - Richard)
 * Applied symlink patch from Angelo Cano

- (2003.06.01 - RAM)
 * Fixed download_clone() to remap the parq ID to the children download.
 * Make sure to revitalize a stopped download upon receiving QUEUE.
 * Removed spurious trailing "\n" in warnings from parq.c.

- (2003.06.01 - Jeroen)
 * Uploads: HEAD requests won't be treated as a followup request anymore (which
            avoids an upload to ignore the max uploads per ip setting)
 * PARQ:    Fixed an assertion failure when an upload got removed due to too many
            disconnections

- (2003.05.29 - RAM)
 * Top makefile did not install "hostiles.txt".
 * Reset counter of QUEUE requests sent when remote servent replies to one.

# v 0.92   2003.05.25  [candidate]

Candidate 0.92 release.  The following are the main changes since 0.92b2:

- PARQ is now fully implemented.
- Filters out hostile IP addresses.
- New icons for showing node state (leaf or ultra mode).
- New "fileinfo" pane in the download screen.  Not finished, but will show
  the currently registered downloads and their status.
- Minor bugs fixed.

WARNING: Leaf node bandwidth is now stolen from HTTP when running in ultra
mode.  If that brings outgoing HTTP bandwidth to 0, sharing is disabled.

- (2003.05.25 - RAM)
 * Miscellaneous cleanup before release of 0.92c.
 * Now trace vendor string in the "Cancelling upload" messages.
 * Mentionned in GUI hints that number of PARQ queue is governed by the
   number of upload slots, and that it should be at least set to 2.
 * Tell them that when host runs NTP, the computed clock skew is ignored.
 * Display lifecount of the fileinfo, not its refcount [From Hans de Graaff].

- (2003.05.25 - Jeroen)
 * When in leaf mode: Prefer compressed connections is honoured again.

- (2003.05.24 - RAM)
 * Also package the pixmaps in the RPM [Patch #635484 from Sam Varshavchik].
 * Don't store download queue at each download inserted [Patch #699251 from
   Paul J. Mantyla].
 * When ignoring a download due to an hostile IP address, make sure we don't
   clear all the downloads for that file: it's just the server that we ignore,
   not the download entry.
 * Remember disabled searches when persisting (fixes bug #625314) [Patch
   #739466 from Stephane Corbe].
 * Increased max HTTP header size on reception to 16K.
 * Cleaned up patch from Stephane Corbe.
 * Added some assertions regarding fileinfo lifecount.
 * Try to report a more specific message to servents mis-handling Retry-After
   whilst passively queued.
 * Include vendor string in PARQ warning messages about early retries.

- (2003.05.24 - Jeroen)
 * PARQ: New ETA calculations. It now takes the current uploads into account too.
 * PARQ: Don't save PARQ entries from which the upload was finished.
 * PARQ: Avoid abusing: re-using the ID for another upload which got finished.
         (a client could keep an upload slot for eternity)
 
- (2003.05.23 - RAM)
 * Fixed punishing of hosts that re-request too early without paying attention
   to the Retry-After header.

- (2003.05.22 - Jeroen)
 * PARQ: A broken/disconnected upload can reclaim its queue position
 * PARQ: Upload pane now shows the Queue the current upload is queued in
 * PARQ: Dynamic upload slots also honours parq now.
 * PARQ: Fixed: No more infinite Waiting uploads.

- (2003.05.20 - Jeroen)
 * PARQ: Fixed: An upload can't get actively queued more than once at a time.

- (2003.05.19 - Jeroen)
 * PARQ: Shouldn't assert anymore when using dynamic slot allocations
 * PARQ: If a client does not obey the Retry-After header it will be
         removed from the PARQ queue.

- (2003.05.19 - RAM)
 * Forgot a "continue" statement in download_remove_file().
 * Likewise, on a file info change, don't requeue actively queued downloads
   or connecting ones.
 * Make sure the message queue kept track of the right amount of items.

- (2003.05.18 - RAM)
 * Added the @INTLLIBS@ macro in the linking flags for I18N
   [From Christian Biere].
 * Reset some fields to NULL in download_remove().
 * Must ignore downloads marked as GTA_DL_REMOVED when iterating on the
   download list.
 * Don't call download_free_removed() from fi_purge().  That call must be
   done asynchronously.
 * Changed status type in uploads to upload_stage_t.
 * Don't send the PARQ ID on 2xx for HEAD replies and follow-up requests.
 * Added extra pre-condition to fi_purge().

- (2003.05.17 - RAM)
 * Doubled half period for remote flow control computations to 5 minutes.
 * Don't requeue actively queued downloads or connecting ones when the
   underlying file is removed.
 * When a download has PARQ information, don't stop it when a write to the
   remote host fails, but requeue it instead.  Those downloads have a chance
   of being resumed.
 * Renamed download_free() into download_remove().
 * Clone lists before iterating in bg_close().
 * Reverted to using casts in clock_update().
 * Made clock_update() ignore the new timestamp if delta is within precision
   (making the ignore interval 2*precision instead of just precision).
 * Increased period for alive pings between ultrapeer and leaf to 120 seconds.
 * Flag when we send a QUEUE, and determine whether they refused our callback.
   After they refused it MAX_QUEUE_REFUSED times, we give up and never send
   them a QUEUE during this session.
 * Added parq_upload_add_header_id() to add an X-Queued header on 2xx replies.
 * Always call parq_upload_remove() from upload_remove().
 * Plugged call to parq_upload_add_header_id() to send queue ID on 2xx replies.
 * Renamed upload_push_conf() as upload_connect_conf().
 * Added call to parq_download_parse_queue_status() even on 2xx replies.
 * Call parq_upload_add_header_id() before upload_http_status() to avoid
   lacking room in the headers if alternate locations are present.
 * Remember when a PARQ id was sent, to avoid sending one back on 2xx replies.
 * Fixed assert failure in ban_force() when only 1 fd is used for banning.

- (2003.05.16 - RAM)
 * Limit clock skew to one day maximum: avoid badly synchronized remote clocks
   to let the skew deviate out of proportions.
 * Avoid issuing a connection to a node we're already connected to
   [From Rafael R. Reilova].
 * GTKG could loop in malloc(): block was freed twice in the case a config
   file was retrieved from the .orig version.
 * Ignore SIGQUIT in the adns process, so that CTRL-\ makes GTKG dump a core.
 * Must call parq_init() before retrieving the downloads now that PARQ IDs
   are stored.

- (2003.05.15 - RAM)
 * Allow server to give a smaller range than the one we're requesting.
 * Reject download when range end is greater than what we asked for.
 * Persist download PARQ ids.
 * Added download_find_waiting_unparq() to elect replacing download on QUEUE.
 * Fixed handling of QUEUE callbacks: was not parsing the ID correctly.
 * When looking up a PARQ download by ID, if we don't find one for the host,
   try to pick any non-PARQ waiting download for that host instead.
 * PARQ ids are now random GUIDs, tagged for GTKG.
 * Don't call file_info_update(DL_CHUNK_EMPTY) to clear the tail of a range.
   The routine is not prepared to handle that case.  As a workaround, 
   call file_info_clear_download() first, then file_info_update(DL_CHUNK_BUSY)
   on the complementary part.
 * New file_config_open_read_norename() to open config files that are never
   written, and which therefore don't need to be renamed as ".orig".
 * Fixed file_config_open_read() so that it displays "instead" when we open
   the ".orig" version.
 * Fixed file_info_update() so that it accepts DL_CHUNK_EMPTY on *whole* ranges.
 * Open hostiles and whitelist with new file_config_open_read_norename().

- (2003.05.15 - Jeroen)
 * PARQ: Don't display status Waiting when there are no upload slots available
 * PARQ: Send a QUEUE command when an upload slot is available
 
- (2003.05.14 - Jeroen)
 * PARQ: Saves and loads the expiration time of a queued upload. This should
         speed up starting uploading on startup.
 * PARQ: Fixed an assertion bug in upload_timer
 
- (2003.05.13 - RAM)
 * Avoid casting to (gint32), and use the "* (gint32*)" dereferencing trick.
 * In the download pane, display ETA for queued entries in a readable way.
 * Forgot to make a variable "static", causing endless promoting and demoting
   to/from ultra mode.
 * Fixed memory leak in sq.c, when query is ignored.

- (2003.05.12 - RAM)
 * Stopped removing half the slot contribution to writing b/w schedulers for
   all the slots that don't trigger.
 * Added missing RCSID to hostiles.c.

- (2003.05.12 - Jeroen)
 * PARQ: Fixed an assertion when connecting back to another IP than the IP
         the upload connected from.

-(2003.05.11 - Richard)
 * [Gtk1] Added clock skew to gui (calculation seems broken).
 * [Gtk1] Added PROP_RUNS_NTP to gui.
 * [Gtk1] Reordered connection settings in gnet pane.
 * [Gtk1] Updated list of contributors in about dialog.
 * Show all connection settings on gnet pane in leaf and ultra mode and hide
   ultrapeer setting in legacy mode.
 * Changed displayed info when failing to load config files.
 * Properly update PROP_CLOCK_SKEW instead of modifying the variable directly.

- (2003.05.11 - RAM)
 * Updated PARQ to revision 1.0.a of the specs.
 * Added flags to record whether a QUEUE is pending.
 * Try sending as many QUEUE messages as possible until we have 100 uploads.
 * Don't expire a PARQ entry if a QUEUE message is pending but was delayed
   because there are too many uploads running.
 * Exported download_redirect_to_server() for PARQ.
 * Send QUEUE messages spaced by at least 10 minutes for a given entry.
 * Give dead downloads a chance to come back to life by sending them QUEUE.

- (2003.05.10 - Jeroen)
 * PARQ: Displays retry time when queue slot is waiting for its upload slot
 * PARQ: Use uploads alive instead of queue size when displaying
         position out of <size>
 * PARQ: Only send QUEUE when library is not being rebuilt
	    
- (2003.05.10 - RAM)
 * Fixed "memory leak" in fileinfo_gui.c.
 * New -DTRACK_ZALLOC compilation switch that will track down the allocation
   points of all the zalloc blocks to display leaks at the end.
 * New properties "host_runs_ntp" and "clock_skew".
 * Will now try to automatically figure out the clock skew relative to GMT.
 * Use the Date: HTTP header as a source for clock skew computation.
 * Use token timestamps as another source for clock skew computation.
 * Trace Ultrapeer selection criteria for debugging.
 * Made sort order in the search pane persistent (fixes bug #557696) [From
   Emile le Vivre].
 * Was not using the forced 95% threshold for flow-control limits in leaf mode.

- (2003.05.09 - RAM)
 * Accidentally inverted condition for hostile checks on pongs: was dropping
   all the non-hostile pongs as being hostile!
 * Integrated PARQ patch #19 [From Jeroen Asselman].
 * Integrated PARQ patch #20 [From Jeroen Asselman].

- (2003.05.08 - RAM)
 * Added monitoring of average outgoing bandwidth.
 * Further tuned the bandwidth scheduler to maximize available bandwidth use.
 * Ultrapeer election now takes into account system params and bandwidth.
 * Don't further limit query propagation to leaves with no pending messages.
 * Integrated hostile IP parsing [From Markus Goetz].
 * Plugged dropping of connections and packets from/to hostile IP addresses.

- (2003.05.07 - Richard)
 * [Gtk1] Added "purge" button to fileinfo pane.
 * [Gtk1] Removed "sources" tab from fileinfo pane. This has not been used yet
   and will not be completed before the next release.
 * Export download_free_removed() so it can be used in fi_purge.
 * [Gtk1] Added tooltips to peermode icons.

- (2003.04.17 - RAM)
 * Integrated PARQ patch #15 [From Jeroen Asselman].
 * List PARQ development explicitly in the AUTHORS file.

- (2003.04.16 - RAM)
 * Added new "configured_peermode" property.  Old "current_peermode" is
   no longer persistent.
 * Leaf node bandwidth is now stolen from HTTP.  If that brings outgoing
   HTTP bandwidth to 0, sharing is disabled.
 * Reordered the computations in bsched.c: resort to early floating point
   division by 1000.0 then to multiplication to avoid overflowing integers.
 * Shut up compiler warning about uninitialized var in adns.c.
 * Removed "force_ultrapeer" and "force_leaf" properties.
 * Addded automatic promotion of leaf to Ultrapeer based on uptime (for now).
 * Don't send non-ultra pongs to leaf nodes.
 * Fixed memory leak in searches: limit MUID list to 4 per search.
 * Throttle leaf node pings to 60 seconds instead of the 3 seconds for others.
 * Adjusted bandwidth scheduler for low-activity sources.
 * Removed unused function on_the_net().
 * When switching to the "auto" configured peermode and there is no connection
   yet, force leaf mode as the current mode.

- (2003.04.13 - RAM)
 * Forgot to update node's timestamp after having sent the Gnutella hello.
 * Added files created by gettext for internationalization (i18n).
 * Integrated i18n patch [From Nicolas Lichtmaier].

- (2003.04.09 - RAM)
 * Be sure to requeue all active downloads that were referencing a file
   we are removing.
 * Make sure we're not over-querying new connections by limiting the amount
   of queries sent to the configured outdegree.
 * Propagate random unsollicited ultra pongs to leaf nodes.

- (2003.04.02 - RAM)
 * Added icon.xpm, the default gtk-gnutella icon for GTK1 [From Michael Gray].
 * Also remove all downloads from host when push route is lost, or when we
   can't reach a host through a direct connection.
 * Fixed icon.c to have it work with GTK 2.0 [From Michael Gray].
 * Avoid setting the IP ToS on a freed socket descriptor.

- (2003.03.31 - RAM)
 * Optimized sha1_eq() and guid_eq() when pointers are identical.
 * Added Retry-After header in parq_upload_add_header().
 * Be more stringent when generating the QRP table: no more than 1% full.
 * Integrated PARQ patch #14 [From Jeroen Asselman].
 * Integrated IP TOS patch [From Mike Mestnik].

- (2003.03.29 - Richard)
 * downloads.c:
   - Added some skeletons for having events on the downloads (sources).
   - Added handles to downloads.
 * downloads.c,downloads_cb.c,settings_gui.c:
   - download_clear_stopped can clear failed and/or completed downloads.
 * event.h: 
   - Typedefed frequency_t and event_t.
 * fileinfo.c: 
   - Put events into an array instead of keeping several event_t variables.
   - Removed event specific add/remove listeners functions and added 
     general fi_add/remove_listener() function. Event types are defined
     in gnet.h.
 * fileinfo_gui.c:
   - Correctly show when a file is finished.
   - Use generalized fi_add/remove_listener().
 * gnet.h: 
   - Added basic support for download/source related events.
   - Added event type enumeration for download/source related events.
   - Added event type enumeration for fileinfo related events.
 * oldconfig.c: 
   - Mapped old "clear_downloads" configuration variable to both new 
     PROP_AUTOCLEAR_*_DOWNLOADS properties.
 * settings_gui.c:
   - Fixed connection odometer in NODE_P_LEAF.
 * gnet properties:
   - Added PROP_AUTOCLEAR_COMPLETED_DOWNLOADS.
   - Added PROP_AUTOCLEAR_FAILED_DOWNLOADS.
   - Removed PROP_AUTOCLEAR_DOWNLOADS.
 * gui properties:
   - Added PROP_SHOW_DL_SETTINGS.
 * [Gtk1] gui modifications:
   - Download settings on download pane hidable.
   - Added detail panel to fileinfo pane.

- (2003.03.28 - RAM)
 * Integrated PARQ patch #13 [From Jeroen Asselman].
 * Abort all downloads from a host to which we can't connect.

- (2003.03.27 - RAM)
 * Added inclusion of <sys/time.h> before <sys/resource.h> for FreeBSD.
 * Added handle_to_queued() to verify the PARQ_UL_MAGIC magic whilst casting.

- (2003.03.26 - RAM)
 * Split parq_upload_request() into two to avoid assertion failures.
 * New parq_upload_get() call to return an opaque PARQ slot for uploads.
 * Moved down inclusion of "gnutella.h" to avoid warnings on MIN/MAX redefine.
 * Integrated PARQ patch #12 [From Jeroen Asselman].
 * Fixed function declarations to avoid compiler warnings in downloads.c.

- (2003.03.25 - RAM)
 * Fixed stupid trailing char truncation when quoting download mesh URLs.
 * Integrated icon patch #2 [From Michael Gray].
 * Added Jeroen Asselman to the glade file in the authors list.
 * Integrated PARQ patch #10 [From Jeroen Asselman].

- (2003.03.23 - Richard)
 * Regenerated configure and friends.
 * Fixed max-nodes calculation in the connection-odometer.
 * Missing ";" in misc.h broke compilation when HAVE_STRLCPY was not set.
 * Added means to fetch aliases of a file from fileinfo database.
 * Show aliases in fileinfo screen.
 * Added link between fileinfo and associated downloads (fi->dl).

- (2003.03.16 - RAM)
 * Regenerated configure and friends.
 * Integrated icon patch from Mike Gray.
 * Suppress error message from DNS helper upon final exit.
 * Make sure we don't try to parse ranges if the file size is zero bytes.
 * In leaf mode, allow flow control from ultrapeer up to 95% of the time.
 * Fixed flags display for nodes: was no longer showing 'I' or 'O'.
 * Adjusted bandwidth scheduler to limit starvation effects when we have
   a large amount of entries.

- (2003.03.11 - Richard)
 * Added possibility to tap into the fileinfo database from the gui.
 * [Gtk1] Added file info table to the downloads pane. This is not finished, 
   but already helpful.
 * Added download_restore_state() (seperated out from download_init())
 * Changed init sequence: first init gui, then read back downloads+fileinfo
 * Changed shutdown: first close downloads, then gui, then fileinfo
 * Introduced file_info_ref() and file_info_unref() to make it possible to
   watch for changes here and notify the gui.
 * Fixed: PROP_BAN_MAX_FDS not updated in gui

- (2003.03.09 - RAM)
 * Change web cache when an ERROR (HTTP or web cache) is reported.

- (2003.03.06 - Richard)
 * Fixed odometers (were all showing "in")
 * [Gtk1] Added odometers for leaf traffic
 * [Gtk1] Added 3 new icons to the gui
 * Fixed connections odometer for the different peermodes
 * Converted the *_LE and *_BE macros to glib style using G_STMT_START and
   G_STMT_END
 * Moved some gui code from downloads.c to downloads_gui.c

# v 0.92   2003.03.04  [beta2]

Bugfixing release:

- Fixed Gnutella web cache hammering.  A buggy test caused GTKG to query
  the caches each time it was establishing an outgoing connection!
- Domain name resolution for Gnutella web cache are now done asynchronously.
  The GUI will no longer freeze due to a DNS request.
- Some performance improvements: removed the most important bottlenecks.
- Fixed flow-control bug, exercised mainly with compressed connections: they
  could stall abruptly, no longer transmitting data.
- Fixed assertion failure in PARQ client code.
- Fixed incomplete clearing of downloads from a given host.

- (2003.03.04 - RAM)
 * Ban 0.92b as an hostile servent, due to its GWC hammering.
 * Only emit the exec() argument size warning if lib_debug.
 * Fixed version_tagcmp(): was not anti-symetric for 'b' and 'u'.

- (2003.03.03 - RAM)
 * Optimized guid_eq() and sha1_eq() to not call memcmp().
 * Rewrote the callout queue to have a more efficient ev_link() routine, the
   drawback being a slightly more costly cq_clock() call.
 * Fixed GWC hammering bug.
 * Avoid using / and % in macros from idtable.c.
 * Removed spurious trailing "\n" in some warnings.

- (2003.03.02 - cbiere)
 * [GTK2] gtk2-gnutella.glade:
    Added spinbutton_config_track_props (sync with GTK1)
    main_window_config_sel_tab: center contents
 * oldconfig.c/config_set_param(): Translate proxy_connections to
    proxy_protocol=PROXY_NONE from old config files
 * sockets.c/socket_connect_prepare():
    Moved ip parameter to socket_connect_finalize()
 * sockets.c/socket_connect_finalize():
    Fixed typo: addr <-> lcladdr
    Added another memset() to clear lcladdr
    Don't call socket_destroy() if the function was called from the
    ADNS callback which would cause a second socket_destroy() later
 * sockets.c/socket_connect_by_name_helper():
    Don't call socket_destroy() but set SOCK_ADNS_FAILED in case of an error
 * sockets.c/socket_connect_by_name():
    If the callback for adns_resolve was already invoked, check the status
    and call socket_destroy() in case of an error
 * sockets.h/struct gnutella_socket:
    Replaced `gboolean adns_pending' with `gint adns' as status variable
    Added `adns_msg' which should point to a static error message when
    SOCK_ADNS_FAILED is set, points to NULL otherwise
 * Removed all GDK legacy from core i.e., s/GDK_INPUT/INPUT_EVENT/ and
    no #include <gdk/gdk.h> any longer
 * Applied patch by Murphy <juncus@telus.net> which fixes typos in tooltips
 * nodes_cb(2).c: Added add_node_helper() for proper type translation
 * adns.c:
    Use adns_callback_t instead of a lazy gpointer
    Revised client-side to use non-blocking pipes which prevents
    deadlocks, allows partial transfers and to handle filled
    pipe buffers
 * adns.c/adns_resolve(): Returns FALSE if the resolution happened
    synchronous, otherwise returns TRUE.

- (2003.03.01 - RAM)
 * Show that we sent crawler info when remote disconnects after our reply.
 * Fixed assertion failure when parsing PARQ replies.
 * Added gm_setproctitle().
 * The ADNS subprocess will now be identified by "ps" as the "DNS helper".
 * Changed socket_timer() to avoid removing entries whilst iterating on list.
 * Special case the insertion to an empty array in qlink_insert().
 * Avoid uninitialized memory reads by bind(): zero the addr structs.
 * Forgot to free the list in socket_timer().

- (2003.02.28 - RAM)
 * The `dl_by_time' list was split into a hashed array, to cut down the number
   of item comparisons we do when inserting, at the cost of more work when
   traversing the list.
 * Optimized filter_apply() by pre-computing the length of the matching text
   at filter "compilation" time, to avoid endless strlen() calls.
 * Optimized search_has_muid(): sent MUIDs are now stored in a hash table.
 * Turned old g_return_if_fail() from legacy code into a g_assert() (tx_link.c).
 * Added some debugging traces whilst chasing the "connection freeze" problem
   (tx_deflate.c).
 * Fixed mq_service(): need to saturate the lower layer whilst running, lest
   we run the risk of never being called again when the lower layer has
   finished flushing its data => the TX side freezes.

- (2003.02.27 - RAM)
 * Optimized message queue to avoid huge CPU utilization during flow-control.
 * Optimized mq_service() to avoid useless I/O vector building.
 * Don't encode '/' in the query portion of URLs.

- (2003.02.27 - Richard)
 * event.[ch]: Added as a replacement for listener.h. For now it's used only
   in the property system. The bonus over listener.h: control of callback 
   frequency on a per-listener base.
 * Added seperate property to control debug level of the property system.
 * props.tpl: Upgraded to use event.[ch], regenerated property sources.
 * prop.[ch]: 
   - Upgraded to use event.[ch]
   - Added prop_get_by_name(): look up a property by name.
   - Added prop_to_string(): converting a property to string reprsenentation, 
     doesn't work for all property types yet.
 * settings_gui.c: Upgraded property_map to make use of the new frequency
   control feature of prop.[ch]
 * shell.c: 
   - No longer show auth cookie in debug output
   - New command: "PRINT [property]" to display current value of a property

- (2003.02.25 - RAM)
 * Added CRC32 code.
 * Fixed the base32/base64 code to correctly process padding, and return the
   amount of decoded bytes, padding not included.
 * Some servents send X-Try headers at every handshaking step, so process them.
 * Added token level.
 * Restored old ban_vendor() signature.

- (2003.02.23 - cbiere)
 * adns_do_transfer(): forgot to rename write to do_write
 * adns_gethostbyname(): use host_to_ip() instead of gethostbyname()
 * adns_callback(): remove the callback manually because the relay in
        inputevt.c doesn't propagate the return value;
    close() pipe if adns_do_read() fails
 * adns_init(): close() stdin and wire the file descriptor to /dev/null,
        just in case because it's shared with the main process;
    use _exit() instead of exit();
    close() all opened file descriptors in case fork() fails
 * adns_resolve(): close() pipe if adns_do_write() fails and don't retry
 * main(): ignore SIGINT and SIGPIPE before adns_init();
    use sig_ignore also for SIGXFSZ
 * host_to_ip(): declare hostname as const
 * upload_write(): Hide variable "pos" if HAVE_SENDFILE is undefined
 * adns.c:
        * Added caching; caching happens server-side, if the server dies
        * caching will be started client-side;
        * Fixed typo (children -> child);
        * Debug warnings depend on dbg > 1 or dbg > 2, now;
        * Declared larger variables as static;
        * adns_resolve(): usage of fallback is only reported once
 * [GTK2] locale_to_utf8: moved function from misc.[ch] to utf8.[ch]

- (2003.02.23 - RAM)
 * Forgot to negate the return of version_check().
 * Partially validate version whose token is given.
 * Avoid always polling at the minimum specified by the download server.
 * Applied Christian's patch fixing the type of gtk_tag and inputevt_add().
 * Forgot to use network order when writing token's timestamp.

- (2003.02.22 - guruz)
 * Added MLDonkey vendor code (MLDK)

- (2003.02.22 - cbiere)
 * The user_callback (parameter for adns_resolve()) was called twice if
   the hostname was an IP string; this caused s->gdk_tag != 0 in
   socket_connect_finalize() because it was called twice due to this bug.

- (2003.02.21 - cbiere)
 * Added socket_connect_prepare() to reduce double code
 * Added adns_pending to which indicates whether the adns callback has been
   invoked
 * Added socket type SOCK_TYPE_DESTROYING which is used free the socket after
   the adns callback has been invoked; prevents accessing already free()d
   memory.
 * Replaced assertion in socket_connect_finalize() because an event handler
   might have been installed while resolving the hostname; this is only a
   temporarily work around and not a solution!

- (2003.02.21 - RAM)
 * Integrated Christian Biere's ADNS patch (fixes bug #662916).
 * Now uses G_N_ELEMENTS() to determine the amount of items in array.
 * Added version tokens.

- (2003.02.17 - RAM)
 * Would not remove all the downloads from a given host sometimes.

- (2003.02.15 - RAM)
 * Associate download with move context early in case we cannot create the
   file on the filesystem: d_end() processing must still be able to run.

- (2003.02.11 - RAM)
 * Forgot to add the "sinking" state to the ESTABLISHING macro.
 * Don't lead them to the leaf status if we can't accept leaves.

# v 0.92   2003.02.08  [beta]

Highlight of changes (user-visible):

- Now supports Ultrapeers, which means GTKG can work as an ultra node or as
  a leaf node.  You can still run as a normal node, although this is not
  something wise to do, because that will likely relagate you in a small part
  of the Gnutella network.
- The GTK2 front-end is no longer experimental, albeit it is slower than
  the GTK1.2 front-end.  This is due to the somewhat inefficient
  implementation of the underlying GTK library.  Don't use GTK2 unless you
  have the equivalent of a 1 GHz Intel chip.
- Added client-side PFSP support (partial file sharing). GTKG can download
  from servers holding partial files.
- Added client-side PARQ support (Passive / Active Remote Queuing).  GTKG
  can now queue downloads from either active-queuing servers or PARQ.
- New Gnet statistics: flow-controlled packets per TTL and hops.
- The "Type" column in the Gnet connection pane was turned into "Flags".
- Added support for GGEP in pings/pongs/pushes: those packets are now
  accepted and forwarded to connections advertising GGEP support.
- New "use surplus bandwidth" setting: all unused bandwidth for Gnet or HTTP
  can be stolen by the other in case it needs some.
- Added count for total bytes uploaded and downloaded.
- Added support for vendor-specific messages.
- The "prefer compressed connections" settings no longer works as expected
  when running in non-normal mode.
- New hops-flow support: remote flow-controlled connections can now warn us
  that thye are flow-controlling us, and so we can drop queries immediately
  instead of sending them, saving outgoing bandwidth.
- Will now show the GTKG version in query hits.
- The queue now shows the count of alive downloads, as well as the queue count.
  An "alive" download is an entry for which the remote server replies.
- Changed the connection algorithm: will now attempt to connect to more
  nodes than really configured, dropping the surplus connections later, when
  needed at all.

WARNING:

- The amount of bandwidth configured for leaves is currently automatically
  added to the HTTP connections when not in leaf mode, regardless of whether
  "use surplus bandwidth" is activated.  This will change in the release.

- (2003.02.08 - RAM)
 * Fixed memory leak in gwcache.c.
 * Refactored upload_stats_dump_history(), and added upload_stats_close().
   Cleanup and dumping are now clearly separated.
 * Suppressed settings_upload_stats_save(): there is no an explicit call
   to upload_stats_close() done at exit time.
 * Be sure to call bsched_set_peermode() each time a bandwidth value is changed
   so that we can adjust the schedulers according to the current mode.
 * New FALSE default for the "fuzzy_filter_dmesh" property.
 * When downgrading from ultra to leaf mode due to peer request, be sure to
   use the property system to change the "current_peermode" property, instead
   of writing directly to the variable!
 * Make sure we react to the peermode change asynchronously.

- (2003.02.07 - RAM)
 * Fixed memory leaks in dmesh.c, fileinfo.c, qrp.c.
 * Allow user to abort actively-queued downloads.
 * Added upload_stats_free_all() to clean up memory on exit.
 * Fixed reading of free'd memory in mq.c.

- (2003.02.06 - RAM)
 * Had mistakenly added the "sinking" state to DOWNLOAD_IS_ACTIVE().
 * Prefix all warnings with a timestamp [From Christian Biere].

- (2003.02.05 - RAM)
 * Fixed dmesh fuzzy matching memory corruption.
 * Send PUSH messages at max TTL value, not my TTL in case it needs re-routing.
 * Added missing memory cleanup to shutdown calls, preventing leak detection.

- (2003.02.04 - RAM)
 * Abort download if handed out an URL that is too large (probably garbage).
 * Integrated fuzzy dmesh filtering for non-N2R entries [From Alex Bennee].
 * Shortened the string displayed for queued download entries.
 * New properties "pfsp_server", "pfsp_first_chunk" for PFSP (unused for now).
 * New property "fuzzy_filter_dmesh" to toggle fuzzy dmesh filtering.
 * Give unused reserved bandwidth for leaf nodes to HTTP traffic.
 * Integrated fix in get_header_value() [From Jeroen Asselman].

- (2003.02.03 - RAM)
 * Added inclusion of "common.h" for FreeBSD 4.7 (utf8.c).
 * Integrated PARQ patch: client-side is fully supported [From Jeroen Asselman].
 * Raised minimal query routing table size to 128 K slots, and lowered the
   sparseness and conflict ratios to check whether we can double the routing
   table size.

- (2003.02.02 - RAM)
 * No longer free remaining atoms in atom_warn_free(), for leak detectors.
 * When seeking to get the fileinfo trailer, don't use SEEK_END with a
   negative offset, but use SEEK_SET with an explicit positive value to
   avoid problems when off_t is 8-byte wide [From Christian Biere].
 * When doing SEEK_SET, check that lseek() returns the right offset.
 * Be sure to not truncate the headers for crawler replies in the middle
   of an IP address [From Christian Biere].
 * Fixed final cleanup in pcache.c to also discard the recent pong cache.
 * Changed freeing order for the existing query table when a RESET is received.
 * Protect against broken servents that don't send us QRP patches covering
   the whole query table.
 * Fixed memory leak on the query sending path in ultra mode.
 * Made sure `n' is no greater than INT_MAX for gm_*snprintf() calls.
 * Don't forget to reset str[0] to NUL in case we have to strlen(str) within
   the gm_*snprintf() calls.
 * First experimental support for PARQ (active queuing only, client-side)
   [From Jeroen Asselman].
 * Fixed parq_download_add_header(): now gets length of buffer explicitly.
 * Fixed status display for remotely queued entries.
 * Fixed get_header_value() to look for a ',' separator as well.

- (2003.02.01 - RAM)
 * Limit lifetime of download mesh entries to 1 day.
 * Added pre-condition to file_info_find_hole(): no busy chunks for download.
 * Forbid outgoing connections to a Gnutella crawler.
 * Apply vendor-specific banning early, so banned people know about it even
   if we're otherwise busy.
 * Limit the headers sent back to crawlers to the strict minimum.
 * Replaced all broken g_snprintf() and g_vsnprintf() calls by calls to
   fixed gm_snprintf() and gm_vsnprintf().  Broken calls are now forbidden.
 * configure now looks for vsnprintf() and defines HAVE_VSNPRINTF.

- (2003.02.01 - Richard)
 * [Gtk2] Reduced padding on uptime
 * [Gtk2] Added "edit filters" button back to search pane
 * Integrated patch by ko <junkpile@free.fr>:
   - shell.c: Remove unnecessary (GdkInputCondition cast)
   - gtk-missing.c: Optimize clist collect_data
   - gtk-missing.c: added tree_selection_collect_data
   - moved/renamed filter rule adding convenience functions from
     search_cb.c and search_cb2.c to filter.c
   - moved/renamed add_targetted_search from search_cb.c and search_cb2.c to
     gui.c
   - moved/renamed record comparing functions from search_cb.c and
     search_cb2.c to gui.c
 * Integrated patch by T'aZ <tazdev@altern.org>
   - search_cb.c, search_cb2.c: show "none auto selected" in the status bar 
     when no additional results were autoselected
     
- (2003.01.30 - RAM)
 * Immediately reset the qrt_ fields and query_table to NULL after having
   freed those items, to prevent accidental reuse.
 * Forgot to remove QRT patch compression task from the list of running tasks
   upon a cancel.
 * Clone directory list before traversing it with recurse_scan() since we
   loop back to the GUI and the directory list could be changed whilst the
   scanning is proceeding.
 * Suppressed warning about handle_messages_supported() not being done.
 * Removed spurious assert() in qrt_patch_computed_add_listener().
 * Added support for LimeWire's crawler.

- (2003.01.29 - RAM)
 * If downloaded filename is empty, use "noname" as the filename.
 * Forgot to test for swapped ranges in the trailing range listed.
 * Fixed bug when cancelling QRT computation due to rescanning.
 * Fixed another bug when cancelling QRT computation due to rescanning.
 * Tell whether we're an ultranode or not on handshaking errors.

- (2003.01.27 - RAM)
 * Will now show when a download is from a partial file, and how much of
   the total file the remote server has.
 * New http_range_size() routine.
 * Now makes sure ranges are well-specified before calling http_range_add().
 * Also detect overlapping with next range in list during http_range_add().
 * Changed detection place of so-called "gnutella2": will now abort earlier,
   without giving the chance for the remote ultranode to become a leaf.
 * Dynamic upload slot computation was not co-existing peacefully with
   the ability to steal bandwidth: now compare both instantaneous and average
   to the min usage percentage.
 * Handle only the very first range in upload requests, instead of replying 500.

- (2003.01.26 - RAM)
 * Added glib-missing routines.
 * New HTTP range parsing routines.
 * Range requests now handled through new HTTP parsing routines.
 * Don't add words less than QRP_MIN_WORD_LENGTH chars to the QRP vector.
 * Fixed RX flow-control ratio computation.
 * Don't accept nodes claiming so-called "gnutella2" support as peers.
 * Added support for client-side PFSP (Partial File Sharing Protocol).
 * New download state "sinking" when slurping HTTP reply between requests.

- (2003.01.24 - RAM)
 * Reworked the bandwidth stealing algorithm to behave less aggressively when
   the kernel flow-controls us on the way out.
 * Do not send out duplicate addresses in X-Try* headers.
 * Fixed `elapsed' to be a time_t instead of a guint32 (http.c).

- (2003.01.19 - RAM)
 * Must not free word vector if it was not allocated (matching.c).
 * Update node flags after the first handshake reply.
 * Only send about 50% of queries to flow-controlled leaf nodes.
 * Understand specially marked speed in queries, but do not emit them yet.
 * Warn users running an unstable version after 60 days, ban them after 90.
 * Was not emitting X-Try-Ultrapeers correctly.
 * New flag 'd' shown instead of 'F' when the queue is non-empty, to indicate
   that there is some delay in the packets sent.
 * Based on my experiments about the necessary bandwidth to run an Ultrapeer,
   changed the default amount of leaves to 15 and the minimum to 5.
 * Display max amount of leaves/ultra/nodes when rejecting connections.
 * Added necessary callback from mq.c to warn when queue count changes, so
   we can update the node's flag immediately.
 * Was not parsing version tag properly, and therefore started to ban recent
   stable GTKG versions.
 * Do not trigger "activity timeout" for leaf nodes.

- (2003.01.18 - RAM)
 * Added new properties: "bw_gnet_leaf_in_enabled", "bw_gnet_leaf_out_enabled",
   "bw_gnet_lin" and "bw_gnet_lout" to control leaf node bandwidth.
   Those are special: values configured are automatically added to Gnet
   bandwidth when not in ultra mode, regardless of whether the shaper is
   enabled.
 * Set decent default Gnutella bandwidths.
 * Added leaf bandwidth scheduler, that can steal bandwidth out of Gnet only.
 * Reordered creation of TX and RX stack so that the peermode is known.
 * Can now properly switch between all three modes (normal, leaf, ultra).
 * Upon mode change, reshape the Gnet bandwidth (leaf versus regular).
 * Added support for QRP infinity 1 to not rule out Shareaza.
 * Have the TX and RX link layers write/read using proper bandwidth scheduler.
 * Had inverted proportional bandwidth repartition computations.
 * Adjusted the bandwidth scheduling algorithm to behave a little better
   in the advent we lack bandwidth and lots of stealing occurs accross shapers.
 * No longer kills a connection when the send queue becomes full, unless
   the message was a prioritary one.
 * RX and TX stacks now provides access to the underlying link-level I/O source.
 * GUI now displays the node TX / RX speeds in k/s.
 * Leaf nodes have their send buffer shrank to as low as 256 bytes.
 * Doubled the time between two alive pings.
 * Don't route the query if the hashing vector is empty.
 * Don't send queries from the search queue on flow-controlled connections.

- (2003.01.18 - Richard)
 * [Gtk1] Added following props to gui:
   - PROP_SEARCH_MAX_RESULTS (search pane settings)
   - PROP_NODE_RX_FLOWC_RATIO (gnet config quality management)
   - PROP_NORMAL_CONNECTION (gnet config)

- (2003.01.17 - RAM)
 * Added routing of queries based on QRT.
 * Don't even try to insert in the search queue if hops-flow is set to 0.
 * Don't put leaf node's address in the hostcache for crawler pings.
 * Added highest_bit_set() routine.
 * Lowered the minimum amount of leaves from 50 to 25.
 * Refactored management of connections to be more aggressive when we
   lack nodes and avoid turning incoming connections down too early
   (closes 607268).
 * Don't ping leaf nodes to get pongs from them.
 * Avoid routing back a leaf node query to its sender.
 * Forgot to free word vector built for query routing purposes.
 * Fixed URL unescaping when given a truncated trailing escape sequence.

- (2003.01.14 - RAM)
 * New drop reason "Unexpected message".
 * New QRP Flag 'p' indicates ultrapeer receiving routing patch.
 * Fixed wrong QRP patch computation for leaf nodes.
 * Finalized reception of QRP patches and application to routing table.
 * Warn when receiving unknown vendor message, in debug mode.
 * Added QRP to the list of messages we "route", for routing tracing.
 * Do not drop routed TTL=0 messages whose target is a leaf node.
 * Drop leaf nodes that route messages.

- (2003.01.13 - cbiere)
 * [Gtk2] Set encoding for GIOChannels to NULL which is safe to use with 
   binary data

- (2003.01.12 - RAM)
 * Quote mesh URLs that contain the ',' character so other servents are
   not confused (GTKG does not need this).
 * Fixed skipping of trailing quote in URL parsing [From Alex Bennee].
 * New properties "normal_connections", "node_leaf_count", "node_normal_count"
   and "node_ultra_count".
 * The leaf node mode is no longer experimental, but Ultrapeer mode is.
 * Added Ultrapeer negotiation management (inter-ultra nodes and ultra / leaf).
 * Is now lenient about TTL=0 messages sent from ultrapeer to leaf.
 * Will ban ancient versions after 1 year only, instead of 1.5 years.
 * First take at QRP reception message management (partially done).

- (2003.01.11 - cbiere)
 * Fixed wrong date for ChangeLog
 * Tried to pop non-existent message from statusbar
 * [Gtk2] New locale_to_utf8: non-convertible characters are replaced by an
   underscore ('_')
 * [Gtk2] Downloads: Reenabled multi-selection
 * [Gtk2] Gnet stats: Save and restore column widths; use pretty alignments
 * [Gtk2] Nodes: Save and restore column widths
 * [Gtk2] Search results: Stop autoselecting during shutdown phase;
   Added status column; Sync column widths (still buggy but harmless);
   Use highlighting;
 * [Gtk2] Upload stats: Use custom CellDataFunc instead of invisible columns;
   prepared save/restore for column widths (not complete yet)

- (2003.01.11 - RAM)
 * New property "node_rx_flowc_ratio".
 * Make sure we're not remotely flow-controlled too often.
 * Replaced magical "7" with the new GTA_NORMAL_TTL constant.
 * New property "dl_qalive_count".
 * Downloads now update the "dl_qalive_count" to reflect the amount of
   sources that still reply to our requests.

- (2003.01.10 - RAM)
 * Was reading '*p' but could peruse 'c' instead (dmesh.c).
 * Generalized the use of walloc/wfree for small structures.
 * Try to allocate chunks of 4K at most for walloc(), or 8 objects at least.
 * Created new GTKG-specific GGEP extension "GTKGV1" to propagate version
   information and servent startup time in query hits.
 * Added inet_init() to ensure we have the no-connection timer set if we
   startup in non-firewalled mode.
 * Will now emit "GTKGV1" extensions in query hits when replying to a GTKG
   query, and display version information in search pane.
 * Exported version_str() for version string formatting.
 * Be sure to not call inet_firewalled() on first listening port change,
   i.e. when we read back the configuration file, or the persisted
   "is_firewalled" property will be ignored!

- (2003.01.08 - RAM)
 * Forgot to check for alternate locations on 503 replies.
 * Also compare SHA1 of requested files when checking for upload duplicates.

- (2003.01.05 - cbiere)
 * [Gtk2] gnutellaNet: Nodes can be removed manually    
 * [Gtk2] Enable proper sorting of upload stats by size and normalized
 * [Gtk2] reenabled "clear" buttons for caches
 * [Gtk2] Revisited code; removed unnecessary functions in search_{cb,gui}2.c
 * [Gtk2] removed unused variable 'error' in monitor_gui2.c
 * [Gtk2] locale_to_utf8: extended error message
 * Include version.h for version_is_too_old() in ban.c

- (2003.01.04 - RAM)
 * Had forgotten that we must "goto next" instead of "continue" in
   the URL parsing loop from dmesh_collect_locations().
 * Added argument to download_remove_file(), so that we can reset the fileinfo
   of manually removed files, in order to not discard the entry at the
   next startup.
 * Fixed hops-flow handling in mq_service(): was generating bad iovec entries
   for dropped messages!
 * Don't need to send the "Connect Back" message as a control message.
 * Seeing a vendor-specific message sets the NODE_A_CAN_VENDOR attribute as
   if we had seen a Vendor-Message header.
 * Drop ping/pongs/pushes that are smaller than their normal size.
 * Added support for initial advertising of supported vendor messages.
 * Count unhandled vendor-specific messages as being of an "unknown type".
 * Was wrongly putting a trailing 's' to the Vendor-Message header.

- (2003.01.03 - RAM)
 * Added support for vendor-specific messages.
